2002-12-03  Trey Matteson  <trey@apple.com>

	Re-fix of 3113393 - Clients side redirects shouldn't always add item to back/forward list
	Fix 3116980 - REGRESSION: Back button goes back twice
	Fix 3099631 - assertion failure at http://www.calendarlive.com/ when pop-up blocking is off

	The earlier fix for the first bug was to consider any redirect happening within one
	second as a continuation of the previous load.  To fix the regressions I re-cast that
	fix using a similar, pre-existing mechanism.

        Reviewed by: Richwill

        * WebView.subproj/WebFramePrivate.h:  Nuke shortRedirectComing, rename
	instantRedirectComing to quickRedirectComing.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _createOrUpdateItem]):  Remove code related to shortRedirectComing,
	the fix that brought the regressions.
        (-[WebFrame _setState:]):  Don't cache the page we're leaving if we're doing
	a redirect (since we don't want the redirecting page in the cache).
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]):  Above rename.
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):  Above rename.
        (-[WebFrame _loadURL:intoChild:]):  Comment fix.
        (-[WebFrame _clientRedirectedTo:delay:fireDate:]):  Use 1 second instead of 0
	seconds as the metric of a client redirect.  Do not consider whether the frame
	state is completed as part of the decision.
        (-[WebFrame _clientRedirectCancelled]):  Above rename.

2002-12-03  John Sullivan  <sullivan@apple.com>

        Reviewed by: Darin

	- REALLY changed the default state for block pop-ups to be off.

        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences load]):
	change default for letting JavaScript open windows automatically
	to YES

2002-12-03  Darin Adler  <darin@apple.com>

	- fixed 3117135 -- world leak: drag any image, get a leak of 1 WebFrame

        Reviewed by John.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]): Retain the URL of the dragged image, not the entire
	element dictionary. The element dictionary creates a reference cycle since it includes
	a reference to the WebFrame.
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]): Use the URL rather than
	extracting it from the dictionary with a WebElementImageURLKey.

        * WebView.subproj/WebHTMLViewPrivate.h: URL, not element dictionary.
        * WebView.subproj/WebHTMLViewPrivate.m: (-[WebHTMLViewPrivate dealloc]): Release the
	URL, not the element dictionary.

2002-12-03  Richard Williamson   <rjw@apple.com>

        Added a preference to change the page cache size, i.e.:
        Alexander.app/Contents/MacOS/Alexander -WebKitPageCacheSizePreferenceKey 4
        
        Reviewed by: hyatt

        * History.subproj/WebBackForwardList.m:
        (+[WebBackForwardList setPageCacheSize:]):
        (+[WebBackForwardList pageCacheSize]):
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences load]):
        (-[WebPreferences _initialTimedLayoutSize]):
        (-[WebPreferences _pageCacheSize]):
        * WebView.subproj/WebPreferencesPrivate.h:

2002-12-03  Richard Williamson   <rjw@apple.com>

        Fixed 3019986.  Use an array of font families instead of a single
        font family to support CSS family lists.
        r=hyatt
        
        * Misc.subproj/WebKitNSStringExtras.m:
        (-[NSString _web_widthForString:font:]):
        * Misc.subproj/WebStringTruncator.m:
        (+[WebStringTruncator rightTruncateString:toWidth:withFont:]):
        (+[WebStringTruncator centerTruncateString:toWidth:withFont:]):
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer substituteFontForString:families:]):
        (-[WebTextRenderer substituteFontForCharacters:length:families:]):
        (-[WebTextRenderer widthForCharacters:length:]):
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:letterSpacing:wordSpacing:fontFamilies:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:characterPosition:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:letterSpacing:wordSpacing:fontFamilies:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:fontFamilies:]):
        * WebCoreSupport.subproj/WebTextRendererFactory.h:
        * WebCoreSupport.subproj/WebTextRendererFactory.m:
        (-[WebTextRendererFactory fontWithFamilies:traits:size:]):
        (-[WebTextRendererFactory fontWithFamily:traits:size:]):
        (+[WebTextRendererFactory fallbackFontWithTraits:size:]):
        (-[WebTextRendererFactory cachedFontFromFamily:traits:size:]):
        (-[WebTextRendererFactory cachedFontFromFamilies:traits:size:]):
        (-[WebTextRendererFactory rendererWithFamilies:traits:size:]):

2002-12-03  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3115073 - REGRESSION: plants.com is crashing in WebIconDB with bad retain count

	The plants.com favicon was marked to be removed from disk and thus it had no retain count. The problem was that it was still on disk and _hasIconForIconURL would return YES. If hasIconForIconURL returns YES, its is ok to call  _setIconURL:forSiteURL:. Since there was no retain count, the assert in _setIconURL:forSiteURL: would be hit.

	We now consider icons without retain counts to not exist even if they're on disk.

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _updateFileDatabase]):
        (-[WebIconDatabase _setIconURL:forSiteURL:]):

2002-12-03  Chris Blumenberg  <cblu@apple.com>

	Fixed:
	3112477 - REGRESSION: dropping image within window loads image in current window
	Fix: Unregister the parent webview for dragging when the drag starts, reregister after the drag ends.

	3116423 - Dragged images sometimes have the wrong promised-file file type
	Fix: Make the - [NSView_web_dragPromisedImage...] method take a file type rather than deriving the file type from the URL

	3115768 - REGRESSION: contextual menu item "copy url to clipboard" doesn't work
	Fix: In [NSPastboard _web_writeURL:andTitle:withOwner:] adding pboard types  doesn't work for the general pasteboard, have to redeclare.

	3116594 - Image on the drag pasteboard shouldn't have applied transparency and scaling
	Fix: In - [NSView_web_dragPromisedImage...] put the original image on the pboard

	Reviewed by John.

        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeURL:andTitle:withOwner:]): don't use addTypes as it doesn't work as I expected
        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragPromisedImage:origin:URL:fileType:title:event:]): put the original image on the pboard, not the drag image
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]):
        (-[WebHTMLView mouseDragged:]): call _web_dragPromisedImage
        (-[WebHTMLView draggedImage:endedAt:operation:]): call -[WebView _reregisterDraggedTypes]
        * WebView.subproj/WebImageView.m:
        (-[WebImageView mouseDragged:]): call _web_dragPromisedImage
        (-[WebImageView draggedImage:endedAt:operation:]): call -[WebView _reregisterDraggedTypes]
        * WebView.subproj/WebView.m:
        (-[WebView initWithFrame:]): call _reregisterDraggedTypes
        (-[WebView draggingEntered:]): simplified, don't need to check drag source
        * WebView.subproj/WebViewPrivate.h:
        * WebView.subproj/WebViewPrivate.m:
        (-[WebView _reregisterDraggedTypes]):

2002-12-03  Darin Adler  <darin@apple.com>

	- fixed 3114796 -- WORLD LEAKS: 1 WebFrame leaked on trivial source file with <html> tag only
	(probably fixed a ton of other bugs too, since this always leaks)

	Reviewed by Chris.

        * WebView.subproj/WebHTMLViewPrivate.m: (-[WebHTMLView _elementAtPoint:]):
	Added a missing autorelease.

2002-12-03  Darin Adler  <darin@apple.com>

	Reviewed by Maciej.

        * WebView.subproj/WebView.m: Fixed a pair of strings that conflict.
        * English.lproj/Localizable.strings: Regenerated.
        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2002-12-02  Trey Matteson  <trey@apple.com>

	Refined bookmark notifications to be more detailed.  We now have added, removed,
	willChange and didChange.

        * Bookmarks.subproj/WebBookmarkGroup.h:   New API.
        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup _sendNotification:forBookmark:children:]):
        (-[WebBookmarkGroup _setTopBookmark:]):
        (-[WebBookmarkGroup _bookmarkWillChange:]):
        (-[WebBookmarkGroup _bookmarkDidChange:]):
        (-[WebBookmarkGroup _bookmarkChildren:wereAddedToParent:]):
        (-[WebBookmarkGroup _bookmarkChildren:wereRemovedToParent:]):
	All just small pieces of flow control for posting the notes.
        * Bookmarks.subproj/WebBookmarkGroupPrivate.h:  Internal methods for posting the notes.
        * Bookmarks.subproj/WebBookmarkLeaf.m:
        (-[WebBookmarkLeaf setTitle:]):  Post da note
        (-[WebBookmarkLeaf setURLString:]):  Post da note
        (-[WebBookmarkLeaf description]):  Added for debugging.
        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList setTitle:]):  Post da note
        (-[WebBookmarkList removeChild:]):  Post da note
        (-[WebBookmarkList insertChild:atIndex:]):  Post da note
        * Bookmarks.subproj/WebBookmarkProxy.m:
        (-[WebBookmarkProxy setTitle:]):  Post da note
        * English.lproj/StringsNotToBeLocalized.txt:  New strings.
        * WebKit.exp:   New strings.

2002-12-02  Maciej Stachowiak  <mjs@apple.com>

	- added original URL field to action dictionary so that policy delegates
	can avoid prompting over and over on redirects.
	
        * WebKit.exp:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource initWithRequest:]):
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame loadRequest:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _actionInformationForNavigationType:event:originalURL:]):
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:andCall:withSelector:]):
        (-[WebFrame _addExtraFieldsToRequest:]):
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):
        (-[WebFrame _postWithURL:data:contentType:triggeringEvent:]):

2002-11-28  Darin Adler  <darin@apple.com>

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler createFileIfNecessary]): Add a FIXME.
        (-[WebDownloadHandler writeDataForkData:resourceForkData:]): Notify that the file system has
	changed so the Finder can respond to the size change.
        (-[WebDownloadHandler finishedLoading]): Notify that the file system has changed now that the
	download has completed and the files are closed (may be redundant now that we have the above,
	but will do no harm).

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
	Use _web_isCaseInsensitiveEqualToString instead of lowercaseString.

        * Misc.subproj/WebNSViewExtras.m: Tweak formatting.
	
2002-11-27  Richard Williamson   <rjw@apple.com>

        Fixed 3113393.  Client side redirects that happen <= 1 second
        update the current back/forward item, rather than creating
        a new one.

        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _addBackForwardItemClippedAtTarget:]):
        (-[WebFrame _createOrUpdateItem]):
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]):
        (-[WebFrame _transitionToCommitted:]):
        (-[WebFrame _clientRedirectedTo:delay:fireDate:]):
        (-[WebFrame _clientRedirectCancelled]):

2002-11-27  Richard Williamson   <rjw@apple.com>

        Fixed measurement error for Ahem font (and any font that
        has a tiny fractional value). 3112745, 3112742
         
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer initWithFont:]):

2002-11-26  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3090834 - Launch WMP (Window Media Player) when encountering WMP content

	Added contentURL to WebPluginError. 

        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]):
        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage initWithPath:]):
        * Plugins.subproj/WebNullPluginView.m:
        (-[WebNullPluginView viewDidMoveToWindow]):
        * Plugins.subproj/WebPluginError.h:
        * Plugins.subproj/WebPluginError.m:
        (-[WebPluginErrorPrivate dealloc]):
        (-[WebPluginError dealloc]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:MIMEType:]):
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]):

=== Alexander-34 ===

2002-11-26  Richard Williamson   <rjw@apple.com>

        Only cache page if the load has completed.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _setState:]):

2002-11-26  Chris Blumenberg  <cblu@apple.com>

	Removed some logging.

        * WebView.subproj/WebControllerPrivate.m:
        (+[WebController _supportedImageMIMETypes]):

2002-11-26  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3112003 - Show standalone tiffs using AppKit not QT plug-in

	We now dynamically check NSImage for supported image types when registering WebImageView's and WebImageRepresentation's supported MIME types. 

        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (+[WebController _supportedImageMIMETypes]): convert NSImage types to mime types
        * WebView.subproj/WebDataSourcePrivate.m:
        (+[WebDataSource _repTypes]): use _supportedImageMIMETypes to register mime types of WebImageRepresentation
        * WebView.subproj/WebViewPrivate.m:
        (+[WebView _viewTypes]): use _supportedImageMIMETypes to register mime types of WebImageView

2002-11-26  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3061174 - javascript: URLs sent by plugins don't work

	For "Javascript:" URLs. 

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]): lowercase the scheme

2002-11-26  Richard Williamson   <rjw@apple.com>

        More work on back/forward cache.  It's ready for
        more general testing.  Although, to be safe I've
        left it disabled by default for tomorrow's release.
        It will log when a page is save and restored from
        the page cache.
                
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge saveDocumentToPageCache:]):
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading:]):
        (-[WebDataSource _commitIfReady:]):
        (-[WebDataSource _loadIcon]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted:]):
        (-[WebFrame _setState:]):
        (-[WebFrame _loadItem:fromItem:withLoadType:]):
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:request:]):
        (-[WebFrame _setProvisionalDataSource:]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Cleanup leaking objects in page cache.
        Cleaned up API a bit.
        
        * History.subproj/WebBackForwardList.h:
        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList dealloc]):
        (+[WebBackForwardList setUsesPageCache:]):
        (+[WebBackForwardList usesPageCache]):
        (+[WebBackForwardList setPageCacheSize:]):
        (+[WebBackForwardList pageCacheSize]):
        * History.subproj/WebHistoryItem.h:
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem setHasPageCache:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge saveDocumentToPageCache:]):
        * WebKit.exp:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _canCachePage]):
        (-[WebFrame _purgePageCache]):
        (-[WebFrame _setState:]):
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:request:]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Changed ordering of cachability check.
        
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _setState:]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Changes fro back/forward cache.
        
        * History.subproj/WebHistoryItem.h:
        * History.subproj/WebHistoryItem.m:
        (+[WebHistoryItem setUsePageCache:]):
        (+[WebHistoryItem usePageCache]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge saveDocumentToPageCache:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _detachFromParent]):
        (-[WebFrame _canCachePage]):
        (-[WebFrame _setState:]):

2002-11-25  Chris Blumenberg  <cblu@apple.com>

	Fixed 2 drag-related crashes. Oops.

        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragPromisedImage:fromOrigin:withURL:title:event:]): put nil at the end of the array list.
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]): retain self before drag

2002-11-25  Chris Blumenberg  <cblu@apple.com>

	- Allow missing icons to be restored when going to the page of the missing icon.

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _setIconURL:forSiteURL:]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Changes for back/forward.  Currently disabled.

        * History.subproj/WebHistoryItem.h:
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem dealloc]):
        (-[WebHistoryItem setPageCacheEnabled:]):
        (-[WebHistoryItem pageCache]):
        * Misc.subproj/WebKitLogging.h:
        * Misc.subproj/WebKitLogging.m:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge saveDocumentToPageCache:]):
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource startLoading]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading:]):
        (-[WebDataSource _startLoading]):
        (-[WebDataSource _commitIfReady:]):
        (-[WebDataSource _commitIfReady]):
        (-[WebDataSource _setStoredInPageCache:]):
        (-[WebDataSource _storedInPageCache]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted:]):
        (-[WebFrame _canCachePage]):
        (-[WebFrame _purgePageCache]):
        (-[WebFrame _setState:]):
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]):
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:request:]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Fixed exception thrown often when creating mouseover status text (3110186).
        
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]):

2002-11-25  Darin Adler  <darin@apple.com>

	- fixed a problem I discovered in testing where multiple identical bookmarks confuse us

        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList removeChild:]): Use indexOfObjectIdenticalTo: and removeObjectIdenticalTo:
	instead of containsObject: and removeObject:.
        (-[WebBookmarkList insertChild:atIndex:]): Use indexOfObjectIdenticalTo: instead of
	containsObject: in the assertion.

2002-11-25  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3084350 - No URL flavors provided for images

        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragPromisedImage:fromOrigin:withURL:title:event:]): renamed, simplifies dragging an image
        (-[WebFilePromiseDragSource initWithSource:]): subclass of NSFilePromiseDragSource, to be used later
        (-[WebFilePromiseDragSource draggingSource]):
        (-[WebFilePromiseDragSource dealloc]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]): call _web_dragPromisedImage:fromOrigin:withURL:title:event:, retain self
        (-[WebHTMLView draggedImage:endedAt:operation:]): added, release self
        * WebView.subproj/WebImageView.m:
        (-[WebImageView mouseDragged:]): call _web_dragPromisedImage:fromOrigin:withURL:title:event:, retain self
        (-[WebImageView draggedImage:endedAt:operation:]): added, release self
        * WebView.subproj/WebView.m:
        (-[WebView isDocumentHTML]): call isKindOfClass instead of className
        (-[WebView draggingEntered:]): check for WebFilePromiseDragSource

2002-11-24  Trey Matteson  <trey@apple.com>

	Added URLString method to WebHistoryItem to avoid silly conversions between
	NSURL and NSString.  When the dust settles with our plans for NSURL we can
	rationalize this API with the rest of WebKit.

        * History.subproj/WebHistoryItem.h:
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem URLString]):

2002-11-24  Chris Blumenberg  <cblu@apple.com>

	Added element keys for the image ALT and link TITLE attributes. This will eventually be used to fix other bugs. Also made WebKit and WebCore use the same element keys to simplify the conversion of the element dictionary.

        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]):

2002-11-24  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3109945 - Assertion failure in -[WebIconDatabase_largestIconFromDictionary:]
	Added error strings for download decoding errors.

        * English.lproj/Localizable.strings: Added error strings for download decoding errors
        * English.lproj/StringsNotToBeLocalized.txt:
        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _loadIconDictionaries]): tweak
        (-[WebIconDatabase _updateFileDatabase]): more error checking to prevent assert
        (-[WebIconDatabase _setIconURL:forSiteURL:]): added asserts to prevent a site URL <-> icon URL mapping without a icon URL -> icon mapping
        (-[WebIconDatabase _largestIconFromDictionary:]): tweak
        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeURL:andTitle:withOwner:]): declare pboard types if none have been declared, else append types
        * WebView.subproj/WebView.m:
        (+[WebView initialize]): Added error strings for download decoding errors

2002-11-24  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3067939 - no support for window.document.lastModified

        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _commitIfReady]): Pass last modified date to WebCore.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]): Pass
	nil last modified date.

2002-11-23  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3109835 - Download errors aren't communicated to client

	Cleaned-up WebMainResourceClient and WebBaseResourceHandleDelegate a little.

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase defaultIconWithSize:]): tweak
        (-[WebIconDatabase releaseIconForSiteURL:]): don't retain site URL here 
        (-[WebIconDatabase _setIcon:forIconURL:]): tweak
        (-[WebIconDatabase _setIconURL:forSiteURL:]): tweak
        (-[WebIconDatabase _releaseIconForIconURLString:]): retain site URL here 
        (-[WebIconDatabase _releaseFutureIconForSiteURL:]): tweak
        (-[WebIconDatabase _sendNotificationForSiteURL:]): tweak
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate cancelWithError:]): made public
        (-[WebBaseResourceHandleDelegate cancel]): cancel downloads too, call cancelWithError
        (-[WebBaseResourceHandleDelegate cancelQuietly]): call cancelWithError
        (-[WebBaseResourceHandleDelegate cancelledError]): tweak
        (-[WebBaseResourceHandleDelegate notifyDelegatesOfInterruptionByPolicyChange]): tweak
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:]): stop downloadHandler if downloading, else notify controller
        (-[WebMainResourceClient cancel]): call receivedError
        (-[WebMainResourceClient checkContentPolicyForResponse:andCallSelector:]): tweak
        (-[WebMainResourceClient handle:didReceiveData:]): stop load for download errors, report error
        (-[WebMainResourceClient handleDidFinishLoading:]): call didFailLoadingWithError is download error
        (-[WebMainResourceClient handle:didFailLoadingWithError:]): call receivedError

2002-11-22  Darin Adler  <darin@apple.com>

        * Misc.subproj/WebCoreStatistics.h:
        * Misc.subproj/WebCoreStatistics.m:
        (+[WebCoreStatistics javaScriptRootObjectClasses]):
	Update for name change -- root object classes, not all live object classes.

2002-11-22  Chris Blumenberg  <cblu@apple.com>

	Fixed assertion while loading local files.

        * Misc.subproj/WebIconDatabase.m: we don't have icon URLs for files
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _loadIcon]): Only try loading favicon as the root of server if scheme is http or https. This isn't really a feature of other protocols.

2002-11-22  Chris Blumenberg  <cblu@apple.com>

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient continueAfterContentPolicy:response:]): Added a FIXME around saveFilenameForResponse:andRequest: because the API expects a path but is asking for a filename.

2002-11-22  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3104693 - QT movie doesn't show video while still downloading

	The initial size of plug-in should be 0,0 instead of 1,1 or else we don't get the layout

        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView initWithFrame:]):

2002-11-22  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3078737 - Crash in -[WebHistoryItem dealloc] after closing last window

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase releaseIconForSiteURL:]): retain the site URL string because it may get released from beneath
        (-[WebIconDatabase _updateFileDatabase]): tweak
        (-[WebIconDatabase _iconsForIconURLString:]): disable timings for deployment build
        (-[WebIconDatabase _setIconURL:forSiteURL:]): tweak
        (-[WebIconDatabase _releaseIconForIconURLString:]): tweak
        (-[WebIconDatabase _scaleIcon:toSize:]): disable timings for deployment build
        * Misc.subproj/WebIconDatabasePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _updateIconDatabaseWithURL:]): new, does the db binding
        (-[WebDataSource _loadIcon]): call _updateIconDatabaseWithURL

2002-11-22  Chris Blumenberg  <cblu@apple.com>

	Attempt to fix: 3078737 - Crash in -[WebHistoryItem dealloc] after closing last window
	I haven't found anything that would cause the crash. I did some clean-up, added asserts and error messages in hopes that this help me track this down.

        * Misc.subproj/WebIconDatabase.h:
        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase init]):
        (-[WebIconDatabase iconForSiteURL:withSize:cache:]):
        (-[WebIconDatabase iconForSiteURL:withSize:]):
        (-[WebIconDatabase retainIconForSiteURL:]):
        (-[WebIconDatabase releaseIconForSiteURL:]):
        (-[WebIconDatabase delayDatabaseCleanup]):
        (-[WebIconDatabase allowDatabaseCleanup]):
        (-[WebIconDatabase _iconDictionariesAreGood]):
        (-[WebIconDatabase _loadIconDictionaries]):
        (-[WebIconDatabase _updateFileDatabase]):
        (-[WebIconDatabase _hasIconForSiteURL:]):
        (-[WebIconDatabase _iconsForIconURLString:]):
        (-[WebIconDatabase _iconForFileURL:withSize:]):
        (-[WebIconDatabase _setIcon:forIconURL:]):
        (-[WebIconDatabase _setIconURL:forSiteURL:]):
        (-[WebIconDatabase _retainIconForIconURLString:]):
        (-[WebIconDatabase _releaseIconForIconURLString:]):
        (-[WebIconDatabase _retainFutureIconForSiteURL:]):
        (-[WebIconDatabase _releaseFutureIconForSiteURL:]):
        (-[WebIconDatabase _releaseOriginalIconsOnDisk]):
        (-[WebIconDatabase _sendNotificationForSiteURL:]):
        (-[WebIconDatabase _addObject:toSetForKey:inDictionary:]):
        (-[WebIconDatabase _largestIconFromDictionary:]):
        (-[WebIconDatabase _iconsBySplittingRepresentationsOfIcon:]):
        (-[WebIconDatabase _iconFromDictionary:forSize:cache:]):
        (-[WebIconDatabase _scaleIcon:toSize:]):
        * Misc.subproj/WebIconDatabasePrivate.h:
        * WebKit.exp:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _loadIcon]):

2002-11-22  Richard Williamson   <rjw@apple.com>

        Fixed rendering issues associated with 3100120.
        We now correctly map surrogate pairs in UTF-16.  khtml still has
        issues dealing with characters outside BMP.  These are tracked
        with 3109251 and 3109258.
        
        Surrogate pairs are treated as exceptions and have their own character
        to glyph map.
        
        * Misc.subproj/WebUnicode.h:
        * Misc.subproj/WebUnicode.m:
        (shapedString):
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (glyphForUnicodeCharacter):
        (findLengthOfCharacterCluster):
        (-[WebTextRenderer substituteFontForString:]):
        (-[WebTextRenderer convertUnicodeCharacters:length:toGlyphs:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:]):
        (-[WebTextRenderer extendUnicodeCharacterToGlyphMapToInclude:]):
        (-[WebTextRenderer extendCharacterToGlyphMapToInclude:]):

2002-11-22  John Sullivan  <sullivan@apple.com>

        * Resources/url_icon.tiff:
	new generic URL icon -- little blue globe, pretty nice

        * WebKit.exp:
	removed symbol for WebTextRendererFactory which was in here
	to support an obsolete SPI hack

2002-11-22  Trey Matteson  <trey@apple.com>

	Added more detailed notifications on history changes.
	All changes below are just posting the new notes at the right time.

        * English.lproj/StringsNotToBeLocalized.txt:
        * History.subproj/WebHistory.h:
        * History.subproj/WebHistory.m:
        (-[WebHistory _sendNotification:entries:]):
        (-[WebHistory addEntry:]):
        (-[WebHistory removeEntry:]):
        (-[WebHistory removeEntries:]):
        (-[WebHistory removeAllEntries]):
        (-[WebHistory addEntries:]):
        (-[WebHistory loadHistory]):
        * WebKit.exp:

2002-11-22  Richard Williamson   <rjw@apple.com>

        Changed NSString category methods to include _web_ prefix.

        * Misc.subproj/WebKitNSStringExtras.h:
        * Misc.subproj/WebKitNSStringExtras.m:
        (-[NSString _web_widthForString:font:]):

2002-11-22  Richard Williamson   <rjw@apple.com>

        Simplified drawing and measuring SPI for use by Alex.

        * Misc.subproj/WebKitNSStringExtras.h: Added.
        * Misc.subproj/WebKitNSStringExtras.m: Added.
        (-[NSString widthForString:font:]):
        * WebKit.pbproj/project.pbxproj:

2002-11-21  Chris Blumenberg  <cblu@apple.com>

	Removed workaround for: 3093170 - Handle clients receive data with length 0

	as it's now fixed.

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler receivedData:]): remove workaround
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveData:]): added asserts

2002-11-21  Richard Williamson   <rjw@apple.com>

        A different fix to 3078065 that doesn't depend on the appkit's idea of
        fixed pitch font.
        
        The fix is to adjust the width of all characters that have the same width
        as the space character to match the adjustment of the space character.
        This has the slight downside that non-monospace fonts that contain glyphs
        with the same width as the space character will have an extra adjustment.
        In practice this is not noticeable as the adjustment is always sub-pixel.
        Nor of course does this cause any mislayout, as it's done at the lowest
        level for both measurement and drawing.
        
        Until we move kthml internals to floats this will be just fine.
        
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (widthForGlyph):
        (-[WebTextRenderer initWithFont:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:]):
tAfterNavigationPolicy:request:]):

2002-11-21  Maciej Stachowiak  <mjs@apple.com>

        * Makefile.am: Pass symroots for this tree to pbxbuild.

2002-11-21  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3009881 - plugins get mouse-overs even when mouse is in menus
	Fixed: 3108240 - Loading datasource sometimes doesn't have cancelled error when cancelled

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView sendNullEvent]): check if menus are showing
        (-[WebBaseNetscapePluginView restartNullEvents]): tweak
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _stopLoading]): set cancelled error if main handle is gone

=== Alexander-33 ===

2002-11-20  Darin Adler  <darin@apple.com>

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
	Unescape the string before executing it, so we don't suffer from bug 3083043
	here in the javascript: URLs that come from plug-ins.

        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-11-20  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3079134 - Throttle plug-ins while in background

        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView sendNullEvent]): new
        (-[WebBaseNetscapePluginView stopNullEvents]): stops timer
        (-[WebBaseNetscapePluginView restartNullEvents]): stops timer if there is one, and starts a new one based on window activation state
        (-[WebBaseNetscapePluginView start]): call restartNullEvents
        (-[WebBaseNetscapePluginView stop]): call stopNullEvents
        (-[WebBaseNetscapePluginView windowBecameKey:]): call restartNullEvents
        (-[WebBaseNetscapePluginView windowResignedKey:]): call restartNullEvents
        (-[WebBaseNetscapePluginView windowDidMiniaturize:]): call stopNullEvents
        (-[WebBaseNetscapePluginView windowDidDeminiaturize:]): call restartNullEvents
        * Plugins.subproj/WebNetscapePluginNullEventSender.h: Removed. No need for another class, use a timer.
        * Plugins.subproj/WebNetscapePluginNullEventSender.m: Removed. No need for another class, use a timer.
        * WebKit.pbproj/project.pbxproj:

2002-11-20  Richard Williamson   <rjw@apple.com>

        Fixed 3107007.  Letter-spacing is causing width to be miscalculated.
        This also fixed some selection problems.
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:]):

2002-11-20  Richard Williamson   <rjw@apple.com>

        Fixed mono spaced fonts to always render with mono spacing! (3078065)
        
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (widthForGlyph):
        (-[WebTextRenderer initWithFont:]):

2002-11-20  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3074926 - crash in BitsToPix() trying to print cnet page

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView drawRect:]): disable experimental plug-in printing code.

2002-11-20  Chris Blumenberg  <cblu@apple.com>

	Minor clean-up, logging and more error checking in plug-in code.

        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream setResponse:]):
        (-[WebBaseNetscapePluginStream receivedData:]):
        (-[WebBaseNetscapePluginStream finishedLoadingWithData:]):
        * Plugins.subproj/npapi.m:
        (NPN_UserAgent):
        (NPN_MemFree):
        (NPN_MemFlush):
        (NPN_ReloadPlugins):

2002-11-20  Chris Blumenberg  <cblu@apple.com>
	
	Fixed: 3061174 - javascript: URLs sent by plugins don't work

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):

2002-11-20  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-11-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3106061 - REGRESSION: Copy in text view copies all text not just selection

        * Misc.subproj/WebSearchableTextView.m:
        (-[WebSearchableTextView copy:]):

2002-11-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3092588 - redraw errors in QT controller if window is in background

	We need to send update events after we activate/deactivate after all.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView windowBecameKey:]):
        (-[WebBaseNetscapePluginView windowResignedKey:]):

2002-11-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3020720 - dropping a folder in the page address makes the folder open in Finder, empties the field

        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_bestURL]): Don't accept directories.

2002-11-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3068112 - extra line breaks when copying from source window

        * Misc.subproj/WebSearchableTextView.m:
        (-[WebSearchableTextView copy:]): Convert CRLF to LF

2002-11-19  David Hyatt  <hyatt@apple.com>

	Make sure that if the scrollers are shown/hidden that we
	force an immediate layout, since if we don't, an intervening
	display can cause us to show scrollbars when they really
	shouldn't be there.
	
        * WebView.subproj/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):

2002-11-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3100597 - repro NSArray exception using contextual menu

        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeURL:andTitle:withOwner:]): more error checking

2002-11-19  Trey Matteson  <trey@apple.com>

	Just a tweak to the description printout.

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem description]):

2002-11-18  Chris Blumenberg  <cblu@apple.com>

	Real fix for: 3104183 - Assert loading www.louisvuitton.com

	Since we don't consider plug-in content as a subresource, attaching plug-in streams to the datasource has no affect on the loading state of the datasource. Both stopLoading on WebFrame and _stopLoading datasource, would not stop plug-ins streams after th
e data source was done loading. Because of this, I've decided to not keep a list of plug-in streams attached to the data source and pulled my previous change. To fix this bug, WebBaseResourceHandleDelegate now retains the controller.

        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePluginStream cancel]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate _releaseResources]):
        (-[WebBaseResourceHandleDelegate setDataSource:]):
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):
        (-[WebBaseResourceHandleDelegate handleDidFinishLoading:]):
        (-[WebBaseResourceHandleDelegate handle:didFailLoadingWithError:]):
        (-[WebBaseResourceHandleDelegate _cancelWithError:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _stopLoading]):
        (-[WebDataSource _makeHandleDelegates:deferCallbacks:]):
        (-[WebDataSource _defersCallbacksChanged]):

2002-11-18  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3104183 - Assert loading www.louisvuitton.com

	We need to treat plug-in streams like subresources except they don't change the loading state of the data source.

        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream start]): call _addPluginStream
        (-[WebNetscapePluginStream cancel]): call _removePluginStream
        (-[WebNetscapePluginStream handleDidFinishLoading:]): call _removePluginStream
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]): call _removePluginStream
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): release pluginStreams
        (-[WebDataSource _addPluginStream:]): just like addSubresourceClient except don't change the loading state.
        (-[WebDataSource _removePluginStream:]): just like removeSubresourceClient except don't change the loading state.
        (-[WebDataSource _stopLoading]): stop plug-ins streams
        (-[WebDataSource _makeHandleDelegates:deferCallbacks:]): 
        (-[WebDataSource _defersCallbacksChanged]): call _makeHandleDelegates:deferCallbacks: for subresources and plug-in streams.

2002-11-18  Richard Williamson   <rjw@apple.com>

        Check for usesBackForwardList was excluding all load types.
        
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):

2002-11-18  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3098767 - REGRESSION: standalone quicktime content just shows blank window

	Check the instance not the class for the class type.

        * Plugins.subproj/WebNetscapePluginRepresentation.m:
        (-[WebNetscapePluginRepresentation receivedData:withDataSource:]):

2002-11-18  Ken Kocienda  <kocienda@apple.com>

	Added feature to import bookmarks/favorites from MSIE. This
	fixes Radar 2961230 (import Mac IE bookmarks).

        * Bookmarks.subproj/WebBookmarkImporter.h: Added.
        * Bookmarks.subproj/WebBookmarkImporter.m: Added.
        (_breakStringIntoLines):
        (_HREFRangeFromSpec):
        (_HREFTextFromSpec):
        (_linkTextRangeFromSpec):
        (_linkTextFromSpec):
        (-[WebBookmarkImporter initWithPath:group:]):
        (-[WebBookmarkImporter topBookmark]):
        (-[WebBookmarkImporter error]):
        (-[WebBookmarkImporter dealloc]):
        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList init]): Create the bookmark list object. This
	was not created with the -init initializer, causing bookmark lists
	to fail.
        * English.lproj/Localizable.strings:
        * English.lproj/StringsNotToBeLocalized.txt:
        * WebKit.exp:
        * WebKit.pbproj/project.pbxproj:

2002-11-17  Trey Matteson  <trey@apple.com>

	Code cleanup to make some internal methods return autoreleased objects.

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _addBackForwardItemClippedAtTarget:]):
        (-[WebFrame _createItem]):
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]):
        (-[WebFrame _transitionToCommitted]):

2002-11-17  Trey Matteson  <trey@apple.com>

	Fixed 3102076 - REGRESSION: infinite recursion involving bridge end
	Fixed 3100929 - REGRESSION: serverRedirectedForDataSource: not sent on server redirects
	Fixed 3103381 - REGRESSION: Going back from anchor doesn't restore scroll position

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):  Return the copy of the
	request that we make instead of the original.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):  Call super after we make our mods
	to the request, so the copy that super makes for us includes those mods.

        * WebView.subproj/WebFramePrivate.h:  Added new state, WebFrameStateCompleting.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToLayoutAcceptable]):  Completing state is a NOP.
        (-[WebFrame _transitionToCommitted]):  Completing state is a NOP.
        (-[WebFrame _isLoadComplete]):  Go to Completing state before calling [bridge end].
	Go to Completed state afterwards, only if no new loads started in the meantime.
        (-[WebFrame _loadItem:fromItem:withLoadType:]):  When doing anchor nav to get to the
	item, save and restore scroll state, and set the current item.
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]):
	Reorder the steps so the right scroll state gets saved to the right place.  Also, don't
	add a backForward item if we're doing a client redirect to an anchor.

2002-11-17  David Hyatt  <hyatt@apple.com>

	Back out my previous fix.  I have a better one that is
	confined to WebCore.
	
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _isLoadComplete]):

2002-11-17  David Hyatt  <hyatt@apple.com>

	The needsdisplay is necessary even for HTML documents.
	I over-optimized here.  Fixes the directory.apple.com
	regression and the santa clara library regression.
	
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _isLoadComplete]):

2002-11-17  Darin Adler  <darin@apple.com>

	- update for change to WebCore API so it never uses NSURL

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:frameName:]): Take NSString instead of NSURL.
        (-[WebBridge startLoadingResource:withURL:]): Ditto.
        (-[WebBridge objectLoadedFromCacheWithURL:response:size:]): Ditto.
        (-[WebBridge reportClientRedirectToURL:delay:fireDate:]): Ditto.
        (-[WebBridge setIconURL:]): Ditto.
        (-[WebBridge setIconURL:withType:]): Ditto.
        (-[WebBridge loadURL:reload:triggeringEvent:isFormSubmission:]): Ditto.
        (-[WebBridge postWithURL:data:contentType:triggeringEvent:]): Ditto.
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]): Ditto.
        (-[WebBridge userAgentForURL:]): Ditto.
        (-[WebBridge requestedURL]): Return NSString instead of NSURL.
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:MIMEType:]): Take NSString instead of NSURL.
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]): Take NSString instead of NSURL.

        * WebCoreSupport.subproj/WebCookieAdapter.m:
        (-[WebCookieAdapter cookiesForURL:]): Take NSString instead of NSURL.
        (-[WebCookieAdapter setCookies:forURL:policyBaseURL:]): Ditto.

        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _commitIfReady]): Pass NSString instead of NSURL.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]): Pass NSString instead of NSURL
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]): Turn bridge URL into NSURL so we
	can call _web_URLByRemovingFragment on it.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]): Convert NSString to NSURL when making the WebKit element dictionary.

2002-11-17  Maciej Stachowiak  <mjs@apple.com>

	- fixed 2949193 - implement onKeyDown, onKeyPress, and onKeyUp event handlers
	
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebHTMLViewPrivate.m:
        (+[WebHTMLView load]): Pose as NSWindow too now.
        (-[WebHTMLView _interceptKeyEvent:toView:]): Pass event to WebCore and
	see if WebCore wants to block it.
        (-[WebNSWindow sendEvent:]): For all key events that would go to a
	subview of a WebHTMLView, let the WebHTMLView take a first crack
	at it.

2002-11-15  Darin Adler  <darin@apple.com>

	- fixed 3079214 -- text/plain page shows up slowly, a few pages at a time

        * WebView.subproj/WebTextView.m:
        (-[WebTextView initWithFrame:]): Remove unneeded setWidthTracksTextView:, because
	that's the default.
        (-[WebTextView dataSourceUpdated:]): Replace the thing each time in the RTF case.
        (-[WebTextView viewDidMoveToSuperview]): Here's where we resize, but only the width.
	Resizing the height was causing the bug.
        (-[WebTextView layout]): Do nothing.
        (-[WebTextView setAcceptsDrags:]): Update to new name. Since we weren't
	importing WebDocument.h, we never noticed that this file got out of sync.
        (-[WebTextView acceptsDrags]): Ditto.
        (-[WebTextView setAcceptsDrops:]): Ditto.
        (-[WebTextView acceptsDrops]): Ditto.

        * WebView.subproj/WebDocument.h: Fix typo. It said setAcceptsDrags: twice.

2002-11-15  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebFramePrivate.m: Removed a bunch of tabs and fixed indenting.

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3102016 - REGRESSION: Command-clicking on a link can open _two_ windows.
	
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setJustOpenedForTargetedLink:]):
        (-[WebDataSource _justOpenedForTargetedLink]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame findOrCreateFramedNamed:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterNavigationPolicy:]):
        (-[WebFrame _loadDataSource:withLoadType:]):
        (-[WebFrame _downloadRequest:toPath:]):
        (-[WebFrame _setJustOpenedForTargetedLink:]):

2002-11-15  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:andCall:withSelector:]):
	Give the listener a slightly longer lifetime, to make this API a bit more foolproof.

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

	Fix world leak I introduced, and also add an early return when needed.
	
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _invalidatePendingPolicyDecisionCallingDefaultAction:]):
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:andCall:withSelector:]):

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

	Make navigation policy asynchronous for real.
	
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        (-[WebPolicyDecisionListenerPrivate initWithTarget:action:]):
        (-[WebPolicyDecisionListenerPrivate dealloc]):
        (-[WebPolicyDecisionListener usePolicy:]):
        (-[WebPolicyDecisionListener _initWithTarget:action:]):
        (-[WebPolicyDecisionListener dealloc]):
        (-[WebPolicyDecisionListener _invalidate]):
        * WebView.subproj/WebControllerPolicyDelegatePrivate.h: Added.
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate decideNavigationPolicyForAction:andRequest:inFrame:decisionListener:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame stopLoading]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate dealloc]):
        (-[WebFrame _invalidatePendingPolicyDecisionCallingDefaultAction:]):
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:andCall:withSelector:]):
        (-[WebFrame _continueAfterNavigationPolicy:]):
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):
        (-[WebFrame _loadDataSource:withLoadType:]):

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

	Wrap content policy invocation to look asynchronous.
	
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient continueAfterContentPolicy:response:]):
        (-[WebMainResourceClient checkContentPolicyForResponse:andCallSelector:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

	Refactor so that all invocations of navigation policy are set up
	to be asynchronous. However, the actually delegate method is not
	async yet.
	
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:andCall:withSelector:]):
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:request:]):
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:request:]):
        (-[WebFrame _loadDataSource:withLoadType:]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient stopLoadingForPolicyChange]):
        (-[WebMainResourceClient continueAfterNavigationPolicy:request:]):
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-14  Maciej Stachowiak  <mjs@apple.com>

	Refactor things a bit so all loads bottleneck through a single
	method (_loadDataSource:withLoadType:).
	
        * WebView.subproj/WebFrame.m:
        (-[WebFrame loadRequest:]):
        (-[WebFrame reload]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _loadItem:fromItem:withLoadType:]):
        (-[WebFrame _loadRequest:triggeringAction:loadType:]):
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):
        (-[WebFrame _postWithURL:data:contentType:triggeringEvent:]):
        (-[WebFrame _reloadAllowingStaleDataWithOverrideEncoding:]):
        (-[WebFrame _loadDataSource:withLoadType:]):
        (-[WebFrame _downloadRequest:toPath:]):

2002-11-14  Maciej Stachowiak  <mjs@apple.com>

	Change things so the public interface to loading is loadRequest:
	and everything else is private.
	
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController showURL:inFrame:]):
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController init]):
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _createFrameNamed:inParent:allowsScrolling:]):
        (-[WebController _downloadURL:toPath:]):
        * WebView.subproj/WebFrame.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame init]):
        (-[WebFrame initWithName:webView:controller:]):
        (-[WebFrame loadRequest:]):
        (-[WebFrame reload]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _timedLayout:]):
        (-[WebFrame _clearProvisionalDataSource]):
        (-[WebFrame _loadItem:fromItem:withLoadType:]):
        (-[WebFrame _loadRequest:triggeringAction:]):
        (-[WebFrame _reloadAllowingStaleDataWithOverrideEncoding:]):
        (-[WebFrame _itemForRestoringDocState]):
        (-[WebFrame _setProvisionalDataSource:]):
        (-[WebFrame _startLoading]):
        (-[WebFrame _downloadRequest:toPath:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient stopLoadingAfterContentPolicy]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        * WebView.subproj/WebView.m:
        (-[WebView concludeDragOperation:]):

2002-11-14  David Hyatt  <hyatt@apple.com>

	Move text measurement and layout beyond onload.  This
	shoudl speed up i-bench substantially and morrison's
	PLT test slightly.  Note that the adjustFrames layout
	stuff has been removed from isLoadComplete.
	
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _timedLayout:]):
        (-[WebFrame _isLoadComplete]):

2002-11-14  Darin Adler  <darin@apple.com>

        * English.lproj/Localizable.strings: Updated to include the new
	error messages that Maciej just added. I wonder what effect this
	will have if we see those errors in Alex-32?

=== Alexander-32 ===

2002-11-14  Don Melton  <gramps@apple.com>

        * WebView.subproj/WebControllerPolicyDelegate.h:

	Added missing semi-colon in definition of WebPolicyDecisionListener to
	fix build error.

2002-11-14  Maciej Stachowiak  <mjs@apple.com>

	Combined file URL policy with content policy. We don't actually
	bother to ask earlier for file URLs yet, since that will make
	things more complicated.
	
        * Misc.subproj/WebKitErrors.h:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _handleUnimplementablePolicy:errorCode:forURL:]):
        (-[WebFrame _continueAfterNavigationPolicyForRequest:dataSource:]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient stopLoadingAfterContentPolicy]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        * WebView.subproj/WebView.m:
        (+[WebView initialize]):

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed 3099240 -- REGRESSION: repro assert d->m_doc->parsing

	Make the reload flag pass across the bridge.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _commitIfReady]):
	Pass a reload flag, based on the load type, to the bridge.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]): Pass a
	reload flag of NO in the anchor case. Preserve reload load types even when
	doing client redirects (have to talk with Trey about this tomorrow).

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed 3100235 -- nil-deference in khtml::RenderTable at money.cnn.com

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView drawRect:]):
	If the WebCore side needs layout, then do layout before trying to draw.

2002-11-13  Trey Matteson  <trey@apple.com>

	Fixed client redirects, some more.  The upshot is that they do not
	generate two items in the back-forward list.  iBench still works.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge reportClientRedirectTo:delay:fireDate:]):  Call straight to the frame for all impl.
        (-[WebBridge reportClientRedirectCancelled]):  Call straight to the frame for all impl.
        (-[WebBridge loadURL:reload:triggeringEvent:isFormSubmission:]):
	clientRedirect param removed when sending _loadURL: to frame.
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _loadURL:loadType:triggeringEvent:isFormSubmission:]):
	clientRedirect param  removed. Check our own ivar to know if we are in client redirect case.
        (-[WebFrame _loadURL:intoChild:]):
	clientRedirect param removed when sending _loadURL: .
        (-[WebFrame _clientRedirectedTo:delay:fireDate:]):
	Note that we are doing a redirect if time=0 and we're not completed.  Also includes
	previous impl moved from Bridge.
        (-[WebFrame _clientRedirectCancelled]):  Previous impl moved from Bridge.


2002-11-13  Maciej Stachowiak  <mjs@apple.com>

	Pass mime type instead of full response to content policy delegate
	method, in preparation for merging it with the file URL policy.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed 3083982 -- Logging into AOL gives null view

	Turns out AOL was using a refresh header, which we were not supporting.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _commitIfReady]):
	Call openURL: and pass headers in.

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:isFormSubmission:]):
	Pass nil for headers in this case, since we know it's just an anchor change.

	- other things

        * WebCoreSupport.subproj/WebBridge.h: Remove dataSourceChanged and dataSource
	methods. We try to keep the bridge methods down to actual bridging.
        * WebCoreSupport.subproj/WebBridge.m: Remove dataSourceChanged altogether,
	and move dataSource up in the file.

        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation setDataSource:]): Keep the data source around, so we
	don't need to ask the bridge for it.
        (-[WebHTMLRepresentation documentSource]): Use it here.

2002-11-13  Trey Matteson  <trey@apple.com>

	Fixed 3100084 - REGRESSION: web page is not first responder after visiting web page

        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _commitIfReady]):  Make the rep before _transitionToCommitted.  This is the way it used to be.
        (-[WebDataSource _makeRepresentation]):  Don't make the docView here.

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):  Make the docView here, after we save the scroll state but before notifying the delegate.

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed 3100013 -- REGRESSION: Can't get results from i-Bench anymore

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _isLoadComplete]):
	Don't set the state to WebFrameStateComplete if it has already been set
	to WebFrameStateProvisional. If it has, that means we already began a new
	load; that one is not yet complete.

2002-11-13  John Sullivan  <sullivan@apple.com>

	- fixed 3099922 -- REGRESSION: Back button always pops up menu

        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragShouldBeginFromMouseDown:withExpiration:xHysteresis:yHysteresis:]:
	Fixed a copy/paste error I made yesterday -- this method was never
	noticing the mouse-up events because it was checking the event type
	against the wrong number. Also changed the hysteresis values from
	unsigneds to floats (unsigned was just wrong).

2002-11-13  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3050447 - Policy handlers have no way of telling client
	that the proposed navigation is a form post

	Now we pass form submissions through all the normal policy steps.
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:reload:triggeringEvent:isFormSubmission:]):
        (-[WebBridge postWithURL:data:contentType:triggeringEvent:]):
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _setTriggeringAction:]):
        (-[WebDataSource _triggeringAction]):
        (-[WebDataSource _lastCheckedRequest]):
        (-[WebDataSource _setLastCheckedRequest:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame setProvisionalDataSource:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _shouldShowRequest:]):
        (-[WebFrame _loadRequest:triggeringAction:]):
        (-[WebFrame _actionInformationForNavigationType:event:]):
        (-[WebFrame _continueAfterNavigationPolicyForRequest:dataSource:]):
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:isFormSubmission:]):
        (-[WebFrame _loadURL:intoChild:]):
        (-[WebFrame _postWithURL:data:contentType:triggeringEvent:]):

2002-11-12  Maciej Stachowiak  <mjs@apple.com>

	Combine click policy and URL policy into navigation policy.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate navigationPolicyForAction:andRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _shouldShowRequest:]):
        (-[WebFrame _actionInformationForNavigationType:event:]):
        (-[WebFrame _continueAfterFileURLPolicyForRequest:]):
        (-[WebFrame _continueAfterNavigationPolicyForRequest:event:]):
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):

2002-11-12  Trey Matteson  <trey@apple.com>

	fixed 3096030 - Crash in -[WebBackForwardList goToEntry:] when playing with SnapBack and dictionary.com

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _isLoadComplete]):  Set state=completed only after we tell the bridge to
	end the load.  This allows client redirects to be processed before we think we're complete.
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):
	Only process client redirects as such if we are not already complete.  This makes JS driven
	navigations after load-time work like the user would expect, as normal navigations.

2002-11-12  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3099487 - REGRESSION: dragging an image always puts it in
	the download directory
	
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _downloadURL:]): Call _downloadURL:toPath: with nil path.
	(-[WebController _downloadURL:toPath:]): New method that
	predetermines the path to download to (needed for DnD).
        * WebView.subproj/WebHTMLView.m:
	(-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]): Use
	_downloadURL:toPath:
        * WebView.subproj/WebImageView.m:
	(-[WebImageView namesOfPromisedFilesDroppedAtDestination:]): Use
	_downloadURL:toPath:
        * WebView.subproj/WebMainResourceClient.m:
	(-[WebMainResourceClient handle:didReceiveResponse:]): Don't ask
	delegate for download path if we already have one.

2002-11-12  Richard Williamson  <rjw@apple.com>

        Fixed likely cause of 3099047 (and others).  Width buffer could underrun in
        some situations.
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:]):

2002-11-12  John Sullivan  <sullivan@apple.com>

        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragShouldBeginFromMouseDown:withExpiration:xHysteresis:yHysteresis:]):
	new method
        (-[NSView _web_dragShouldBeginFromMouseDown:withExpiration:]):
	now calls the new method, passing the default hysteresis values

2002-11-12  Richard Williamson  <rjw@apple.com>

        Implemented letter-spacing and word-spacing CSS properties.

        * Misc.subproj/WebStringTruncator.m:
        (+[WebStringTruncator rightTruncateString:toWidth:withFont:]):
        (+[WebStringTruncator centerTruncateString:toWidth:withFont:]):
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer widthForCharacters:length:]):
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:letterSpacing:wordSpacing:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:characterPosition:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:letterSpacing:wordSpacing:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:letterSpacing:wordSpacing:]):

2002-11-12  Maciej Stachowiak  <mjs@apple.com>

	Removed policy classes and instead use the policy enums directly,
	since we no longer hold the path in the enum.
	
        * Downloads.subproj/WebDownloadHandler.m:
        * WebKit.exp:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        * WebView.subproj/WebControllerPolicyDelegatePrivate.h: Removed.
        * WebView.subproj/WebControllerPrivate.m:
        * WebView.subproj/WebDefaultPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (+[WebDefaultPolicyDelegate defaultURLPolicyForRequest:]):
        (-[WebDefaultPolicyDelegate URLPolicyForRequest:inFrame:]):
        (-[WebDefaultPolicyDelegate fileURLPolicyForMIMEType:andRequest:inFrame:]):
        (-[WebDefaultPolicyDelegate unableToImplementPolicy:error:forURL:inFrame:]):
        (-[WebDefaultPolicyDelegate clickPolicyForAction:andRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame handleUnimplementablePolicy:errorCode:forURL:]):
        (-[WebFrame _shouldShowRequest:]):
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-12  Maciej Stachowiak  <mjs@apple.com>

	Keep the triggering event around on the data source, so it can be
	used with redirects.

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _loadRequest:triggeringEvent:]):
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):
        (-[WebFrame _postWithURL:data:contentType:]):

2002-11-12  Darin Adler  <darin@apple.com>

	- improved the code that manages observing the window and superview

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView addSuperviewObservers]): Added.
        (-[WebHTMLView removeSuperviewObservers]): Added.
        (-[WebHTMLView addWindowObservers]): Added.
        (-[WebHTMLView removeWindowObservers]): Added.
        (-[WebHTMLView viewWillMoveToSuperview:]): Call removeSuperviewObservers.
        (-[WebHTMLView viewDidMoveToSuperview]): Call addSuperviewObservers.
        (-[WebHTMLView viewWillMoveToWindow:]): Call removeWindowObservers and
	removeSuperviewObservers.
        (-[WebHTMLView viewDidMoveToWindow]): Call addWindowObservers and
	addSuperviewObservers.

2002-11-11  Maciej Stachowiak  <mjs@apple.com>

	Remove contentPolicy parameter from _downloadURL, and remove
	remaining traces of path from policy object.

        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        (-[WebPolicyPrivate dealloc]):
        (+[WebURLPolicy webPolicyWithURLAction:]):
        (+[WebFileURLPolicy webPolicyWithFileAction:]):
        (+[WebContentPolicy webPolicyWithContentAction:]):
        (+[WebClickPolicy webPolicyWithClickAction:]):
        * WebView.subproj/WebControllerPolicyDelegatePrivate.h:
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _downloadURL:]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate downloadURL:]):
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate clickPolicyForAction:andRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]):
        * WebView.subproj/WebImageView.m:
        (-[WebImageView namesOfPromisedFilesDroppedAtDestination:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-11  Darin Adler  <darin@apple.com>

        * Plugins.subproj/WebNetscapePluginPackage.m: (-[WebNetscapePluginPackage load]):
        Use fileSystemRepresentationWithPath, not cString, to turn a path into something
        to pass to FSPathMakeRef.

        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-11-11  Darin Adler  <darin@apple.com>

	- tighten up cursor handling a bit more

        * WebView.subproj/WebDynamicScrollBarsView.m:
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView addMouseMovedObserver]): Call _frameOrBoundsChanged
	so we emit a mouse moved event right away.
        (-[WebHTMLView viewWillMoveToSuperview:]): Remove the colon since I
	removed the parameter from _frameOrBoundsChanged.

        * WebView.subproj/WebHTMLViewPrivate.h: Declare _frameOrBoundsChanged.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _frameOrBoundsChanged]): Remove parameter.

2002-11-11  Trey Matteson  <trey@apple.com>

        Fixed 3015884 - Reloading a page should remember the scroll position

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):  Save scroll position on reload
        (-[WebFrame _isLoadComplete]):  Restore position on reload

2002-11-11  Trey Matteson  <trey@apple.com>

        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList addEntry:]):  Yank code to avoid adding a duplicate entry, to catch the
	refresh case.  That's dealt with in WebFramePrivate now.
        (-[WebBackForwardList description]):  Enhanced to print more info.

        * History.subproj/WebHistoryItem.h:
	History items now hold an array of subitems to mirror the frame tree.  One item in the tree
	is designated the target of the navigation.
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem dealloc]):  Release new ivars.
        (-[WebHistoryItem isTargetItem]):
        (-[WebHistoryItem setIsTargetItem:]):
	New setter and setter.
        (-[WebHistoryItem _recurseToFindTargetItem]):
        (-[WebHistoryItem targetItem]):
	Search the tree to find the target item.
        (-[WebHistoryItem children]):
        (-[WebHistoryItem addChildItem:]):
        (-[WebHistoryItem childItemWithName:]):
	Maintain and search new child item list.
        (-[WebHistoryItem description]):
	Enhanced to print out the tree of items.
        (-[WebHistoryItem dictionaryRepresentation]):
        (-[WebHistoryItem initFromDictionaryRepresentation:]):
	Save and load the new state.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge generateFrameName]):  New call from KWQ, just forwards to Frame.
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Call new frame method dedicated to this case.
        (-[WebBridge saveDocumentState:]):
        (-[WebBridge documentState]):
	Call frame methods to get the right item to save/restore to/from.

        * WebView.subproj/WebController.m:
        (-[WebController _goToItem:withLoadType:]):  Stop any current loading before going to a new item.
        (-[WebController goBack]):
        (-[WebController goForward]):
        (-[WebController goBackOrForwardToItem:]):  Name change of private method (for consistency)

        * WebView.subproj/WebDataSourcePrivate.h:
	ProvisionalItem and PreviousItem are moved back up to WebFrame, where we know more about the
	state transitions that happen during loading.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): Don't release removed ivars.
        (-[WebDataSource _commitIfReady]): Make the view representations -after- the transition to committed.
	This allows us to save away the scroll location successfully, since making the view was resetting it.
        * WebView.subproj/WebFrame.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame setProvisionalDataSource:]):  Saving the scroll location has moved elsewhere to handle frames.
        (-[WebFrame stopLoading]):  Skip all the work if we're already state=complete.

        * WebView.subproj/WebFramePrivate.h:
	The frame now holds a ref to the current, previous and provisional back-forward items.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate dealloc]):  Release new state.
        (-[WebFramePrivate setProvisionalItem:]):
        (-[WebFramePrivate setPreviousItem:]):
        (-[WebFramePrivate setCurrentItem:]):	New setters (1 line getters were missed by script)
        (-[WebFrame _addBackForwardItemClippedAtTarget:]):  Adds a BF item to the top of the BF list.
        (-[WebFrame _createItem]):  Create a single BF item.
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]):  Create a tree of BF items, which
	mirror the frame tree.
        (-[WebFrame _immediateChildFrameNamed:]):  New frame search utility (doesn't recurse)
        (-[WebFrame _detachFromParent]):  Save the scroll position when detaching a frame.
        (-[WebFrame _transitionToCommitted]):  Maintain new item ivars.  Save scroll position when
	appropriate.  Hook up items for child frames to their parent, as they are created.
        (-[WebFrame _setState:]):  Clear previousItem whenever we reach committed.
        (-[WebFrame _isLoadComplete]):  Clear previousItem if we are committed.
        (-[WebFrame _childFramesMatchItem:]):  Does the frame's frame tree match the one held by the item?
        (-[WebFrame _loadItem:fromItem:withLoadType:]):  Only do simple anchor navigation if the frame
	has no children (fixes oddball corner case with a frame reloading itself).  Set provisional item.
        (-[WebFrame _recursiveGoToItem:fromItem:withLoadType:]):  Heart of returning to an item that had
	frames.  We either find that the existing content is good, or initiate a load.
        (-[WebFrame _goToItem:withLoadType:]):  Adjust the BF list cursor, and recurse to do the work.
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):  Only do anchor-style nav if
	the destination URL has a fragment.  Save scroll position.
        (-[WebFrame _loadURL:intoChild:]):  If returning to an item with frames, possibly replace the
	new content with the stuff that was there at the time, substituting the URL.
        (-[WebFrame _saveScrollPositionToItem:]):  Don't croak on nil item or view.
        (-[WebFrame _restoreScrollPosition]):  Do croak (ASSERT) on nil item.
        (-[WebFrame _scrollToTop]):  Nit cleanup.
        (-[WebFrame _addFramePathToString:]):  Add a component for our frame to the frame name we're generating.
        (-[WebFrame _generateFrameName]):  Generate a frame name that is repeatable.
        (-[WebFrame _itemForSavingDocState]):  Returns correct item to use for formstate save.
        (-[WebFrame _itemForRestoringDocState]):  Returns correct item to use for formstate restore

2002-11-11  Maciej Stachowiak  <mjs@apple.com>

	Store path and the fact that we're downloading in the data source,
	instead of storing the content policy.
	
        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler cleanUpAfterFailure]):
        (-[WebDownloadHandler createFileIfNecessary]):
        (-[WebDownloadHandler finishedLoading]):
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _downloadURL:withContentPolicy:]):
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        (+[WebDataSource registerRepresentationClass:forMIMEType:]):
        (-[WebDataSource isDownloading]):
        (-[WebDataSource downloadPath]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _commitIfReady]):
        (-[WebDataSource _setIsDownloading:]):
        (-[WebDataSource _setDownloadPath:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):

2002-11-11  Maciej Stachowiak  <mjs@apple.com>

	Don't ask for the content policy any more if the previous policies
	said to save - in effect this means to ask only if the previous
	policies said to use the content policy. Also, remove now-useless
	previous content policy parameter from content policy delegate.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
	(-[WebDataSource _setContentPolicy:]): Retain new policy before
	releasing the old one.
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebMainResourceClient.m:
	(-[WebMainResourceClient handle:didReceiveResponse:]): Don't ask
	for content policy if the delegate already decided to save.

2002-11-11  Maciej Stachowiak  <mjs@apple.com>

	Added new policy delegate callback to get the filename - this
	won't be up to the content policy any more.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate saveFilenameForResponse:andRequest:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-11-11  Darin Adler  <darin@apple.com>

	- made some improvements to cursor setting for greater speed and correctness

        * WebView.subproj/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView setCursor:]): Just use setDocumentCursor: instead of
	our own logic. This allows us to remove code and may fix some bugs or anomalies as well.
        (-[WebDynamicScrollBarsView dealloc]): Release the cursor. I think we were leaking before.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView viewWillMoveToSuperview:]): Use _frameOrBoundsChanged: method now, which
	has been moved into the private file.
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]): Don't bother finding
	topmost WebHTMLView to call _updateMouseoverWithEvent: on; now it works fine no matter
	which level it's called at.

        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _frameOrBoundsChanged:]): Moved the code here that was formerly in the
	_setNeedsLayoutIfSizeChanged method, also added code that does _updateMouseoverWithEvent:
	so that we get properly updated cursor when we scroll.
        (-[WebHTMLView _updateMouseoverWithEvent:]): Remove unneeded assert. This method works
	equally well no matter which WebHTMLView calls it; everything is done at the window and
	controller level.

        * WebView.subproj/WebControllerPrivate.h: Added lastElementWasNotNil field and
	_mouseDidMoveOverElement:modifierFlags: method.
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _mouseDidMoveOverElement:modifierFlags:]): Call through to the delegate,
	but don't do multiple calls if they are all nil.

        * WebCoreSupport.subproj/WebBridge.m: Remove unused modifierTrackingEnabled method.
        * WebView.subproj/WebHTMLViewPrivate.h: Remove unused _setModifierTrackingEnabled and
	_modifierTrackingEnabled methods.

2002-11-10  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2002-11-10  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3021681 - downloaded files' creation and modification dates are not set

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler createFileIfNecessary]): call [response creationDate] and [response lastModifiedDate] when setting file attributes.
        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream setResponse:]): call [response lastModifiedDate] when giving content to plug-ins.

2002-11-10  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2002-11-09  Darin Adler  <darin@apple.com>

	- fixed 3095156 -- reproducible leak of WebDataSource due to bad URL in stylesheet

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
	Check for errors by looking at the return value from loadWithRequest: rather than
	making a separate call to canInitWithRequest.

        * WebView.subproj/WebBaseResourceHandleDelegate.h: Add boolean success/failure result
	loadWithRequest:.
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate loadWithRequest:]): Return NO if we fail to make a handle.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _startLoading]):
	Check result of loadWithRequest: and complain if it's NO.

        * WebView.subproj/WebMainResourceClient.m: Tweak whitespace.

2002-11-09  Chris Blumenberg  <cblu@apple.com>

	Fixed: 2991610 - Alexander should support services, including Speech

        * WebView.subproj/WebHTMLView.m:
        (+[WebHTMLView initialize]): register for service types
        (-[WebHTMLView dealloc]): moved to top of file
        (-[WebHTMLView copy:]): call _writeSelectionToPasteboard
        (-[WebHTMLView writeSelectionToPasteboard:types:]): call _writeSelectionToPasteboard
        (-[WebHTMLView validRequestorForSendType:returnType:]): return self for our pboard types
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebHTMLViewPrivate.m:
        (+[WebHTMLView _pasteboardTypes]): new, returns the array of supported pboard types 
        (-[WebHTMLView _writeSelectionToPasteboard:]): new, adds data to pboard
        * WebView.subproj/WebImageView.m:
        (-[WebImageView initialize]): register for service types
        (-[WebImageView validateUserInterfaceItem:]): respond to copy
        (-[WebImageView validRequestorForSendType:returnType:]): return self for images
        (-[WebImageView writeImageToPasteboard:]): writes image data to pboard
        (-[WebImageView copy:]): calls writeImageToPasteboard
        (-[WebImageView writeSelectionToPasteboard:types:]): calls writeImageToPasteboard

2002-11-08  Darin Adler  <darin@apple.com>

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem setTitle:]): Use display title if it matches, so
	we don't end up with two identical strings, as when reading from
	the property list.
        (-[WebHistoryItem setDisplayTitle:]): The same thing, the other way round.

2002-11-08  Darin Adler  <darin@apple.com>

	- fixed 3095078 -- image loop counts still not handled right

        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer blockHasGIFExtensionSignature:length:]): Look for the tag
	"NETSCAPE2.0", not "NETSCAPE1.0".
        (-[WebImageRenderer nextFrame:]): Remove special handling for last frames with
	a duration of 0. That was just a misunderstanding.

2002-11-08  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _setRequest:]):
	Slightly better fix. Essentially just take out the assert.

2002-11-08  Darin Adler  <darin@apple.com>

	- fixed an assert I am seeing a lot

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _setRequest:]): Oops.

2002-11-08  Richard Williamson   <rjw@apple.com>

        Solved missing glyph problem, but it's very slow, so
        it's disabled for now.  I'll turn back on after extending
        the character to glyph map in each renderer to include
        substituted font.
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer substituteFontForString:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):

2002-11-08  Darin Adler  <darin@apple.com>

	- separate WebBaseNetscapePluginStream more cleanly from its subclasses
	by making most fields private

        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream setResponse:]):
        * Plugins.subproj/WebNetscapePluginStream.h:
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:]):
        (-[WebNetscapePluginStream dealloc]):
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:didReceiveResponse:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        (-[WebSubresourceClient handle:didFailLoadingWithError:]):
        (-[WebSubresourceClient cancel]):
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):
        (-[WebBaseResourceHandleDelegate handle:didFailLoadingWithError:]):
        (-[WebBaseResourceHandleDelegate _cancelWithError:]):
        (-[WebBaseResourceHandleDelegate cancel]):
        (-[WebBaseResourceHandleDelegate cancelQuietly]):
        (-[WebBaseResourceHandleDelegate cancelledError]):
        (-[WebBaseResourceHandleDelegate notifyDelegatesOfInterruptionByPolicyChange]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient cancel]):
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient notifyDelegatesOfInterruptionByPolicyChange]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):

2002-11-08  Darin Adler  <darin@apple.com>

	- changed persistent dictionaries to use NSString instead of NSURL
	because of impact on memory footprint

	Also changed WebIconDatabase code to verify what it reads from disk,
	and ignore it if it can't verify the format.

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase iconForSiteURL:withSize:cache:]):
        (-[WebIconDatabase retainIconForSiteURL:]):
        (-[WebIconDatabase releaseIconForSiteURL:]):
        (-[WebIconDatabase _iconDictionariesAreGood]):
        (-[WebIconDatabase _loadIconDictionaries]):
        (-[WebIconDatabase _updateFileDatabase]):
        (-[WebIconDatabase _hasIconForSiteURL:]):
        (-[WebIconDatabase _iconsForIconURLString:]):
        (-[WebIconDatabase _setIcon:forIconURL:]):
        (-[WebIconDatabase _setIconURL:forSiteURL:]):
        (-[WebIconDatabase _setBuiltInIconAtPath:forHost:]):
        (-[WebIconDatabase _retainIconForIconURLString:]):
        (-[WebIconDatabase _releaseIconForIconURLString:]):
        (-[WebIconDatabase _retainFutureIconForSiteURL:]):
        (-[WebIconDatabase _releaseFutureIconForSiteURL:]):
        (-[WebIconDatabase _retainOriginalIconsOnDisk]):
        (-[WebIconDatabase _releaseOriginalIconsOnDisk]):
        (-[NSEnumerator _web_isAllStrings]):
        * Panels.subproj/WebStandardPanels.m:
        (-[WebStandardPanels didStartLoadingURL:inWindow:]):
        (-[WebStandardPanels didStopLoadingURL:inWindow:]):
        (-[WebStandardPanels _didStartLoadingURL:inController:]):
        (-[WebStandardPanels _didStopLoadingURL:inController:]):
        (-[WebStandardPanels frontmostWindowLoadingURL:]):

2002-11-08  Darin Adler  <darin@apple.com>

	- fixed crash on boot that Don was seeing

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem URL]): Make this work when _URLString is nil.
        (-[WebHistoryItem initFromDictionaryRepresentation:]): Make this work for nil URL.

	- my own private war on the cString method

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler initWithDataSource:]): Use %@ in LOG to avoid cString.
        (-[WebDownloadHandler finishedLoading]): Ditto.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _commitIfReady]): Ditto.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _timedLayout:]): Ditto.
        (-[WebFrame _setState:]): More of the same.
        (-[WebFrame _isLoadComplete]): Ditto.

2002-11-08  Ken Kocienda  <kocienda@apple.com>

	Fix deployment build breaker: a variable was used only in a 
	LOG statement, causing the variable to become usused when
	building with the Deployment build style. 

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler finishedLoading])

2002-11-07  Darin Adler  <darin@apple.com>

        * History.subproj/WebHistoryItem.h: Replace _URL with _URLString.

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem _retainIconInDatabase:]): Get the URL with [self URL].
        (-[WebHistoryItem initWithURL:target:parent:title:]): Set up _URLString.
        (-[WebHistoryItem dealloc]): Release _URLString.
        (-[WebHistoryItem URL]): Make a URL from _URLString.
        (-[WebHistoryItem icon]): Use [self URL] instead of _URL.
        (-[WebHistoryItem setURL:]): Store a URL string.
        (-[WebHistoryItem hash]): Use the URL string's hash.
        (-[WebHistoryItem isEqual:]): Compare the URL strings.
        (-[WebHistoryItem description]): Use _URLString.
        (-[WebHistoryItem dictionaryRepresentation]): Use _URLString.
        (-[WebHistoryItem initFromDictionaryRepresentation:]): Call through to
	the other init functions so we have only one designated initializer.
	Leave the date as nil if there's no date in the dictionary instead of
	setting the date to 0.

2002-11-07  Maciej Stachowiak  <mjs@apple.com>

	Removed SaveAndOpenExternally policy.
	
        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler finishedLoading]):
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):

2002-11-07  Chris Blumenberg  <cblu@apple.com>

        * WebKit.pbproj/project.pbxproj:

2002-11-07  Richard Williamson  <rjw@apple.com>

        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer stopAnimation]):

2002-11-07  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3095628 - REGRESSION: exception when clicking on link to load content into iframe
	
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _actionInformationForNavigationType:event:]): Get the
	element info from the HTML view where the click originally
	happened, not the current document view. Add some asserts to make
	sure this is working.


2002-11-07  Richard Williamson  <rjw@apple.com>

        Tweaks
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer convertCharacters:length:toGlyphs:skipControlCharacters:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):

=== Alexander-31 ===

2002-11-07  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3094778 - REGRESSION: Assert on logout from schwab.com

	(probably fixed it anyway - I'm flying blind on this one)
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:frameName:]): Use a nil request
	if the URL was nil, instead of making a request that contains a
	nil URL.

2002-11-07  Maciej Stachowiak  <mjs@apple.com>

	Changed things so that creating a window takes a request rather
	than a URL and referrer.
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:frameName:]):
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _openNewWindowWithRequest:behind:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _setTriggeringEvent:]):
        (-[WebDataSource _triggeringEvent]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate openNewWindowWithURL:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame setProvisionalDataSource:]):
        (-[WebFrame findOrCreateFramedNamed:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):
        * WebView.subproj/WebWindowOperationsDelegate.h:

2002-11-06  Darin Adler  <darin@apple.com>

	- fixed problem where files small enough to fit entirely in the buffer
	(8K or less) would not be decoded

        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler decodeData:]): Added. Moved most of the code from
	receivedData into here.
        (-[WebDownloadHandler receivedData:]): Changed to call decodeData.
        (-[WebDownloadHandler finishedLoading]): Call decodeData on any remaining
	bytes rather than writing them straight out to the data fork.

2002-11-06  Richard Williamson  <rjw@apple.com>

        More work on rendering scripts. Now most complex scripts render correctly.
        Working new features include:
        bidi, diacriticals, cursive forms, and arabic ligatures.
        Selection of text rendered in these scripts, is however, not working. 
        Also, line height is incorrect when renderering combined below glyphs.
        ajami is, sadly, horrendously broken.

        * Misc.subproj/WebUnicode.m:
        (glyphVariantLogical):
        (shapedString):
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):

2002-11-06  John Sullivan  <sullivan@apple.com>

        * Bookmarks.subproj/WebBookmark.m:
        (+[WebBookmark bookmarkOfType:]):
	made this handle WebBookmarkTypeProxy

2002-11-06  Darin Adler  <darin@apple.com>

	- fixed bug that affected BinHex-encoded files with no resource fork

        * Downloads.subproj/WebBinHexDecoder.m:
        (-[WebBinHexDecoder decodeData:dataForkData:resourceForkData:]):
	Don't decode the resource fork unless done with the data fork.

        * Downloads.subproj/WebDownloadHandler.m: (-[WebDownloadHandler receivedData:]):
	Set the forks to nil before calling through.

2002-11-06  Darin Adler  <darin@apple.com>

        * Downloads.subproj/WebMacBinaryDecoder.m: (+[WebMacBinaryDecoder canDecodeHeaderData:]):
	Fix == 129 check that was supposed to be <= 129.

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-11-06  Darin Adler  <darin@apple.com>

        * Downloads.subproj/WebBinHexDecoder.m: (-[WebBinHexDecoder decodeIntoBuffer:size:]):
	Fix an off-by-one error handling repeat counts.

        * WebKit.pbproj/project.pbxproj: Fix group name I accidentally mangled.

2002-11-06  Darin Adler  <darin@apple.com>

	- added a BinHex decoder and did a little work on the MacBinary decoder
        
        I'm not supposed to be working on this, but I didn't feel like doing "real" work.

        * Downloads.subproj/WebBinHexDecoder.h: Added.
        * Downloads.subproj/WebBinHexDecoder.m: Added.
        * WebKit.pbproj/project.pbxproj: Added WebBinHexDecoder.

        * Downloads.subproj/WebDownloadDecoder.h: Added WEB_DOWNLOAD_DECODER_MINIMUM_HEADER_LENGTH.
        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler closeFile]): Check to be sure we don't close the same file twice.

        * Downloads.subproj/WebMacBinaryDecoder.h: Added _scriptCode.
        * Downloads.subproj/WebMacBinaryDecoder.m:
        (+[WebMacBinaryDecoder canDecodeHeaderData:]): Added check of MacBinary version field.
        (-[WebMacBinaryDecoder decodeData:dataForkData:resourceForkData:]): Added MacBinary III
	part that gets the script code.
        (-[WebMacBinaryDecoder filename]): Use the script code.

2002-11-06  Maciej Stachowiak  <mjs@apple.com>

	Took URL field out of click policy - open in new window policy
	will always open the request URL.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        (-[WebPolicyPrivate dealloc]):
        (+[WebURLPolicy webPolicyWithURLAction:]):
        (+[WebFileURLPolicy webPolicyWithFileAction:]):
        (+[WebContentPolicy webPolicyWithContentAction:andPath:]):
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate clickPolicyForAction:andRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):

2002-11-06  Chris Blumenberg  <cblu@apple.com>

	Support MacBinary I by checking that bytes 99-127 are 0. Also check byte 82 for all formats.

        * Downloads.subproj/WebMacBinaryDecoder.m:
        (+[WebMacBinaryDecoder canDecodeHeaderData:]):

2002-11-06  Ken Kocienda  <kocienda@apple.com>

	Call new WebHTTPResourceRequest method to set the amount of time
	to cache a 404 response when trying to fetch a favicon.

	This change helps to fix this bug:

	Radar 3004422 (Loader should cache misses)

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader startLoading])

2002-11-05  Maciej Stachowiak  <mjs@apple.com>

	Reworked clickPolicy arguments to be closer to proposed version.
	
        * WebKit.exp:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.m:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate clickPolicyForAction:andRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _actionInformationForNavigationType:event:]):
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):

2002-11-05  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebTextRenderer.m: Made a slightly simpler and faster
	version of the new "lose precision" CEIL_TO_INT macro.

2002-11-05  Richard Williamson  <rjw@apple.com>

        Fixed a couple of issues that Dave highlighted w/ his whitespace
        fixes.  CG sometimes introduces very small 'error' in metrics, specifically
        we saw character widths of 20.0000019 that should have been 20.  As a 
        work-around we loose precision beyond the 1000th place.  Also, always
        ceil spaces.
                
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):

2002-11-05  Darin Adler  <darin@apple.com>

	- fixed 3084704 -- crash in HTMLTokenizer on page with JavaScript
	HTMLDocument::Close inside a <script>

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _detachFromParent]):
	We need to stop loading here. Otherwise we might do loading after closeURL,
	which could lead to a problem like the one above.

2002-11-05  Darin Adler  <darin@apple.com>

	- changed our MacBinary decoding to not pay any attention to the comment

	Before we would "fail to decode" if the comment was truncated, now we just
	don't worry about it.

        * Downloads.subproj/WebMacBinaryDecoder.h: Remove _commentLength and _commentEnd.
        * Downloads.subproj/WebMacBinaryDecoder.m:
        (-[WebMacBinaryDecoder decodeData:dataForkData:resourceForkData:]): Remove code
	to get _commentLength and code to compute _commentEnd.
        (-[WebMacBinaryDecoder finishDecoding]): Check offset against the resource fork
	end rather than the comment end to see if we got enough data.

2002-11-05  John Sullivan  <sullivan@apple.com>

        * Resources/url_icon.tiff:
	reverted generic URL icon back to the one that
	looks like a document until we get something from
	HI that SJ likes

2002-11-05  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3074108 - Decode macbinary files during download

        * Downloads.subproj/WebDownloadDecoder.h:
        * Downloads.subproj/WebDownloadHandler.h:
        * Downloads.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler initWithDataSource:]):
        (-[WebDownloadHandler dealloc]):
        (-[WebDownloadHandler decodeHeaderData:dataForkData:resourceForkData:]):
        (-[WebDownloadHandler decodeData:dataForkData:resourceForkData:]):
        (-[WebDownloadHandler closeFile]):
        (-[WebDownloadHandler cleanUpAfterFailure]):
        (-[WebDownloadHandler createFileIfNecessary]):
        (-[WebDownloadHandler writeData:toFork:]):
        (-[WebDownloadHandler writeDataForkData:resourceForkData:]):
        (-[WebDownloadHandler dataIfDoneBufferingData:]):
        (-[WebDownloadHandler receivedData:]):
        (-[WebDownloadHandler finishDecoding]):
        (-[WebDownloadHandler finishedLoading]):
        (-[WebDownloadHandler cancel]):
        * Downloads.subproj/WebMacBinaryDecoder.h:
        * Downloads.subproj/WebMacBinaryDecoder.m:
        (-[WebMacBinaryDecoder decodeData:dataForkData:resourceForkData:]):
        (-[WebMacBinaryDecoder fileAttributes]):
        (-[WebMacBinaryDecoder filename]):
        * Misc.subproj/WebKitErrors.h: added new errors
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]): don't send response to download handler
        (-[WebMainResourceClient handle:didReceiveData:]): watch for decoding errors

2002-11-05  Ken Kocienda  <kocienda@apple.com>

	Fix for this bug:

	Radar 3092747 (javascript cookieEnabled property returns incorrect value)

	Now, we return "true" for navigator.cookieEnabled when 
	"Only accept cookies from the same domain as the current page" option
	is selected is user preferences.

        * WebCoreSupport.subproj/WebCookieAdapter.m:
        (-[WebCookieAdapter cookiesEnabled])

2002-11-05  John Sullivan  <sullivan@apple.com>

	- fixed 3091271 -- missing plug-in icon is on white
	background, not transparent.

        * Resources/nullplugin.tiff: Photoshopped the white away. It's
	still ugly, but that's a separate bug (3091274)

2002-11-05  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3083732 - SJ: window comes out blank on samsung site
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Don't start loading if the URL is exactly the same as the parent
	URL. We may need a more stringent check, but this seems to match
	the tolerance of other browsers OK.

2002-11-05  Maciej Stachowiak  <mjs@apple.com>

	Added request and frame to click policy callback.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate clickPolicyForElement:button:modifierFlags:request:inFrame:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:request:]):
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):

2002-11-04  Richard Williamson  <rjw@apple.com>

        Changes to support cursive letter forms.  It works, but I've
        disabled it for now.  It's buggy and needs cleanup.
        Arabic now renders correctly except for ligature substitution.
        
        * Misc.subproj/WebUnicode.h:
        * Misc.subproj/WebUnicode.m:
        (_unicodeIsMark):
        (getShape):
        (prevChar):
        (nextChar):
        (prevLogicalCharJoins):
        (nextLogicalCharJoins):
        (glyphVariantLogical):
        (shapedString):
        * Misc.subproj/WebUnicodeTables.m:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):
        * WebKitPrefix.h:

2002-11-04  Maciej Stachowiak  <mjs@apple.com>

	Changes to send NSEvents all the way through WebCore and then pass
	them back out to WebKit, so that click policy can have a
	WebResourceRequest added.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:reload:triggeringEvent:]):
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _continueAfterClickPolicyForEvent:]):
        (-[WebFrame _loadURL:loadType:clientRedirect:triggeringEvent:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseUp:]):
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebHTMLViewPrivate.m:

2002-11-04  Chris Blumenberg  <cblu@apple.com>

	Fixed - 3091658: REGRESSION: cmd-left for back doesn't work in plain-text viewer

	We now pass text field key events to the next responder which would be WebView in this case.

        * WebView.subproj/WebTextView.m:
        (-[WebTextView keyDown:]):
        (-[WebTextView keyUp:]):

2002-11-04  Darin Adler  <darin@apple.com>

	- fixed 3090257 -- "leak the world" using the Wallace and Gromit "console"

        * Plugins.subproj/WebNetscapePluginStream.m: Update for changes to the base delegate.
        (-[WebNetscapePluginStream start]): Use loadWithRequest:.
        (-[WebNetscapePluginStream stop]): Call cancel instead of just canceling the handle
	directly. This fixes the world leak.
        (-[WebNetscapePluginStream cancel]): Do some of the work that was formerly in "stop".

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]): Call the "stop loading URL" whenever
	we cancel I/O, so we don't leak the world.
        (-[WebMainResourceClient handle:didReceiveResponse:]): Ditto.

        * WebCoreSupport.subproj/WebBridge.m: (-[WebBridge objectLoadedFromCache:response:size:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m: (-[WebSubresourceClient handleDidFinishLoading:]):
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _finishedLoadingResourceFromDataSource:]):
	Fix a typo in the word "finished".

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]): Tweak.
        (-[WebBaseResourceHandleDelegate cancel]): Tweak.

        * Panels.subproj/WebStandardPanels.m:
        (-[WebStandardPanels didStartLoadingURL:inWindow:]): Add assertions.
        (-[WebStandardPanels didStopLoadingURL:inWindow:]): Ditto.
        (-[WebStandardPanels _didStartLoadingURL:inController:]): Ditto.
        (-[WebStandardPanels _didStopLoadingURL:inController:]): Ditto.

2002-11-04  Darin Adler  <darin@apple.com>

        * Downloads.subproj/WebMacBinaryDecoder.h: Removed many unneeded fields.
        * Downloads.subproj/WebMacBinaryDecoder.m:
        (+[WebMacBinaryDecoder canDecodeHeaderData:]): Added comments. Changed maximum filename
	length to 63 as the format supports, rather than the 31 that's based on historical
	HFS limitations. Fix endian dependency in CRC check.
        (-[WebMacBinaryDecoder decodeData:dataForkData:resourceForkData:]): Simplified this,
	and removed the state machine and the accumulator. Also added some asserts. Fixed endian
	dependency in the code to extract the header.
        (-[WebMacBinaryDecoder finishDecoding]): New simpler check now that we don't have a
	_streamComplete boolean.
        (-[WebMacBinaryDecoder fileAttributes]): Rewrote to take advantage of the above changes,
	and also to use kCFAbsoluteTimeIntervalSince1904 rather than parsing a date string.

        * Downloads.subproj/crc16.h: Tweaks.
        * Downloads.subproj/crc16.m: Tweaks.

2002-11-04  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebImageRenderer.m: (-[WebImageRenderer dealloc]):
	Replaced a useless call to stopAnimation with a couple of asserts.

2002-11-04  John Sullivan  <sullivan@apple.com>

        * Resources/url_icon.tiff:
	new "generic URL" icon from HI -- this one looks like
	a red ribbon (!)

2002-11-03  Darin Adler  <darin@apple.com>

        * Plugins.subproj/WebPluginError.h:
        * Plugins.subproj/WebPluginError.m:
	Not __MyCompanyName__, but rather Apple Computer.

2002-11-03  Darin Adler  <darin@apple.com>

        * Plugins.subproj/WebPlugin.h: Fix comment.

        * Plugins.subproj/WebPluginError.m: (-[WebPluginErrorPrivate dealloc]):
	Fix leak by calling [super dealloc].

        * WebView.subproj/WebFramePrivate.m: (-[WebFramePrivate dealloc]): Remove the
	timer invalidate since, as Trey pointed out, it's pointless to invalidate a
	timer in dealloc if it's retaining this object while valid.

2002-11-03  Chris Blumenberg  <cblu@apple.com>

	- Added MacBinary decoding code. Not yet used.

        * Downloads.subproj/WebMacBinaryDecoder.h: Added.
        * Downloads.subproj/WebMacBinaryDecoder.m: Added.
        (+[WebMacBinaryDecoder canDecodeHeaderData:]):
        (-[WebMacBinaryDecoder init]):
        (-[WebMacBinaryDecoder dealloc]):
        (-[WebMacBinaryDecoder decodeData:dataForkData:resourceForkData:]):
        (-[WebMacBinaryDecoder finishDecoding]):
        (-[WebMacBinaryDecoder fileAttributes]):
        * Downloads.subproj/crc16.h: Added.
        * Downloads.subproj/crc16.m: Added.
        (CRC16):
        * Plugins.subproj/WebPluginPackage.m:
        (-[WebPluginPackage isLoaded]): 
        * WebKit.pbproj/project.pbxproj:

2002-11-03  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent
	changes both to the code here and to the extract script.

2002-11-03  Darin Adler  <darin@apple.com>

	- fixed 3091300 -- "prelighting" on local page is still slow, despite recent bug fix

	Turns out all updating would be slow if any resources on the page failed to load.

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
	Call the new reportError instead of cancel.
        (-[WebSubresourceClient handle:didFailLoadingWithError:]): Ditto.

2002-11-02  Darin Adler  <darin@apple.com>

        * Panels.subproj/WebAuthenticationPanel.m: (-[WebAuthenticationPanel setUpForRequest:]):
	Do the previous fix one better by using _web_hostWithPort.

2002-11-02  Darin Adler  <darin@apple.com>

	- fixed bug where the address of an NSNumber object would be used for the port number

        * Panels.subproj/WebAuthenticationPanel.m: (-[WebAuthenticationPanel setUpForRequest:]):
	Call intValue on the object returned from [NSURL port].

2002-11-01  Darin Adler  <darin@apple.com>

        * Plugins.subproj/WebBaseNetscapePluginView.m: (-[WebBaseNetscapePluginView sendEvent:]):
	Fixed uninitialized variable problem.

2002-11-01  Darin Adler  <darin@apple.com>

	- fixed 3090239 -- crash on window close

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _detachFromParent]): Nil out the bridge and
	release it so we don't close the URL twice.

	- fixed 3058598 -- animated gif animates repeatedly in Alex, but only once in other browsers

        * WebCoreSupport.subproj/WebImageRenderer.h: Added fields used by bug workaround.
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer blockHasGIFExtensionSignature:length:]): Helper method for bug workaround.
        (-[WebImageRenderer checkDataForGIFExtensionSignature:]): Checks incoming data for the GIF
	extension signatures.
        (-[WebImageRenderer initWithData:]): Override to call checkDataForGIFExtensionSignature.
        (-[WebImageRenderer incrementalLoadWithBytes:length:complete:]): Call checkDataForGIFExtensionSignature.
        (-[WebImageRenderer repetitionCount]): Return 1 if we were going to return 0, but we didn't see a
	GIF extension signature. This workaround can be removed once we require a system new enough to have
	the bug fix for bug 3090341.
        (-[WebImageRenderer nextFrame:]): Stop on last frame, don't wrap around to first.

        * WebCoreSupport.subproj/WebImageRendererFactory.h: Update for changes to WebCore.
        * WebCoreSupport.subproj/WebImageRendererFactory.m: Tweaks.

        * WebView.subproj/WebImageRepresentation.m: Update imports.
        * WebView.subproj/WebImageView.m: Update imports.

2002-11-01  Richard Williamson   <rjw@apple.com>

        Implemented rendering of diacriticals.
        
        * Misc.subproj/WebUnicode.h:
        * Misc.subproj/WebUnicode.m:
        (_unicodeDigitValue):
        (_unicodeCategory):
        (_unicodeDirection):
        (_unicodeJoining):
        (_unicodeDecompositionTag):
        (_unicodeMirrored):
        (_unicodeCombiningClass):
        (_unicodeLower):
        (_unicodeUpper):
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):
        (-[WebTextRenderer extendCharacterToGlyphMapToInclude:]):

2002-11-01  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-11-01  Chris Blumenberg  <cblu@apple.com>

	Check that the plug-in is loaded before calling it.

        * Plugins.subproj/WebBaseNetscapePluginStream.h:
        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream dealloc]):
        (-[WebBaseNetscapePluginStream setPluginPointer:]):
        (-[WebBaseNetscapePluginStream setResponse:]):
        (-[WebBaseNetscapePluginStream receivedData:]):
        (-[WebBaseNetscapePluginStream destroyStreamWithReason:]):
        (-[WebBaseNetscapePluginStream finishedLoadingWithData:]):
        * Plugins.subproj/WebBasePluginPackage.h:
        * Plugins.subproj/WebBasePluginPackage.m:
        (-[WebBasePluginPackage isLoaded]):
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]):
        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage isLoaded]):
        * Plugins.subproj/WebNetscapePluginRepresentation.m:
        (-[WebNetscapePluginRepresentation receivedData:withDataSource:]):

2002-11-01  Chris Blumenberg  <cblu@apple.com>

	- Moved plug-in error handling to WebResourceLoadDelegate
	- Report plug-in load failure, java load failure, and plug-in not found errors.
	- Added WebPluginError, subclass of WebError.
	- Attempted fix: 3090675 - Standalone WMP (Window Media Player) content crashes Alexander

        * English.lproj/Localizable.strings:
        * Misc.subproj/WebKitErrors.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView sendEvent:]): don't send event to null function
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]): report plug-in load failure
        * Plugins.subproj/WebNullPluginView.h:
        * Plugins.subproj/WebNullPluginView.m: take a WebPluginError
        (-[WebNullPluginView dealloc]):
        (-[WebNullPluginView viewDidMoveToWindow]):
        * Plugins.subproj/WebPluginError.h: Added.
        * Plugins.subproj/WebPluginError.m: Added.
        (-[WebPluginErrorPrivate dealloc]):
        (-[WebPluginError dealloc]):
        (-[WebPluginError pluginPageURL]):
        (-[WebPluginError pluginName]):
        (-[WebPluginError MIMEType]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:MIMEType:]): report plug-in load failure
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]): report plug-in load failure
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.m:
        (-[WebResourceLoadDelegate pluginFailedWithError:dataSource:]): added, does nothing
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebResourceLoadDelegate.h:
        * WebView.subproj/WebView.m:
        (+[WebView initialize]): added new error strings

2002-11-01  John Sullivan  <sullivan@apple.com>

	- some weaning of WebBookmark API from WebBookmarkGroup

        * Bookmarks.subproj/WebBookmark.m:
        (-[WebBookmark dealloc]):
	set group to nil instead of asserting that it's non-nil

        * Bookmarks.subproj/WebBookmarkGroup.h:
	removed obsolete ivar _bookmarksByID
        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup initWithFile:]):
	removed obsolete ivar _bookmarksByID
        (-[WebBookmarkGroup dealloc]):
	removed obsolete ivar _bookmarksByID
        (-[WebBookmarkGroup removeBookmark:]):
	removed this unnecessary method; callers need to use
	[[bookmark parent] removeChild:bookmark] instead

2002-11-01  Trey Matteson  <trey@apple.com>

	Moved involved code for loading URLs from WebBridge up to WebFrame, with a little
	consolidation along the way.  I need to get all this stuff in one place in prep
	for doing back-forward properly with frames.  There should be no change in
	functionality as a result of these changes.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:reload:]):
        (-[WebBridge postWithURL:data:contentType:]):
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Much of the guts of these is moved to WebFramePrivate.
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setIsClientRedirect:]):
        (-[WebDataSource _isClientRedirect]):
	Keep state of whether we're processing a redirect in DataSource.  I had previously
	to do this with a loadType, but that failed because cliRedir is orthogonal.
        * WebView.subproj/WebFramePrivate.h:
	WebFrameLoadTypeClientRedirect is gone.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate init]):
	Initialize loadType explicitly.
        (-[WebFrame _transitionToCommitted]):
	Test [dataSource _isClientRedirect] instead of looking at loadType.
        (-[WebFrame _isLoadComplete]):
	Nuke WebFrameLoadTypeClientRedirect
        (-[WebFrame _goToItem:withFrameLoadType:]):
	Nuke WebFrameLoadTypeClientRedirect.
        (-[WebFrame _loadRequest:]):
	Helper method moved from WebBridge.
        (-[WebFrame _loadURL:loadType:clientRedirect:]):
	Core impl moved up from WebBridge.
        (-[WebFrame _postWithURL:data:contentType:]):
	Core impl moved up from WebBridge.

2002-11-01  Darin Adler  <darin@apple.com>

	- implemented loop counts

        * WebCoreSupport.subproj/WebImageRenderer.h: Added repetitionsComplete field.
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer repetitionCount]): Get NSImageLoopCount.
        (-[WebImageRenderer nextFrame:]): Check repetitionCount and stop once we hit it.

2002-10-31  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebFrame.m: (-[WebFrame setController:]): Add an assert,
	hoping to catch a reported bug earlier or disprove one theory.

2002-10-31  Trey Matteson  <trey@apple.com>

	Added API to support 3072505 - SnapBack for user-entered page address
	Refixed 3041616 - Extra page added in back button history
	Previous fix was stepped on by a later checkin.  Re-established that fix, then
	went on to make sure we have the final URL and title in the BF item in the
	case of a client redirect.  Also handles redirects that happen within frames.
	Fixed 3078560 - div added to "back" list

        * History.subproj/WebBackForwardList.h:
        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList containsEntry:]):
	Added new API for 3072505.
        * WebCoreSupport.subproj/WebBridge.h:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge reportClientRedirectTo:delay:fireDate:]):
        (-[WebBridge reportClientRedirectCancelled]):
        (-[WebBridge loadURL:reload:]):
	Added logging.  Renamed flag.  Establish the right loadtype and set BF items
	from the old dataSource onto the new dataSource in the case of a client redirect.
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setRequest:]):
	Add logging.
        (-[WebDataSource _addBackForwardItem:]):
        (-[WebDataSource _addBackForwardItems:]):
        (-[WebDataSource _backForwardItems]):
	New setters/getters to support setting up the new dataSource of a client redirect.
        * WebView.subproj/WebFramePrivate.h:
	New loadType WebFrameLoadTypeClientRedirect.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
	Update the URL in the BF list in the client redirect case.
        (-[WebFrame _isLoadComplete]):
	NOP case for WebFrameLoadTypeClientRedirect
        (-[WebFrame _goToItem:withFrameLoadType:]):
	ASSERT_NOT_REACHED case for WebFrameLoadTypeClientRedirect

2002-10-31  Richard Williamson  <rjw@apple.com>

        Corrected extern definitions of lookup tables.
        
        * Misc.subproj/WebUnicode.h:
        * Misc.subproj/WebUnicode.m:
        (_unicodeDirection):
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (+[WebTextRenderer initialize]):

=== Alexander-30 ===

2002-10-30  Richard Williamson  <rjw@apple.com>

        More work on bidi and contextual forms.
        Table lookup code for unicode characters attributes.

        * Misc.subproj/WebUnicode.h: Added.
        * Misc.subproj/WebUnicode.m: Added.
        (_unicodeDigitValue):
        (_unicodeCategory):
        (_unicodeDirection):
        (_unicodeJoining):
        (_unicodeDecompositionTag):
        (_unicodeMirrored):
        (_unicodeMirroredChar):
        (_unicodeCombiningClass):
        (_unicodeLower):
        (_unicodeUpper):
        (WebKitInitializeUnicode):
        * Misc.subproj/WebUnicodeTables.m: Added.
        * WebKit.pbproj/project.pbxproj:

        Additional logging parameter.
        
        * Misc.subproj/WebKitLogging.h:
        * Misc.subproj/WebKitLogging.m:

2002-10-30  Maciej Stachowiak  <mjs@apple.com>

	Pass WebResourceRequest rather than just NSURL to URL policy
	delegate method.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (+[WebDefaultPolicyDelegate defaultURLPolicyForRequest:]):
        (-[WebDefaultPolicyDelegate URLPolicyForRequest:inFrame:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _shouldShowRequest:]):

2002-10-30  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2002-10-30  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3088122 - Assertion failure/crash closing window with QuickTime streaming in

        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setMainDocumentError:]): call receivedError on the representation.

2002-10-30  Darin Adler  <darin@apple.com>

	- fixed memory leaks in plugin package creation code

        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage initWithPath:]): Rearrange this code, and make sure
	that it does a [self release] if it's going to return nil instead of self.
        (-[WebNetscapePluginPackage unload]): Set bundle to 0 when we release it.
        (-[WebNetscapePluginPackage dealloc]): Release the bundle if it's not 0.

        * Plugins.subproj/WebPluginPackage.m:
        (-[WebPluginPackage initWithPath:]): Rearrange this code, and make sure
	that it does a [self release] if it's going to return nil instead of self.

2002-10-30  Darin Adler  <darin@apple.com>

	- fixed 3086564 -- REGRESSION: meta-refresh to the same page doesn't refresh

	The key is to respect the new reload: parameter from the bridge.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:reload:]): Don't ever treat a reload as a redirect.
	Set the cache policy to WebRequestCachePolicyLoadFromOrigin if it's a reload.

	- fixed 3087214 -- REGRESSION: <WebKit/WebKit.h> contains #import of non-existent header

        * Misc.subproj/WebKit.h: Removed import of WebControllerSets.h, which is private.

2002-10-30  Maciej Stachowiak  <mjs@apple.com>

	Another step towards the policy API change - add request argument
	to file URL policy and remove isDirectory argument.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate fileURLPolicyForMIMEType:andRequest:inFrame:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame setProvisionalDataSource:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _shouldShowRequest:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):

2002-10-29  Maciej Stachowiak  <mjs@apple.com>

	First step towards policy API change. Pass request instead of URL
	to content policy delegate method.
	
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-10-29  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3087548 - REGRESSION: two windows open for netflix confirmation
	
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _findFrameInThisWindowNamed:]): Added this function back,
	and added check for top-level frame name.
        (-[WebController _findFrameNamed:]): Use
	_findFrameInThisWindowNamed: to make sure top-level frame names
	get checked.

2002-10-29  Chris Blumenberg  <cblu@apple.com>

	Created Downloads.subproj to hold the to-be-implemented download decoders.

        * Downloads.subproj/WebDownloadDecoder.h: Added.
        * Downloads.subproj/WebDownloadHandler.h: Added.
        * Downloads.subproj/WebDownloadHandler.m: Added.
        (-[WebDownloadHandler initWithDataSource:]):
        (-[WebDownloadHandler dealloc]):
        (-[WebDownloadHandler errorWithCode:]):
        (-[WebDownloadHandler receivedResponse:]):
        (-[WebDownloadHandler receivedData:]):
        (-[WebDownloadHandler finishedLoading]):
        (-[WebDownloadHandler cancel]):
        * Misc.subproj/WebDownloadHandler.h: Removed.
        * Misc.subproj/WebDownloadHandler.m: Removed.
        * WebKit.pbproj/project.pbxproj:

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed crash I just introduced

        * Plugins.subproj/WebPluginDatabase.m: (-[WebPluginDatabase init]):
	Remove the release call here. When I added the autorelease, I didn't realize that
	the caller was doing a release.

2002-10-28  Trey Matteson  <trey@apple.com>

	Fixed 3041616 - Extra page added in back button history

	Client-side redirects would always put an extra item in the backforward list.
	According to Darin this is a regression all the way back from functionality moving
	from WebBrowser to WebKit.	

        * WebCoreSupport.subproj/WebBridge.h:
	Added state to know if we're doing an "internal" type of load
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge reportClientRedirectTo:delay:fireDate:]):
	Set internalLoad bit if delay==0
        (-[WebBridge reportClientRedirectCancelled]):
	Clear internalLoad
        (-[WebBridge loadURL:]):
	Set frame's loadType if doing an internal load (similar to what we do when loading
	child frames)

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed storage leak of WebNetscapePluginPackage objects

        * Plugins.subproj/WebBasePluginPackage.m:
        (+[WebBasePluginPackage pluginWithPath:]): Add missing autorelease.

        * Plugins.subproj/WebBasePluginPackage.h:
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        * Plugins.subproj/WebPluginPackage.h:
        * Plugins.subproj/WebPluginPackage.m:
	Not __MyCompanyName__, but rather Apple Computer.

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed bug that caused us to leak all WebResourceHandles used for subresources

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient dealloc]): Remove bogus "currentURL == nil" assert.
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
	Use the new loadWithRequest: call instead of making handle and doing loadWithDelegate:.
	This is where the leak was, because no one ever released the handle, but releasing it
	right away would be too soon.

        * WebView.subproj/WebBaseResourceHandleDelegate.h: Added defersCallbacks field,
	loadWithRequest: method, and setDefersCallbacks: method. Removed handle method.
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate loadWithRequest:]): New method. Sets up the handle,
	set the defersCallbacks state on it, and calls loadWithDelegate:.
        (-[WebBaseResourceHandleDelegate setDefersCallbacks:]): Stores defersCallbacks state,
	and also sets it on the handle, if any.
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]): Remove code to set up
	the handle, since we now do that at loadWithRequest: time.

        * WebView.subproj/WebDataSourcePrivate.h: Remove mainHandle field.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): Don't release mainHandle.
        (-[WebDataSource _setPrimaryLoadComplete:]): Ditto.
        (-[WebDataSource _startLoading]): Use loadWithRequest: on the client, no need to deal
	with the handle directly at all.
        (-[WebDataSource _addSubresourceClient:]): Call setDefersCallbacks: on the client.
        (-[WebDataSource _defersCallbacksChanged]): Ditto.

        * WebView.subproj/WebControllerPrivate.m: Remove unneeded include.
        * WebView.subproj/WebMainResourceClient.m: Ditto.

2002-10-28  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3056726 - View Source window always displays the source in current system encoding
	Fixed: 3019352 - Text encoding is not handled when viewing plain text

        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource stringWithData:]): added, creates a string using the specified encoding.
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation documentSource]): uses the bridge specified encoding when creating the string
        * WebView.subproj/WebTextView.h:
        * WebView.subproj/WebTextView.m:
        (-[WebTextView dataSourceUpdated:]): use stringWithData: 
        (-[WebTextView supportsTextEncoding]): Yup

2002-10-28  Richard Williamson   <rjw@apple.com>

        Fixed crasher.
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):

2002-10-28  John Sullivan  <sullivan@apple.com>

        * Bookmarks.subproj/WebBookmark.h:
        * Bookmarks.subproj/WebBookmark.m:
        (-[WebBookmark contentMatches:]): new method, returns YES if
	two bookmarks are the same, ignoring group and parent.

2002-10-28  Trey Matteson  <trey@apple.com>

	Finished 2998200 - access to most-recent in submenu of back & forward buttons

        * WebView.subproj/WebDataSourcePrivate.h:
	The BF items we are going to and from were moved here from
	WebFrame because of timing problems among multiple data sources
	when using the BF buttons during a load.
	In addition, the datasource has a list of relevant BF items for
	which it keeps their titles up to date.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
	Free new state.
        (-[WebDataSource _setTitle:]):
	Update titles of BF items.
        (-[WebDataSource _provisionalBackForwardItem]):
        (-[WebDataSource _setProvisionalBackForwardItem:]):
        (-[WebDataSource _previousBackForwardItem]):
        (-[WebDataSource _setPreviousBackForwardItem:]):
        (-[WebDataSource _addBackForwardItem:]):
	Maintain new state.
        (-[WebDataSource _commitIfReady]):
	Free up previous and provisional BF items after commit.
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:]):
	Add the new BF item to the datasource.
        (-[WebBridge saveDocumentState:]):
	Use the right BF item to save the doc state.
        * WebView.subproj/WebFramePrivate.h:
	Previous and provisional BF are moved to datasource.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
	Use provisional BF from datasource to set position in BF list.
	Add new BF item to datasource.
        (-[WebFrame _isLoadComplete]):
        (-[WebFrame _checkLoadComplete]):
	Comments, whitespace.
        (-[WebFrame _goToItem:withFrameLoadType:]):
	Set item we will use to saveDocState at commit time.

2002-10-27  Darin Adler  <darin@apple.com>

	- WebKit part of filename width fix

        * WebCoreSupport.subproj/WebFileButton.m:
        (-[WebFileButton drawRect:]): Compute left position by starting at
	the right side of the button frame rather than by starting at the right
	side of the overall bounds. Removes dependency on fixed-width filename area.
        (-[WebFileButton updateLabel]): Added. Computes ellipsized filename.
        (-[WebFileButton setFilename:]): Use updateLabel instead of code in line here.
        (-[WebFileButton setFrameSize:]): Call updateLabel.
        (-[WebFileButton bestVisualFrameSizeForCharacterCount:]): Compute a width based
	on the count passed in rather than a hardcoded 200-pixel constant.

2002-10-27  Darin Adler  <darin@apple.com>

	- fixed 3037369 -- Status text not cleared after start of drag from page

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]):
	Find the highest-level enclosing WebHTMLView, and call _updateMouseoverWithEvent:
	with the mouseUp event after the drag is done.
        (-[WebHTMLView mouseMovedNotification:]): Just call _updateMouseoverWithEvent:,
	the code from here was moved into there.

        * WebView.subproj/WebHTMLViewPrivate.h: Declare _updateMouseoverWithEvent.
        * WebView.subproj/WebHTMLViewPrivate.m: (-[WebHTMLView _updateMouseoverWithEvent:]):
	Moved all the code from mouseMovedNotification: in here so it could be used twice.

2002-10-27  Don Melton  <gramps@apple.com>

        * WebView.subproj/WebController.m:
        (-[WebController userAgentForURL:]):

	Changed default user agent to Mozilla 1.1.

2002-10-27  Darin Adler  <darin@apple.com>

        * Bookmarks.subproj/WebBookmarkProxy.m: (-[WebBookmarkProxy dealloc]):
	Added, so we don't leak the title.

        * Bookmarks.subproj/WebBookmarkGroup.m: (-[WebBookmarkGroup removeBookmark:]):
        * Bookmarks.subproj/WebBookmarkList.m: (-[WebBookmarkList removeChild:]):
	Added retain/release pairs so we don't use an object after it's deallocated.
	In practice this doesn't happen the way these are used by Alex since they are
	in an array, but they have windows of vulnerability depending on exactly how
	they are used.

2002-10-26  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory inputElementAltText]): Added.
        (-[WebViewFactory resetButtonDefaultLabel]): Added.
        (-[WebViewFactory searchableIndexIntroduction]): Added.
        (-[WebViewFactory submitButtonDefaultLabel]): Added.
        (-[WebViewFactory defaultLanguageCode]): Added.

        * English.lproj/Localizable.strings: Update.
        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-10-25  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory runJavaScriptAlertPanelWithMessage:]): Added.
        (-[WebViewFactory runJavaScriptConfirmPanelWithMessage:]): Added.

        * English.lproj/Localizable.strings: Update.
        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-10-25  Richard Williamson   <rjw@apple.com>

        Implemented support for bidi text layout.
        
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (_drawGlyphs):
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:rightToLeft:]):

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	Made frameNamed private in WebController and renamed it to _findFrameNamed. Got rid of _frameInThisWindowNamed in WebController because it isn't needed anymore.

        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController _goToItem:withFrameLoadType:]): call _findFrameNamed
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _findFrameNamed:]): renamed, made private, got rid of call to _frameInThisWindowNamed as it is not needed
        * WebView.subproj/WebFrame.m:
        (-[WebFrame findFrameNamed:]): call [WebController _findFrameNamed:]

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	- Fix case where we would name a new window _blank
	- If a data source can't be created for a plug-in request, don't create the frame or open a window.
	- cleaned up plug-in stream notifications

        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView initWithFrame:]): create streamNotifications dict
        (-[WebBaseNetscapePluginView dealloc]): release streamNotifications dict
        (-[WebBaseNetscapePluginView frameStateChanged:]): cleaned up
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]): create data source before frame
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController showURL:inFrame:]): create data source before frame
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _setTopLevelFrameName:]): don't allow _blank frames
        * WebView.subproj/WebFrame.m:
        (-[WebFrame findOrCreateFramedNamed:]): no need to check for _blank

2002-10-25  Darin Adler  <darin@apple.com>

        Tighten up the code that observes mouse moved events.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView initWithFrame:]): Don't set up observers here.
        (-[WebHTMLView addMouseMovedObserver]): Added some assertions.
        (-[WebHTMLView viewWillMoveToWindow:]): Stop observing the "become main" and "resign main"
	notifications here.
        (-[WebHTMLView viewDidMoveToWindow]): Start observing them here.
        (-[WebHTMLView windowDidBecomeMain:]): Assert that the notification is for this window,
	instead of checking with if.
        (-[WebHTMLView windowDidResignMain:]): Assert that the notification is for this window.

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	Cleaned up the frame searching shenanigans. Things are much cleaner and clearer now.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]): call findOrCreateFramedNamed
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController showURL:inFrame:]): call findOrCreateFramedNamed
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge childFrames]): moved
        (-[WebBridge mainFrame]): moved
        (-[WebBridge findOrCreateFramedNamed:]): call findOrCreateFramedNamed on the frame
        (-[WebBridge pluginViewWithPackage:attributes:baseURL:]): call _pluginController
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _frameInThisWindowNamed:]): call _descendantFrameNamed
        * WebView.subproj/WebFrame.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame findFrameNamed:]): was frameNamed. First checks special-case frame names, descendant frames, then the whole controller, then other controllers.
        (-[WebFrame findOrCreateFramedNamed:]): calls findFrameNamed, opens new window if necessary 
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _descendantFrameNamed:]): searches children, children's children etc.
        (-[WebFrame _pluginController]): this method needed an "_"
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView addSubview:]): call _pluginController
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]): no need to special case for "_blank" since findFrameNamed will return nil for that name

2002-10-25  Trey Matteson  <trey@apple.com>
	
	2919039 - Implement limit on back/forward history list
	2998200 - access to most-recent in submenu of back & forward buttons
	3022566 - need WebKit API for accessing and visiting back/forward list items
	3084051 - forward button incorrectly enabled after going forward all the way

	Remaining issues at this point are getting the title of the pages
	into the menu items (instead of the URL), and saving document
	state properly when you jump around in the list.  Solutions are
	known and coming soon.

        * History.subproj/WebBackForwardList.h:
	Added doc comments to API.  Made ivars private.  Replaced index-
	based API with item-based API.  Added a sizelimit to the overall
	list.  Tweaked API to get back and forward lists.
        * History.subproj/WebBackForwardList.m:
	Straightforward impl of the above, with the note that I dumped
	WebHistoryList from the API and impl in favor of an NSArray,
	which is efficient for this sort of use (queue, stack).
        (-[WebBackForwardList init]):
        (-[WebBackForwardList dealloc]):
        (-[WebBackForwardList goBack]):
        (-[WebBackForwardList goForward]):
        (-[WebBackForwardList goToEntry:]):
        (-[WebBackForwardList backEntry]):
        (-[WebBackForwardList forwardEntry]):
        (-[WebBackForwardList maximumSize]):
        (-[WebBackForwardList setMaximumSize:]):
        (-[WebBackForwardList description]):
        * History.subproj/WebHistoryList.h: Removed.
	Nuked from API, per above.
        * History.subproj/WebHistoryList.m: Removed.
        * Misc.subproj/WebKit.h:
	WebHistoryList gone from API.
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:]):
	Use if/else instead of buried "return;", so next person doesn;t
	make the same mis-read I did.
        (-[WebBridge saveDocumentState:]):
	Site of future work.
        * WebKit.pbproj/project.pbxproj:
	Nuked WebHistoryList.
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController goBackOrForwardToItem:]):
	New method to support random access nav in backforward list.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setTitle:]):
	Site of future work (fixing title in items)
        * WebView.subproj/WebFramePrivate.h:
	WebFrameLoadTypeIndexedBack/WebFrameLoadTypeIndexedForward are
	collapsed into WebFrameLoadTypeIndexedBackForward.  Vestigial
	WebFrameLoadTypeIntermediateBack is nuked.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate setBackForwardItem:]):
        (-[WebFrame _setBackForwardItem:]):
        (-[WebFrame _backForwardItem]):
	Must remember the BF item we're going to so we can update the
	BF list on commit.
        (-[WebFrame _transitionToCommitted]):
	Update the BF list on commit.
        (-[WebFrame _isLoadComplete]):
        (-[WebFrame _goToItem:withFrameLoadType:]):
	Update BF list on within-page nav.
	Remember BF item we are going to for later update on commit.

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	Minor non-mentionable clean-up.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:MIMEType:]):

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	Cleaned up the plug-in API headers so they can be sent to other groups.

        * Plugins.subproj/WebPlugin.h:
        * Plugins.subproj/WebPluginContainer.h:
        * Plugins.subproj/WebPluginViewFactory.h:

2002-10-24  Richard Williamson   <rjw@apple.com>

        Fixed many font substitution related bugs, at least including:
        3006966, 3026675, 3071106, and more... (each of these bugs
        has a list of related bugs). 
        
        Needs little more cleanup to correctly deal with non base characters.
        
        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawCharacters:stringLength:fromCharacterPosition:toCharacterPosition:atPoint:withPadding:withTextColor:backgroundColor:]):
        (-[WebTextRenderer floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:]):
        (-[WebTextRenderer _floatWidthForCharacters:stringLength:fromCharacterPosition:numberOfCharacters:withPadding:applyRounding:attemptFontSubstitution:widths:fonts:glyphs:numGlyphs:]):
        
        Against Darin's better judgement prevent extra layout when not in live resize.  If
        this introduces any regressions I owe darin a good bottle of wine.
        
        * WebView.subproj/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):

2002-10-24  Chris Blumenberg  <cblu@apple.com>

	New Java plug-in works! Much faster to load and no spinny cursor! Unfortunately, it very unstable.

        * Plugins.subproj/WebPluginController.m: cleaned-up the logging messages.
        (-[WebPluginController addPluginView:]):
        (-[WebPluginController didAddPluginView:]):
        (-[WebPluginController startAllPlugins]):
        (-[WebPluginController stopAllPlugins]):
        (-[WebPluginController destroyAllPlugins]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]): make height and width an attribute.

2002-10-24  Chris Blumenberg  <cblu@apple.com>

	Some clean-up and bug fixes for new plug-in support.

        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController initWithWebFrame:]): need a colon after windowWillClose
        (-[WebPluginController addPluginView:]): added logging
        (-[WebPluginController didAddPluginView:]): added logging
        (-[WebPluginController startAllPlugins]): added logging
        (-[WebPluginController stopAllPlugins]): added logging
        (-[WebPluginController destroyAllPlugins]): added logging
        * Plugins.subproj/WebPluginPackage.m:
        (-[WebPluginPackage getMIMEInformation]): use correct dict key for getting MIME descriptions
        * WebCoreSupport.subproj/WebBridge.m: no more didAddSubview
        * WebView.subproj/WebFramePrivate.h: no more didAddSubview
        * WebView.subproj/WebFramePrivate.m: no more didAddSubview
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView addSubview:]): call didAddPluginView on WebPluginController

2002-10-24  John Sullivan  <sullivan@apple.com>

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:response:size:]):
	added ASSERT(response != nil), leftover from debugging
	session on Tuesday, seems worth leaving in.

2002-10-24  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-10-24  Chris Blumenberg  <cblu@apple.com>

	Changed some method names in WebPluginController.

        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController didAddPluginView:]):
        (-[WebPluginController startAllPlugins]):
        (-[WebPluginController stopAllPlugins]):
        (-[WebPluginController destroyAllPlugins]):
        (-[WebPluginController windowWillClose:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
        (-[WebFrame _didAddSubview:]):

=== Alexander-29 ===

2002-10-24  Richard Williamson   <rjw@apple.com>

        Don't leak request.
        
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):

2002-10-24  Richard Williamson   <rjw@apple.com>

        Always copy request, we can't count on it being immutable.
        This was the cause of the ASSERT from last night's checkin.
        
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):
        
        Only send serverRedirectedForDataSource: if URL changed.
        
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setRequest:]):

2002-10-24  Chris Blumenberg  <cblu@apple.com>
	
	- Use "MIMEType" instead of "serviceType".

        * Plugins.subproj/WebBasePluginPackage.h:
        * Plugins.subproj/WebBasePluginPackage.m:
        (-[WebBasePluginPackage load]):
        (-[WebBasePluginPackage dealloc]):
        (-[WebBasePluginPackage filename]):
        (-[WebBasePluginPackage setPath:]):
        * Plugins.subproj/WebNetscapePluginEmbeddedView.h:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        (-[WebNetscapePluginEmbeddedView initWithFrame:plugin:URL:baseURL:MIMEType:attributes:]):
        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage getMIMEInformation]): changed name.
        (-[WebNetscapePluginPackage initWithPath:]):
        * Plugins.subproj/WebNullPluginView.h:
        * Plugins.subproj/WebNullPluginView.m:
        (-[WebNullPluginView initWithFrame:MIMEType:attributes:]):
        (-[WebNullPluginView dealloc]):
        (-[WebNullPluginView viewDidMoveToWindow]): send missing plug-ins notification here
        * Plugins.subproj/WebPluginPackage.m:
        (-[WebPluginPackage getMIMEInformation]): new, gets MIME info from plist
        (-[WebPluginPackage initWithPath:]):
        (-[WebPluginPackage dealloc]):
        (-[WebPluginPackage viewFactory]):
        (-[WebPluginPackage load]):
        (-[WebPluginPackage unload]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:MIMEType:]):
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]):

2002-10-24  Richard Williamson   <rjw@apple.com>

        Flag error instead of ASSERTing as a result of fix to 3083013.
        Not clear why this condition occurs, but better than ASSERTing
        for Alex 29.
        
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setRequest:]):

2002-10-24  Darin Adler  <darin@apple.com>

	- fixed a crash I ran into in the new delegate code

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate _releaseResources]): Retain self across this
	deallocation to avoid reentering and being deallocated midstream. This happens
	because the handle holds the only reference to us, and we may be releasing the
	last reference to it.
        (-[WebBaseResourceHandleDelegate dealloc]): Add call to [super dealloc].

        * Plugins.subproj/WebBasePluginPackage.m: (-[WebBasePluginPackage dealloc]):
	Add call to [super dealloc].

        * WebView.subproj/WebMainResourceClient.m: Tweak.

2002-10-23  Darin Adler  <darin@apple.com>

	- fixed 3083013 -- REGRESSION: Cookie refused at http://directory/ even on reload

	Restore a bit of the cruft.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
	We need to change the request on the data source when a redirect happens,
	because the data source goes on to ultimately communicate this to WebCore.
	Restored the code that did that, with some changes to fit into the new regime.

2002-10-23  Richard Williamson  <rjw@apple.com>

        Cleaned up months of accumulated cruft.
        Added base class to the three WebResourceHandleDelegate implementors.
        Removed superfluous handle references to controller callbacks.
        More can still be done.
        All in the name of fixing 3076050.
        
        * Misc.subproj/WebKitErrors.h:
        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream setResponse:]):
        * Plugins.subproj/WebNetscapePluginRepresentation.m:
        (-[WebNetscapePluginRepresentation receivedData:withDataSource:]):
        (-[WebNetscapePluginRepresentation receivedError:withDataSource:]):
        (-[WebNetscapePluginRepresentation finishedLoadingWithDataSource:]):
        * Plugins.subproj/WebNetscapePluginStream.h:
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:]):
        (-[WebNetscapePluginStream dealloc]):
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePluginStream stop]):
        (-[WebNetscapePluginStream handle:willSendRequest:]):
        (-[WebNetscapePluginStream handle:didReceiveResponse:]):
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge reportBadURL:]):
        * WebCoreSupport.subproj/WebSubresourceClient.h:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient initWithLoader:dataSource:]):
        (-[WebSubresourceClient dealloc]):
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
        (-[WebSubresourceClient receivedError:]):
        (-[WebSubresourceClient handle:willSendRequest:]):
        (-[WebSubresourceClient handle:didReceiveResponse:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        (-[WebSubresourceClient handle:didFailLoadingWithError:]):
        (-[WebSubresourceClient cancel]):
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate init]):
        (-[WebBaseResourceHandleDelegate _releaseResources]):
        (-[WebBaseResourceHandleDelegate dealloc]):
        (-[WebBaseResourceHandleDelegate setDataSource:]):
        (-[WebBaseResourceHandleDelegate dataSource]):
        (-[WebBaseResourceHandleDelegate resourceLoadDelegate]):
        (-[WebBaseResourceHandleDelegate downloadDelegate]):
        (-[WebBaseResourceHandleDelegate setIsDownload:]):
        (-[WebBaseResourceHandleDelegate isDownload]):
        (-[WebBaseResourceHandleDelegate handle:willSendRequest:]):
        (-[WebBaseResourceHandleDelegate handle:didReceiveResponse:]):
        (-[WebBaseResourceHandleDelegate handle:didReceiveData:]):
        (-[WebBaseResourceHandleDelegate handleDidFinishLoading:]):
        (-[WebBaseResourceHandleDelegate handle:didFailLoadingWithError:]):
        (-[WebBaseResourceHandleDelegate cancel]):
        (-[WebBaseResourceHandleDelegate handle]):
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _mainReceivedBytesSoFar:fromDataSource:complete:]):
        (-[WebController _receivedError:fromDataSource:]):
        (-[WebController _mainReceivedError:fromDataSource:]):
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _startLoading]):
        (-[WebDataSource _stopLoading]):
        (-[WebDataSource _clearErrors]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _isLoadComplete]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]):
        (-[WebMainResourceClient dealloc]):
        (-[WebMainResourceClient receivedError:]):
        (-[WebMainResourceClient cancel]):
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient _notifyDelegatesOfInterruptionByPolicyChange]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):
        (-[WebMainResourceClient handle:didFailLoadingWithError:]):
        * WebView.subproj/WebResourceLoadDelegate.h:

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Support for new plug-in API. This is about as much as I can do without the new java plug-in and java root.

        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController initWithWebFrame:]): observe window close changes
        (-[WebPluginController dealloc]): remove observer, assert if we're still tracking plug-ins
        (-[WebPluginController didAddSubview:]): start the plug-in
        (-[WebPluginController stopAllPlugins]): stop and destroy all plug-ins.
        (-[WebPluginController windowWillClose:]): call stopAllPlugins if the window in question is closing
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]): call stopAllPlugins on WebPluginController

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Changed the plug-in package API to return key enumerators instead dictionaries.

        * Plugins.subproj/WebBasePluginPackage.h:
        * Plugins.subproj/WebBasePluginPackage.m:
        (-[WebBasePluginPackage initWithPath:]):
        (-[WebBasePluginPackage load]):
        (-[WebBasePluginPackage unload]):
        (-[WebBasePluginPackage dealloc]):
        (-[WebBasePluginPackage extensionEnumerator]):
        (-[WebBasePluginPackage MIMETypeEnumerator]):
        (-[WebBasePluginPackage descriptionForMIMEType:]):
        (-[WebBasePluginPackage MIMETypeForExtension:]):
        (-[WebBasePluginPackage extensionsForMIMEType:]):
        (-[WebBasePluginPackage setName:]):
        (-[WebBasePluginPackage setPath:]):
        (-[WebBasePluginPackage setFilename:]):
        (-[WebBasePluginPackage setPluginDescription:]):
        (-[WebBasePluginPackage setMIMEToDescriptionDictionary:]):
        (-[WebBasePluginPackage setMIMEToExtensionsDictionary:]):
        * Plugins.subproj/WebNetscapePluginPackage.h:
        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage getPluginInfo]):
        (-[WebNetscapePluginPackage pathByResolvingSymlinksAndAliasesInPath:]):
        (-[WebNetscapePluginPackage initWithPath:]):
        (-[WebNetscapePluginPackage executableType]):
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController didAddSubview:]):
        * Plugins.subproj/WebPluginDatabase.h:
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebPluginDatabase pluginForKey:withEnumeratorSelector:]):
        (-[WebPluginDatabase pluginForMIMEType:]):
        (-[WebPluginDatabase pluginForExtension:]):
        (-[WebPluginDatabase MIMETypes]):
        (-[WebPluginDatabase init]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:serviceType:]):
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]):
        (-[WebBridge didAddSubview:]): new
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _didAddSubview:]): new 

2002-10-23  Darin Adler  <darin@apple.com>

	- finished up the job of moving the file button here from WebCore.

	I did this mainly for localization reasons.

        * WebCoreSupport.subproj/WebFileButton.m:
        (-[WebFileButton initWithFrame:]): Set up button control size, font, bezel style,
	target, and action. Also add it as a subview.
        (-[WebFileButton drawRect:]): Center icon in the "visual frame" part of the view,
	not the entire bounds.
        (-[WebFileButton setFilename:]): Don't show any icon when the filename is empty.
        (-[WebFileButton bestVisualFrameSize]): Implemented this.
        (-[WebFileButton visualFrame]): Ditto.
        (-[WebFileButton setVisualFrame:]): Ditto.
        (-[WebFileButton baseline]): Ditto.
        (-[WebFileButton beginSheet]): Added. Shared between button presses and other clicks.
        (-[WebFileButton chooseButtonPressed:]): Call beginSheet.
        (-[WebFileButton mouseDown:]): Ditto.
        (-[WebFileButton openPanelDidEnd:returnCode:contextInfo:]): Send the notification,
	WebCoreFileButtonFilenameChanged, when the filename is changed.

        * WebView.subproj/WebController.m: (-[WebController policyDelegate]):
	Add a FIXME about the leak I found here.

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Call the arguments for plug-ins "attributes" everywhere.

        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView setAttributes:]):
        * Plugins.subproj/WebNetscapePluginEmbeddedView.h:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        (-[WebNetscapePluginEmbeddedView initWithFrame:plugin:URL:baseURL:mime:attributes:]):
        * Plugins.subproj/WebNullPluginView.h:
        * Plugins.subproj/WebNullPluginView.m:
        (-[WebNullPluginView initWithFrame:mimeType:attributes:]):
        (-[WebNullPluginView drawRect:]):
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController initWithWebFrame:]):
        (-[WebPluginController dealloc]):
        (-[WebPluginController addPluginView:]):
        * Plugins.subproj/WebPluginPackage.h:
        * Plugins.subproj/WebPluginPackage.m:
        (-[WebPluginPackage viewFactory]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge pluginViewWithPackage:attributes:baseURL:]):
        (-[WebBridge viewForPluginWithURL:attributes:baseURL:serviceType:]):
        (-[WebBridge viewForJavaAppletWithFrame:attributes:baseURL:]):

2002-10-23  Chris Blumenberg  <cblu@apple.com>

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge requestedURL]):
        (-[WebBridge viewForPluginWithURL:serviceType:arguments:baseURL:]):
        (-[WebBridge viewForJavaAppletWithFrame:baseURL:parameters:]):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory fileButton]):
        (-[WebViewFactory pluginsInfo]):

2002-10-23  Darin Adler  <darin@apple.com>

	- fix bug where plugins crashed closing a stream that was never opened

        * Plugins.subproj/WebBaseNetscapePluginStream.h: Change type for parameter of
	receivedError: to NPReason. It's not NPError.
        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream dealloc]): Assert that stream is destroyed by
	checking stream.ndata.
        (-[WebBaseNetscapePluginStream setResponse:]): Set stream.ndata to nil if the
	stream is not successfully created by NPP_NewStream.
        (-[WebBaseNetscapePluginStream destroyStreamWithReason:]): Added. Destroys the
	stream, but only if it's present. Also set stream.ndata to nil. This was the bug fix.
        (-[WebBaseNetscapePluginStream receivedError:]): Call destroyStreamWithReason:.
        (-[WebBaseNetscapePluginStream finishedLoadingWithData:]): Call destroyStreamWithReason:.

        * English.lproj/Localizable.strings: Update.
        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Forgot to add WebPluginController back to the project after I had a project conflict.

        * WebKit.pbproj/project.pbxproj:

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Added WebPluginController which controls and reacts to plug-in requests. Its owned by the WebFrame.

        * Plugins.subproj/WebPluginController.h: Added.
        * Plugins.subproj/WebPluginController.m: Added.
        (-[WebPluginController initWithWebFrame:]):
        (-[WebPluginController showURL:inFrame:]):
        (-[WebPluginController showStatus:]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate dealloc]):
        (-[WebFrame pluginController]):

2002-10-23  Darin Adler  <darin@apple.com>

	Add WebFileButton, to be used by WebCore soon. It's about 1/2
	done right now. Compiles but not used yet.

        * WebCoreSupport.subproj/WebViewFactory.m: (-[WebViewFactory fileButton]): Added.

        * WebCoreSupport.subproj/WebFileButton.h: Added.
        * WebCoreSupport.subproj/WebFileButton.m: Added.
        * WebKit.pbproj/project.pbxproj: Added WebFileButton files.

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:didReceiveResponse:]): Add an assertion.

2002-10-23  Maciej Stachowiak  <mjs@apple.com>

        - fixed 2876448 - The authentication panel should give a note when
	the user tried to log in and failed

	Also, made the message different (and more helpful) when the
	authentication is for a proxy server.
	
        * Panels.subproj/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel setUpForRequest:]): Use different
	messages depending on proxy and previous failure count.

	Updated localized strings:
	
	* English.lproj/Localizable.strings:
        * English.lproj/StringsNotToBeLocalized.txt:

2002-10-23  Maciej Stachowiak  <mjs@apple.com>

	- fixed 2876446 - The label in the authentication panel needs to
	adjust its height depending on content

	Also improved [NSControl sizeToFitAndAdjustWindowHeight] method.
	
        * Panels.subproj/English.lproj/WebAuthenticationPanel.nib: Adjusted
	springs.
        * Panels.subproj/WebAuthenticationPanel.m:
	(-[WebAuthenticationPanel setUpForRequest:]): Use
	sizeToFitAndAdjustWindowHeight on main label.
	
        * Misc.subproj/WebNSControlExtras.m:
        (-[NSControl sizeToFitAndAdjustWindowHeight]): Improved the logic
	so the best height is picked while leaving the width
	alone. Before, the label would always come out to be a very wide
	single line.

2002-10-22  Maciej Stachowiak  <mjs@apple.com>

        * WebKit.pbproj/project.pbxproj: Made WebControllerSets.h
	private. Also alphabetized headers in target pane and subproject
	folders.

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	load and unload is only a WebNetscapePluginPackage thing since you can't unload an NSBundle.

        * Plugins.subproj/WebBasePluginPackage.h:
        * Plugins.subproj/WebBasePluginPackage.m:
        * Plugins.subproj/WebNetscapePluginPackage.h:

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	More moving stuff around for the new plug-in API. Added WebBasePluginPackage and added subclass WebPluginPackage. Also made WebNetscapePluginPackage a subclass of WebBasePluginPackage. 

        * Plugins.subproj/WebBasePluginPackage.h: Added.
        * Plugins.subproj/WebBasePluginPackage.m: Added.
        (+[WebBasePluginPackage pluginWithPath:]): creates a WebPluginPackage or WebNetscapePluginPackage
        (-[WebBasePluginPackage initWithPath:]):
        (-[WebBasePluginPackage name]):
        (-[WebBasePluginPackage path]):
        (-[WebBasePluginPackage filename]):
        (-[WebBasePluginPackage pluginDescription]):
        (-[WebBasePluginPackage extensionToMIMEDictionary]):
        (-[WebBasePluginPackage MIMEToExtensionsDictionary]):
        (-[WebBasePluginPackage MIMEToDescriptionDictionary]):
        (-[WebBasePluginPackage load]):
        (-[WebBasePluginPackage unload]):
        (-[WebBasePluginPackage isLoaded]):
        (-[WebBasePluginPackage description]):
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]):
        * Plugins.subproj/WebNetscapePluginPackage.h:
        * Plugins.subproj/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage initWithPath:]):
        * Plugins.subproj/WebPluginDatabase.h:
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebPluginDatabase pluginForMIMEType:]):
        (-[WebPluginDatabase pluginForExtension:]):
        (-[WebPluginDatabase pluginForFilename:]):
        (-[WebPluginDatabase MIMETypes]):
        (-[WebPluginDatabase init]):
        * Plugins.subproj/WebPluginPackage.h: Added.
        * Plugins.subproj/WebPluginPackage.m: Added.
        (-[WebPluginPackage initWithPath:]):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory viewForPluginWithURL:serviceType:arguments:baseURL:]): check the class of the plug-in when deciding which view to create.
        (-[WebViewFactory viewForJavaAppletWithFrame:baseURL:parameters:]): same here.
        * WebKit.pbproj/project.pbxproj:

2002-10-22  David Hyatt  <hyatt@apple.com>

	Getting XML docs at least made for XML files...
	
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation setDataSource:]):

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	Made new plug-in API headers private.

        * WebKit.pbproj/project.pbxproj:

2002-10-22  Darin Adler  <darin@apple.com>

        * Misc.subproj/WebKitErrors.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
	Rename WebErrorLocationChangeInterruptedByURLPolicyChange to
	WebErrorLocationChangeInterruptedByPolicyChange.

2002-10-22  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):
	Send the new error whenever a policy change happens. The old code was
	sending a successful completion in the download and ignore cases.

2002-10-22  John Sullivan  <sullivan@apple.com>

	- fixed 3080873 -- Error in console when no bookmark file 
	found -[WebBookmarkGroup _loadBookmarkGroupGuts]

        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup _loadBookmarkGroupGuts]):
	removed ERROR that was useful only long ago.

2002-10-22  Richard Williamson  <rjw@apple.com>

        Added stubs from common WebResourceHandleDelegate base
        class.
        
        * Plugins.subproj/WebBaseNetscapePluginStream.h:
        * Plugins.subproj/WebNetscapePluginStream.h:
        * WebCoreSupport.subproj/WebSubresourceClient.h:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebBaseResourceHandleDelegate.h: Added.
        * WebView.subproj/WebBaseResourceHandleDelegate.m: Added.
        * WebView.subproj/WebMainResourceClient.h:

2002-10-22  Darin Adler  <darin@apple.com>

	Make the panel position itself above the main window.
	Too bad we can't use a sheet, but this is better than a random position.

        * WebCoreSupport.subproj/WebJavaScriptTextInputPanel.m:
        (-[WebJavaScriptTextInputPanel initWithPrompt:text:]):
	Use the new [NSWindow sizeToFitAndAdjustWindowHeight]
	and [NSControl sizeToFitAndAdjustWindowHeight].

        * Misc.subproj/WebNSControlExtras.h: Added.
        * Misc.subproj/WebNSControlExtras.m: Added.
        * Misc.subproj/WebNSWindowExtras.h: Added.
        * Misc.subproj/WebNSWindowExtras.m: Added.
        * WebKit.pbproj/project.pbxproj: Added above files.

        * English.lproj/StringsNotToBeLocalized.txt: Update.

2002-10-22  Ken Kocienda  <kocienda@apple.com>

        * Misc.subproj/WebKitErrors.h: Add new error code to signify that a location
	change has been interrupted by a change in the URLPolicy governing the load.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]): Add code to check the URLPolicy
	for the URL in the request that is submitted to us in this delegate method. Send
	a locationChangeDone:forDataSource: message with an error using the newly-defined
	code in cases where the location change should be cancelled.

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	Added protocol headers for new plug-in API.

        * Plugins.subproj/WebPlugin.h: Added.
        * Plugins.subproj/WebPluginContainer.h: Added.
        * Plugins.subproj/WebPluginViewFactory.h: Added.
        * WebKit.pbproj/project.pbxproj:

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	- Moved things around to make room for new plug-in API.
	- Renamed WebNetscapePlugin to WebNetscapePluginPackage.
	- Renamed WebNetscapePluginDatabase to WebPluginDatabase.

        * Plugins.subproj/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream setPluginPointer:]):
        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView plugin]):
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]):
        * Plugins.subproj/WebNetscapePluginEmbeddedView.h:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        (-[WebNetscapePluginEmbeddedView initWithFrame:plugin:URL:baseURL:mime:arguments:]):
        * Plugins.subproj/WebNetscapePluginNullEventSender.h: Added.
        * Plugins.subproj/WebNetscapePluginNullEventSender.m: Added.
        (-[WebNetscapePluginNullEventSender initWithPluginView:]):
        (-[WebNetscapePluginNullEventSender dealloc]):
        (-[WebNetscapePluginNullEventSender sendNullEvents]):
        (-[WebNetscapePluginNullEventSender stop]):
        * Plugins.subproj/WebNetscapePluginPackage.h: Added.
        * Plugins.subproj/WebNetscapePluginPackage.m: Added.
        (-[WebNetscapePluginPackage openResourceFile]):
        (-[WebNetscapePluginPackage closeResourceFile:]):
        (-[WebNetscapePluginPackage stringForStringListID:andIndex:]):
        (-[WebNetscapePluginPackage getPluginInfo]):
        (-[WebNetscapePluginPackage stringByResolvingSymlinksAndAliasesInPath:]):
        (-[WebNetscapePluginPackage initWithPath:]):
        (-[WebNetscapePluginPackage load]):
        (-[WebNetscapePluginPackage unload]):
        (-[WebNetscapePluginPackage NPP_SetWindow]):
        (-[WebNetscapePluginPackage NPP_New]):
        (-[WebNetscapePluginPackage NPP_Destroy]):
        (-[WebNetscapePluginPackage NPP_NewStream]):
        (-[WebNetscapePluginPackage NPP_StreamAsFile]):
        (-[WebNetscapePluginPackage NPP_DestroyStream]):
        (-[WebNetscapePluginPackage NPP_WriteReady]):
        (-[WebNetscapePluginPackage NPP_Write]):
        (-[WebNetscapePluginPackage NPP_HandleEvent]):
        (-[WebNetscapePluginPackage NPP_URLNotify]):
        (-[WebNetscapePluginPackage NPP_GetValue]):
        (-[WebNetscapePluginPackage NPP_SetValue]):
        (-[WebNetscapePluginPackage NPP_Print]):
        (-[WebNetscapePluginPackage MIMEToExtensionsDictionary]):
        (-[WebNetscapePluginPackage extensionToMIMEDictionary]):
        (-[WebNetscapePluginPackage MIMEToDescriptionDictionary]):
        (-[WebNetscapePluginPackage name]):
        (-[WebNetscapePluginPackage filename]):
        (-[WebNetscapePluginPackage path]):
        (-[WebNetscapePluginPackage isLoaded]):
        (-[WebNetscapePluginPackage pluginDescription]):
        (-[WebNetscapePluginPackage description]):
        (functionPointerForTVector):
        (tVectorForFunctionPointer):
        * Plugins.subproj/WebPlugin.h: Removed.
        * Plugins.subproj/WebPlugin.m: Removed.
        * Plugins.subproj/WebPluginDatabase.h:
        * Plugins.subproj/WebPluginDatabase.m:
        (+[WebPluginDatabase installedPlugins]):
        (-[WebPluginDatabase pluginForMIMEType:]):
        (-[WebPluginDatabase pluginForExtension:]):
        (-[WebPluginDatabase pluginForFilename:]):
        (-[WebPluginDatabase MIMETypes]):
        (-[WebPluginDatabase init]):
        * Plugins.subproj/WebPluginNullEventSender.h: Removed.
        * Plugins.subproj/WebPluginNullEventSender.m: Removed.
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory viewForPluginWithURL:serviceType:arguments:baseURL:]):
        (-[WebViewFactory pluginsInfo]):
        (-[WebViewFactory viewForJavaAppletWithFrame:baseURL:parameters:]):
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.m:
        (+[WebController canShowMIMEType:]):

2002-10-22  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebJavaScriptTextInputPanel.m: Added missing import.

2002-10-22  Darin Adler  <darin@apple.com>

	- fixed 3077305 -- js dialog not yet implemented - crash (fatal error)

        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory runJavaScriptTextInputPanelWithPrompt:defaultText:returningText:]):
	Create a WebJavaScriptTextInputPanel and run it.

        * English.lproj/WebJavaScriptTextInputPanel.nib: Added.
        * WebCoreSupport.subproj/WebJavaScriptTextInputPanel.h: Added.
        * WebCoreSupport.subproj/WebJavaScriptTextInputPanel.m: Added.
        * WebKit.pbproj/project.pbxproj: Added 

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	Use the mouseDown point instead of the mouseDragged point to determine the mouseOffset when dragging images. When you drag an image now, the point where you clicked is the point where the cursor is in relation to the drag image.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDown:]): retain the mouse down event
        (-[WebHTMLView mouseDragged:]): use the mouse down event
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLViewPrivate dealloc]): release the mouse down event

2002-10-21  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebViewFactory.h: Changed to use new protocol scheme so we
	get an error if we forget to implement something.
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory runJavaScriptTextInputPanelWithPrompt:defaultText:returningText:]): Stub.

2002-10-21  Richard Williamson   <rjw@apple.com>

        More incremental tweaks.  Will be factoring common
        handle delegate behavior into base class.
        
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:response:size:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _finsishedLoadingResourceFromDataSource:]):

2002-10-21  Trey Matteson  trey@apple.com

	Fixed typos and other doc comment errors found during API review.

        * WebView.subproj/WebController.h:

2002-10-21  Richard Williamson   <rjw@apple.com>

        Changed WebResourceLoadDelegate methods to include an identifier
        as first parameter.  This will help clients track callbacks relating
        to a particular resource.  Added identifierForInitialRequest:fromDataSource:
        so clients can create their own identifier.
        
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:response:size:]):
        * WebCoreSupport.subproj/WebSubresourceClient.h:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:willSendRequest:]):
        (-[WebSubresourceClient handle:didReceiveResponse:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        (-[WebSubresourceClient handle:didFailLoadingWithError:]):
        * WebView.subproj/WebController.m:
        (-[WebResourceLoadDelegate identifierForInitialRequest:fromDataSource:]):
        (-[WebResourceLoadDelegate resource:willSendRequest:fromDataSource:]):
        (-[WebResourceLoadDelegate resource:didReceiveResponse:fromDataSource:]):
        (-[WebResourceLoadDelegate resource:didReceiveContentLength:fromDataSource:]):
        (-[WebResourceLoadDelegate resource:didFinishLoadingFromDataSource:]):
        (-[WebResourceLoadDelegate resource:didFailLoadingWithError:fromDataSource:]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:forHandle:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        (-[WebMainResourceClient handle:didFailLoadingWithError:]):
        * WebView.subproj/WebResourceLoadDelegate.h:

2002-10-21  Chris Blumenberg  <cblu@apple.com>

	Changed content policy API to pass a response instead of MIME type so client can get the mime type and filename from one class.

        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-10-21  Darin Adler  <darin@apple.com>

	- fixed 3080512 -- REGRESSION: moving from old page to new one, we get blank white
	before the new one is ready

	Roll out a bunch of my changes, because they weren't complete. Added FIXMEs for the
	problems I was unsuccessfully trying to fix.

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _setState:]):
        * WebView.subproj/WebView.m:
        (-[WebView initWithFrame:]), (-[WebView isOpaque]), (-[WebView drawRect:]):
	Roll back.

2002-10-21  Darin Adler  <darin@apple.com>

	- fixed 3080246 -- REGRESSION: Animated GIFs sometimes disappear after drag or scroll

	Once more, with feeling.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _setNeedsLayoutIfSizeChanged:]): Added setNeedsDisplay:YES here. The lack
	of this is what caused the bug. But also don't do any work when the size doesn't change.
	This prevents this from being called at all in the scrolling case, which is what we want.
        (-[WebHTMLView viewWillMoveToSuperview:]): Just the name change.
        (-[WebHTMLView layout]): Store the layout size for the above methods.
        * WebView.subproj/WebHTMLViewPrivate.h: Add a place to store the size.

        * WebView.subproj/WebImageView.m: (-[WebImageView layout]):
	Roll this change back in.

2002-10-21  Darin Adler  <darin@apple.com>

	- fixed 3080246 -- REGRESSION: Animated GIFs sometimes disappear after drag or scroll

        * WebView.subproj/WebImageView.m: (-[WebImageView layout]):
	My change to this caused the regression. Not sure why, but I'll just back out
	because the change wasn't important.

2002-10-20  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3025847 - Can't use any menu command keys after clicking on a plugin

	Don't give plug-ins command-modified keys anymore because the ability wasn't worth the annoyance. If only plug-ins truthfully responded t  events! Anyway, filed 3080103 so that I can look into a way to make this work for everybody.

        * Plugins.subproj/WebBaseNetscapePluginView.m:

2002-10-20  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3025868 - Plugin context menu disappears then reappears if you click off of it

	Also fixed some rare dragging weirdness in WebHTMLView. If you attempted to drag a plug-in after dragging an image, the image would drag again.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView mouseDragged:]): subclass and do nothing to prevent calling mouseDragged in WebHTMLView
        (-[WebBaseNetscapePluginView performKeyEquivalent:]): no changes to this method, removed menuForEvent, wasn't needed after all
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream stop]): minor clean-up

2002-10-20  Darin Adler  <darin@apple.com>

	- fixed a minor problem with autorelease I just ran into

        * WebView.subproj/WebHTMLViewPrivate.m: (+[WebHTMLView load]):
	Create an autorelease pool for the benefit of the class initialize
	functions that will be called.

2002-10-20  Chris Blumenberg  <cblu@apple.com>

	Fixed 3050010: Should show contextual menu for WebImageView
	Also made drags from WebImageView work.

        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m: added _web_setPromisedImageDragImage which does the hackery to extend the promised file drag for images
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _menuForElement:]): added, gets menu items from delegate and creates menu
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView menuForEvent:]): simplified, gets element and calls -[WebController _menuForElement:]
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]): call _web_setPromisedImageDragImage: when dragging image
        * WebView.subproj/WebImageRepresentation.h:
        * WebView.subproj/WebImageRepresentation.m:
        (-[WebImageRepresentation dealloc]): release the URL
        (-[WebImageRepresentation URL]): added so WebImageView can get the URL
        (-[WebImageRepresentation setDataSource:]): retain the URL
        * WebView.subproj/WebImageView.h: use new drag bools
        * WebView.subproj/WebImageView.m:
        (-[WebImageView initWithFrame:]): ditto
        (-[WebImageView setAcceptsDrags:]): ditto
        (-[WebImageView acceptsDrags]): ditto
        (-[WebImageView setAcceptsDrops:]): ditto
        (-[WebImageView acceptsDrops]): ditto
        (-[WebImageView controller]): new
        (-[WebImageView menuForEvent:]): new, creates element and calls -[WebController _menuForElement:]
        (-[WebImageView mouseDragged:]): drag promised file
        (-[WebImageView dragImage:at:offset:event:pasteboard:source:slideBack:]): call _web_setPromisedImageDragImage:
        (-[WebImageView namesOfPromisedFilesDroppedAtDestination:]): new

2002-10-20  Darin Adler  <darin@apple.com>

	- fixed a problem where you would get garbage bits when resizing while loading a standalone image

	Cleaned up some of the complexity of how we were handling resizing.

        * WebView.subproj/WebDynamicScrollBarsView.m: (-[WebDynamicScrollBarsView updateScrollers]):
	Do the update twice to properly handle the case where a disappearing scroller makes a second
	scroller appear or vice versa.

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _setState:]): Remove the code that was trying
	to set the setDrawsBackground flag on the scroll view. It was doing it wrong, causing bugs with
	drawing non-HTML views while loading. Also, it wasn't working as an optimization, since the
	window was still drawing the metallic background behind. We can revisit adding an optimization
	at the WebHTMLView level if it creates a measurable speed increase, but we must be careful to
	test loading with non-HTML views along with the HTML cases.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _setNeedsLayoutToYes:]): Added. Calls setNeedsLayout:YES.
        (-[WebHTMLView viewWillMoveToSuperview:]): Added. Registers so we get _setNeedsLayoutToYes:
	calls when the superview's size changes. This allows us to do a layout at all the right times.
        (-[WebHTMLView layout]): Call setNeedsDisplay:YES, because if we do a layout without a complete
	display the screen will look bad. Also do a reapplyStyles, because if there are pending style
	changes we want to apply them before doing a layout since they could affect the layout.
        (-[WebHTMLView drawRect:]): Remove the special case that says to always relayout during live
	resize, because it works without a special case now. For the other live resize case, turn it from
	a special case into a general one. Any time layout is done, make sure to draw the entire view,
	not just the passed-in rectangle, and call setNeedsDisplay:NO so we don't do it all over again.

        * WebView.subproj/WebImageView.m: (-[WebImageView layout]): Explicitly set frame size to
	0,0 when there is no image.

        * WebView.subproj/WebView.m: Remove now-unnecessary viewWillStartLiveResize, setFrame:,
	viewDidEndLiveResize, isOpaque, and drawRect overrides.
        (-[WebView initWithFrame:]): Don't call setDrawsBackground:NO for the reasons above.
	Don't set scroll bar visibility because the dynamic scroll bars view handles that already.

2002-10-19  Darin Adler  <darin@apple.com>

	- fixed 3073693 -- flash drawn to screen even when window minimized

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView start]): Set up additional notifications.
	Don't start the null event sender if the window is miniaturized.
        (-[WebBaseNetscapePluginView windowDidMiniaturize:]): Stop the null event sender.
        (-[WebBaseNetscapePluginView windowDidDeminiaturize:]): Start the null event sender.

2002-10-19  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _transitionToCommitted]):
	Removed stray printf.

2002-10-18  Richard Williamson   <rjw@apple.com>

        Changed name to setUsesBackForwardList: from
        setUseBackForwardList.  ditto for useBackForwardList
        
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController setUsesBackForwardList:]):
        (-[WebController usesBackForwardList]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
        (-[WebFrame _isLoadComplete]):

        Fixed history items that have "untitled" title after
        redirect. (3078577).
        
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setTitle:]):

2002-10-18  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController stringByEvaluatingJavaScriptFromString:]):
	Changed to return a string and changed name.

2002-10-18  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-10-18  Ken Kocienda  <kocienda@apple.com>

	Removed unneeded import of WebFoundation/WebResourceLoadManager.h

        * Misc.subproj/WebIconLoader.m

2002-10-18  Darin Adler  <darin@apple.com>

        * Makefile.am: Move dependency so clean happens before build.

2002-10-18  Darin Adler  <darin@apple.com>

        * force-clean-timestamp: Dependencies don't work well enough, so
	we need a clean build here after the WebFoundation domain change.

2002-10-18  Darin Adler  <darin@apple.com>

	Update for WebFoundation error domain changes.

        * Misc.subproj/WebKitErrors.h: Put WebErrorDomainWebKit in here.
	Also remove WebErrorNoError and the WebErrorCode name for the enum.
        * WebKit.exp: Export the WebErrorDomainWebKit constant.
        * WebView.subproj/WebView.m: Define the WebErrorDomainWebKit.

        * WebKit.pbproj/project.pbxproj: Always use WebKit.exp.
        * Makefile.am: Don't generate WebKit-combined.exp any more.
        * WebKit-tests.exp: Removed.

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3078644 -- Odd clipping in frame

        * WebView.subproj/WebClipView.h: Add hasAdditionalClip and additionalClip methods.
        * WebView.subproj/WebClipView.m:
        (-[WebClipView resetAdditionalClip]): Add an assertion.
        (-[WebClipView setAdditionalClip:]): Ditto.
        (-[WebClipView hasAdditionalClip]): Added.
        (-[WebClipView additionalClip]): Added.

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView visibleRect]):
	Turn off the additional clip while computing our visibleRect. This way, the additional
	clip only affects people who ask for the clip view's visibleRect directly, which basically
	means just the focus rectangle drawing code we are trying to influence.

2002-10-17  Richard Williamson  <rjw@apple.com>

        Support for drawing frame borders (fixes 2982466).
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _drawBorder:]):
        (-[WebHTMLView drawRect:]):

2002-10-17  John Sullivan  <sullivan@apple.com>

	- added support for bookmark identifiers, to be used for marking
	bookmark proxies uniquely (independent of localized title). This
	is not the old unique-identifier scheme; now identifiers are optional,
	and initially nil, but the client can use them for its own purposes.

        * Bookmarks.subproj/WebBookmark.h:
        * Bookmarks.subproj/WebBookmark.m:
        (-[WebBookmark dealloc]): release identifier
        (-[WebBookmark identifier]): return identifier
        (-[WebBookmark setIdentifier:]): set identifier
        * Bookmarks.subproj/WebBookmarkLeaf.m:
        (-[WebBookmarkLeaf initFromDictionaryRepresentation:withGroup:]):
	restore identifier
        (-[WebBookmarkLeaf dictionaryRepresentation]):
	save identifier
        (-[WebBookmarkLeaf copyWithZone:]):
	copy identifier
        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList initFromDictionaryRepresentation:withGroup:]):
	restore identifier
        (-[WebBookmarkList dictionaryRepresentation]):
	save identifier
        (-[WebBookmarkList copyWithZone:]):
	copy identifier
        * Bookmarks.subproj/WebBookmarkPrivate.h:
        * Bookmarks.subproj/WebBookmarkProxy.m:
        (-[WebBookmarkProxy initFromDictionaryRepresentation:withGroup:]):
	restore identifier
        (-[WebBookmarkProxy dictionaryRepresentation]):
	save identifier
        (-[WebBookmarkProxy copyWithZone:]):
	copy identifier

=== Alexander-28 ===

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3062613 -- too many redirects at nytimes.com and apple

	Our cookie policy was rejecting the cookies from nytimes.com -- the policy base
	URL was still the news.com URL from before the redirect.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
	Update the cookie policy URL when a redirect changes the data source's URL.

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3077910 -- REGRESSION: download window open at startup time -> no scrollbars

        * WebView.subproj/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):
	Check for WebDocumentView protocol before making the layout method
	call. Prevents exception when WebDynamicScrollBarsView is used with
	a document that is not a WebDocumentView.

2002-10-16  Richard Williamson  <rjw@apple.com>

        Added some drawing debug code (ifdef excluded).
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView drawRect:]):

2002-10-16  Darin Adler  <darin@apple.com>

	Fixed anomalies with plugin positioning caused by my switch to
	NSViewFocusDidChangeNotification. Turns out that is not sent during
	live resize, but we need things to work during live resize.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView start]): Register for changes in the
	bounds and frame of all superviews again, instead of using
	NSViewFocusDidChangeNotification.

2002-10-16  Richard Williamson  <rjw@apple.com>

        Fixed 2969367.  Ensure layout happens before doing check
        to determine if scrollbars are needed.  Ahhh, dynamic
        scrollbars work so much better now.
        
        * WebView.subproj/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):

2002-10-16  Darin Adler  <darin@apple.com>

	Fixed the problem where we would leave white bits when making the window larger.

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView drawRect:]): During live resize,
	use the visible rectangle after doing layout, not before.

2002-10-16  Richard Williamson  <rjw@apple.com>

        Fixed regression in visited links due to change is semantics of
        [dataSource request], added [dataSource _originalRequest].  Items
        always need to be added to history with the original request.
        
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource initWithRequest:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _defersCallbacksChanged]):
        (-[WebDataSource _originalRequest]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):

2002-10-16  Darin Adler  <darin@apple.com>

	- fixed 3017152 -- intra-page anchors not updating page address field

        * WebView.subproj/WebLocationChangeDelegate.h: Rearrange methods so they are
	in the order they are delivered. Add locationChangedWithinPageForDataSource method.
	Renamed the redirect methods to match the verb tenses used in the others.
	Removed the URL parameter from the server redirect method.
        * WebView.subproj/WebLocationChangeDelegate.m: Update the class to match the
	changes to the protocol.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge reportClientRedirectTo:delay:fireDate:]):
	Update for change to clientWillRedirectTo method name.
        (-[WebBridge loadURL:]): Call locationChangedWithinPageForDataSource:.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _setRequest:]):
	Update for change to serverRedirectedForDataSource method name.

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView mouseMovedNotification:]):
	Remove overzealous assert that was firing for me.

        * WebCoreSupport.subproj/WebSubresourceClient.m: Update comment.
        * WebView.subproj/WebDataSource.h: Fix comment.

2002-10-15  Darin Adler  <darin@apple.com>

	- fixed 3062393 -- need to send proper referrer for "open in new window" menu items and keyboard shortcuts

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:frameName:]): Don't take a referrer parameter any more.
	Get the referrer by calling to the other side of the bridge, instead.
        (-[WebBridge startLoadingResource:withURL:]): Ditto.
        (-[WebBridge loadURL:]): Ditto.
        (-[WebBridge postWithURL:data:contentType:]): Ditto.
        (-[WebBridge createChildFrameNamed:withURL:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Ditto.

        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate openNewWindowWithURL:]): Don't take a referrer parameter,
	which was always nil anyway. Instead, get the referrer from the bridge.
        (-[WebDefaultContextMenuDelegate openLinkInNewWindow:]): Don't pass nil for referrer.
        (-[WebDefaultContextMenuDelegate openImageInNewWindow:]): Ditto.
        (-[WebDefaultContextMenuDelegate openFrameInNewWindow:]): Ditto.

        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _continueAfterClickPolicyForEvent:]): Pass a referrer from the bridge, rather
	than nil, for both WebClickPolicyOpenNewWindow and WebClickPolicyOpenNewWindowBehind.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]): Add a FIXME.

2002-10-15  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebDataSourcePrivate.h: Remove unused stuff.
        * WebView.subproj/WebDataSourcePrivate.m: Ditto.

2002-10-15  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:referrer:]): Add a special case for when the URL is the
	same as the previous URL for the same frame. This relies on some logic in
	KHTML's openURL method that handles this case too.

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource initWithRequest:]): Don't bother keeping an inputURL.
        (-[WebDataSource URL]): Just return [[self request] URL]. Maybe we can
	remove this altogether.
        * WebView.subproj/WebDataSourcePrivate.h: Remove inputURL, finalURL.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): No need to release inputURL, finalURL.
        (-[WebDataSource _setURL:]): Used only by the new code above. Makes a copy
	of the request, changes the URL, and then drops the old request.
        (-[WebDataSource _setRequest:]): Changed to no longer call _setURL. Now
	does much of the work that _setURL used to do.

2002-10-15  Darin Adler  <darin@apple.com>

	WebKit part of improved frame name support.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame initWithName:webView:provisionalDataSource:controller:]):
	Call setName on the newly created part.

2002-10-15  John Sullivan  <sullivan@apple.com>

	- fixed 3075777 -- hysteresis for dragging links on web pages
	is still too large

        * WebView.subproj/WebHTMLView.m: changed hysteresis constants;
	added comment.

2002-10-15  Darin Adler  <darin@apple.com>

	Fix problem where timer was lasting after window was closed.

        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _detachFromParent]):
	Add a call to [_private->bridge closeURL].

2002-10-15  Richard Williamson  <rjw@apple.com>

        Added attributed string to pasteboard.  Fixes 3006760.
        We may want to scale back the content that is included in the
        attributed string.  Currently all text nodes in the selection
        are converted.  This include text nodes for non-visible content,
        i.e. scripts.
        [Note we may also want to put HTML snippet on the pboard.  The appkit
        does support reading text using htmldisplay today.  Of course this should
        eventually migrate to use WebView.]
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView copy:]):

2002-10-15  Darin Adler  <darin@apple.com>

	Fixed bug where URLs dragged to the content area were not made canonical
	the way URLs dragged to the page address field are.

        * Misc.subproj/WebNSPasteboardExtras.m: (-[NSPasteboard _web_bestURL]):
	Make URLs canonical before returning them.

2002-10-15  Chris Blumenberg  <cblu@apple.com>

	If a file is renamed during download because a file of the same name already exists, show this in the UI.

        * Misc.subproj/WebDownloadHandler.h:
        * Misc.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler receivedResponse:]): added, create file here
        (-[WebDownloadHandler receivedData:]): don't create file here
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handleDidFinishLoading:]): call [dataSource _setPrimaryLoadComplete:YES] for downloads
        (-[WebMainResourceClient handle:didReceiveResponse:]): call [WebDownloadHandler receivedResponse:]
        (-[WebMainResourceClient handle:didReceiveData:]): no download error to handle

2002-10-14  Chris Blumenberg  <cblu@apple.com>

	- Made all downloads no matter how prompted, pass through the content policy API so the client can properly choose the file name and correct the extension if necessary. We now ask for the content policy even if one has been predetermined. 

        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _downloadURL:withContentPolicy:]): Renamed, set the predetermined content policy.
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate downloadURL:]): call [WebController _downloadURL:withContentPolicy:]
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]): call [WebController _downloadURL:withContentPolicy:]
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _continueAfterClickPolicyForEvent:]): call [WebController _downloadURL:withContentPolicy:]
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]): ask for content policy even if one is predetermined

2002-10-14  Chris Blumenberg  <cblu@apple.com>

	- Cleaned up download handler and download progress delegate interactions.
	- Got rid of error suppression junk.
	- Only send 1 final message to the download progress delegate

        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:forHandle:]): no error suppression
        (-[WebMainResourceClient didCancelWithHandle:]): ignore cancel errors because 1 download error is enough
        (-[WebMainResourceClient handleDidFinishLoading:]): don't send the special and odd final message to the download progress delegate
        (-[WebMainResourceClient handle:didReceiveData:]): no error suppression
        (-[WebMainResourceClient handle:didFailLoadingWithError:]): ignore cancel errors because 1 download error is enough

2002-10-14  Darin Adler  <darin@apple.com>

        * Bookmarks.subproj/WebBookmark.m:
        (+[WebBookmark bookmarkFromDictionaryRepresentation:withGroup:]):
        * Bookmarks.subproj/WebBookmarkLeaf.m:
        (-[WebBookmarkLeaf initFromDictionaryRepresentation:withGroup:]):
        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList initFromDictionaryRepresentation:withGroup:]):
        * Bookmarks.subproj/WebBookmarkProxy.m:
        (-[WebBookmarkProxy initFromDictionaryRepresentation:withGroup:]):
	Add checking since we don't "trust" the dictionary passed in.

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem initFromDictionaryRepresentation:]):
	Add FIXME about adding the checking.

        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup initWithFile:]): Use copy, not retain.

        * WebView.subproj/WebControllerPrivate.m:
        (-[WebControllerPrivate dealloc]): Fix storage leak by releasing
	the default context menu delegate.

        * WebView.subproj/WebControllerPrivate.h: Tweak.

2002-10-14  Chris Blumenberg  <cblu@apple.com>

	Made WebNetscapePluginStream retain a WebNetscapePluginEmbeddedView not a WebBaseNetscapePluginView.

        * Plugins.subproj/WebNetscapePluginStream.h:
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:]):

2002-10-13  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Added strings from WebBookmarkProxy.m.

2002-10-13  Chris Blumenberg  <cblu@apple.com>

	- Eliminated the dual-role behavior of WebPluginStream.

	Renamed WebPluginStream to WebBaseNetscapePluginStream.
	WebNetscapePluginRepresentation, a subclass of WebBaseNetscapePluginStream,
	is the document representation for standalone plug-ins.
	WebNetscapePluginStream, also a subclass of WebBaseNetscapePluginStream,
	is the general plug-in stream loader for embedded plug-ins or plug-in requested streams.

	23 plug-in source files with more likely to come!

        * Plugins.subproj/WebBaseNetscapePluginStream.h: Added.
        * Plugins.subproj/WebBaseNetscapePluginStream.m: Added.
        (-[WebBaseNetscapePluginStream dealloc]):
        (-[WebBaseNetscapePluginStream setPluginPointer:]):
        (-[WebBaseNetscapePluginStream setResponse:]):
        (-[WebBaseNetscapePluginStream receivedData:]):
        (-[WebBaseNetscapePluginStream receivedError:]):
        (-[WebBaseNetscapePluginStream finishedLoadingWithData:]):
        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView setWindow]):
        (-[WebBaseNetscapePluginView pluginPointer]):
        (-[WebBaseNetscapePluginView drawRect:]):
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        * Plugins.subproj/WebNetscapePluginRepresentation.h: Added.
        * Plugins.subproj/WebNetscapePluginRepresentation.m: Added.
        (-[WebNetscapePluginRepresentation setDataSource:]):
        (-[WebNetscapePluginRepresentation receivedData:withDataSource:]):
        (-[WebNetscapePluginRepresentation receivedError:withDataSource:]):
        (-[WebNetscapePluginRepresentation finishedLoadingWithDataSource:]):
        * Plugins.subproj/WebNetscapePluginStream.h: Added.
        * Plugins.subproj/WebNetscapePluginStream.m: Added.
        (-[WebNetscapePluginStream setCurrentURL:]):
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:]):
        (-[WebNetscapePluginStream dealloc]):
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePluginStream stop]):
        (-[WebNetscapePluginStream loadEnded]):
        (-[WebNetscapePluginStream handle:willSendRequest:]):
        (-[WebNetscapePluginStream handle:didReceiveResponse:]):
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebNetscapePluginDatabase init]):
        * Plugins.subproj/WebPluginStream.h: Removed.
        * Plugins.subproj/WebPluginStream.m: Removed.
        * WebKit.pbproj/project.pbxproj:

2002-10-11  Richard Williamson   <rjw@apple.com>

        More DOM/attributed string work.
        
        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation attributedStringFrom:startOffset:to:endOffset:]):
        * WebView.subproj/WebHTMLRepresentationPrivate.h:

2002-10-11  Richard Williamson   <rjw@apple.com>

        * WebView.subproj/WebHTMLRepresentation.m:
        * WebView.subproj/WebHTMLRepresentationPrivate.h:

2002-10-11  Ken Kocienda  <kocienda@apple.com>

	Fixed uninitialized variable build breaker I got when
	doing a Deployment build.

        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup insertNewBookmarkAtIndex:ofBookmark:withTitle:URLString:type:]):

2002-10-11  John Sullivan  <sullivan@apple.com>

	Added the concept of bookmark proxies; items that can be
	stored and displayed with other bookmarks but represent
	a source of bookmark-like items (e.g. Rendezvous, History)

        * Bookmarks.subproj/WebBookmarkProxy.h: Added.
        * Bookmarks.subproj/WebBookmarkProxy.m: Added.
        (-[WebBookmarkProxy initFromDictionaryRepresentation:withGroup:]):
        (-[WebBookmarkProxy dictionaryRepresentation]):
        (-[WebBookmarkProxy bookmarkType]):
        (-[WebBookmarkProxy copyWithZone:]):
        (-[WebBookmarkProxy title]):
        (-[WebBookmarkProxy setTitle:]):
        (-[WebBookmarkProxy icon]):
	New class, has a title and that's about it

        * Bookmarks.subproj/WebBookmark.h:
        * Bookmarks.subproj/WebBookmark.m:
        (+[WebBookmark bookmarkFromDictionaryRepresentation:withGroup:]):
	Handle proxy case

        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup insertNewBookmarkAtIndex:ofBookmark:withTitle:URLString:type:]):
	Handle proxy case

        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList initFromDictionaryRepresentation:withGroup:]),
        (-[WebBookmarkList dictionaryRepresentation]):
	Handle proxy case

        * Bookmarks.subproj/WebBookmarkPrivate.h:
	Add #define for proxy

        * WebKit.pbproj/project.pbxproj: updated for new files

2002-10-11  Chris Blumenberg  <cblu@apple.com>

	Thought I has checking for nil enough, but not enough as I raised an exception on Avie's machine.

        * Plugins.subproj/WebPlugin.m:
        (-[WebNetscapePlugin getPluginInfo]): check for the nil extension case

2002-10-11  Darin Adler  <darin@apple.com>

	Apply a simplified technique I learned while working on the Favorites button
	class in the browser code.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView start]): Use the NSViewFocusDidChangeNotification
	to track the plugin rectangles instead of the NSViewFrameDidChangeNotification
	and NSViewBoundsDidChangeNotification on all the superviews.

2002-10-11  John Sullivan  <sullivan@apple.com>

        * Resources/url_icon.tiff: new generic URL icon -- no more @!

2002-10-10  Darin Adler  <darin@apple.com>

	- fixed 3069366 -- REGRESSION: no pop-up window at inkfinder.com

	The window now pops up, but it doesn't seem to work right. But I
	think the window working right is a separate issue.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]): Make sure we
	use the copy of the request that we're keeping around when we call
	_setRequest on the data source, rather than the copy we're returning
	which can be modified by WebFoundation. Also rearrange things so we're
	more likely to get things right when the delegate changes the URL on
	the request.

2002-10-10  Chris Blumenberg  <cblu@apple.com>

	No need to send update event when activating/deactivating.
	This was as old workaround for the plug-in drawing problems.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView windowBecameKey:]):
        (-[WebBaseNetscapePluginView windowResignedKey:]):

=== Alexander-27 ===

2002-10-10  Darin Adler  <darin@apple.com>

	- fixed 3071799 -- REGRESSION: hang and strange download loading about:blank

	Chris fixed the strange download earlier. This fixes the "hang' by making sure
	we commit even if we receive 0 bytes of data.

        * WebView.subproj/WebDataSourcePrivate.h: Added a _finishedLoading method.
        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _finishedLoading]):
	Added. Sets the "first byte of data received" flag, and calls _commitIfReady.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handleDidFinishLoading:]): Call _finishedLoading.

2002-10-10  Darin Adler  <darin@apple.com>

	- fixed 3072015 -- REGRESSION: frames multiply endlessly

        * WebCoreSupport.subproj/WebBridge.m: (-[WebBridge setFrame:]):
	Remove code that sets the parent from here, because it's too early, always nil.
        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _addChild:]):
	Do it here instead.

2002-10-09  Richard Williamson   <rjw@apple.com>

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handleDidFinishLoading:]):
        * WebKit.exp:
        * WebView.subproj/WebController.m:
        (-[WebResourceLoadDelegate resourceRequest:willSendRequest:fromDataSource:]):
        (-[WebResourceLoadDelegate resourceRequest:didReceiveResponse:fromDataSource:]):
        (-[WebResourceLoadDelegate resourceRequest:didReceiveContentLength:fromDataSource:]):
        (-[WebResourceLoadDelegate resourceRequest:didFinishLoadingFromDataSource:]):
        (-[WebResourceLoadDelegate resourceRequest:didFailLoadingWithError:fromDataSource:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handleDidFinishLoading:]):
        * WebView.subproj/WebResourceLoadDelegate.h:

2002-10-09  John Sullivan  <sullivan@apple.com>

	- removed unnecessary concept of unique identifiers for bookmarks

        * Bookmarks.subproj/WebBookmark.h:
        * Bookmarks.subproj/WebBookmark.m:
        (-[WebBookmark dealloc]):
        (-[WebBookmark _setGroup:]):
        * Bookmarks.subproj/WebBookmarkGroup.h:
        * Bookmarks.subproj/WebBookmarkGroup.m:
        * Bookmarks.subproj/WebBookmarkGroupPrivate.h:
	removed all references to unique identifiers

2002-10-09  Darin Adler  <darin@apple.com>

	WebKit support for creating windows and then showing them later
	after setting them up.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:referrer:frameName:]): Replaced the old
	openNewWindowWithURL with this. It calls the new window operations delegate
	method.
        (-[WebBridge showWindow]): Added. Calls the window operations delegate showWindow method.
        (-[WebBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Call _createFrameNamed instead of createFrameNamed.

        * WebView.subproj/WebWindowOperationsDelegate.h: Replaced the openNewWindowWithURL
	method with a new method named createWindowWithURL. Added showWindow and showWindowBehindFrontmost.

        * WebView.subproj/WebControllerPrivate.h: Renamed createFrameNamed to _createFrameNamed
	and removed the data source parameter. Added _openNewWindowWithURL:referrer:behind:
	for the convenience of those who used to call the window operations delegate directly
	to open the window.
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _createFrameNamed:inParent:allowsScrolling:]): Renamed, and removed
	the data source parameter.
        (-[WebController _openNewWindowWithURL:referrer:behind:]): Added.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate openNewWindowWithURL:referrer:]):
        * WebView.subproj/WebFrame.m: (-[WebFrame frameNamed:]):
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _continueAfterClickPolicyForEvent:]):
	Use a private WebController method instead of calling the delegate directly,
	because it now takes two method calls to create and display a new window.

        * Misc.subproj/WebNSViewExtras.m:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        * WebView.subproj/WebController.m:
        * WebView.subproj/WebDataSource.m:
        * WebView.subproj/WebFramePrivate.m:
        * WebView.subproj/WebHTMLView.m:
        * WebView.subproj/WebMainResourceClient.m:
        * WebView.subproj/WebPreferences.m:
        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewPrivate.m:
	Tweaked comments.

2002-10-09  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer drawClippedToValidInRect:fromRect:]):
	Fix positioning of progressively loading images that are flipped.

2002-10-09  Darin Adler  <darin@apple.com>

	- fixed 3069764 -- REGRESSION: Plug-ins sometimes don't respond to
	update events, causes disappearing

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView drawRect:]): Set the visible region of the port to the
	port bounds to work around the fact that NSWindow tries to help us by doing a
	BeginUpdate call. This ensures we can draw where we think we are dirty, not just
	where Carbon thinks we are dirty.

        * Plugins.subproj/WebNetscapePluginDocumentView.m: Tweak includes.
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m: Tweak includes.
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge openNewWindowWithURL:referrer:frameName:]): Tweak.

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2002-10-08  Darin Adler  <darin@apple.com>

	Make WebFrame do the entire frame hierarchy, instead of having the
	parent and child pointers in the data source.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge childFrames]): Get children from the frame, not the data source.
        (-[WebBridge setFrame:]): Do the setParent: call on the bridge here, instead of
	in dataSourceChanged, since the parent relationship is now established even without
	having the data source.
        (-[WebBridge dataSourceChanged]): Remove the setParent: call.
        (-[WebBridge loadRequest:]): Remove the parent parameter. It's already set up at
	this point so we don't need to set it.
        (-[WebBridge loadURL:referrer:]): Don't pass a parent.
        (-[WebBridge postWithURL:referrer:data:contentType:]): Don't pass a parent.
        (-[WebBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
	Don't pass a parent.
	(-[WebBridge addBackForwardItemWithURL:anchor:]): Get the parent frame by just calling
	the parent method instead of the more roundabout way that it was doing it before.

        * WebView.subproj/WebController.m:
        (-[WebController _frameForDataSource:fromFrame:]): Get the children list from the frame,
	no need to ask the data source. And no need to deal with the provisional data source, since
	those can't have children any more.
        (-[WebController _frameForView:fromFrame:]): Ditto.

        * WebView.subproj/WebControllerPrivate.h: Change parent parameter when creating a new
	frame to be a frame, not a data source.
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebControllerPrivate _clearControllerReferences:]): Get the children list from the frame.
        (-[WebControllerPrivate dealloc]): Rename the _reset method _controllerWillBeDeallocated
	to be more concrete. More simplification can happen here later.
        (-[WebController createFrameNamed:for:inParent:allowsScrolling:]): Call _addChild on the
	parent frame rather than calling addFrame on the parent data source.

        * WebView.subproj/WebDataSource.h: Remove the parent, children, frameNamed, frameNames, and
	frameExists methods.
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource controller]): Remove the assertion here about parents, since we don't have
	a parent pointer any more.
        (-[WebDataSource isLoading]): Get the list of children from the frame.

        * WebView.subproj/WebDataSourcePrivate.h: Remove the parent pointer and the frames dictionary,
	also remove the _setParent: and addFrame: methods.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): Don't release the frames list.
        (-[WebDataSource _recursiveStopLoading]): Get the frames list from the frame.
        (-[WebDataSource _layoutChildren]): Ditto.
        (-[WebDataSource _defersCallbacksChanged]): Ditto.

        * WebView.subproj/WebFrame.h: Add parent and children methods.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame dealloc]): Call _detachFromParent.
        (-[WebFrame setProvisionalDataSource:]): Set the encoding of the data source to match
	the encoding of the parent's data source. This used to be done in [WebDataSource _setParent:].
	Further simplification can probably be done here.
        (-[WebFrame reload]): Remove the call to [WebDataSource _setParent:].
        (+[WebFrame _frameNamed:fromFrame:]): Get the children from the frame.
        (-[WebFrame frameNamed:]): Get the parent from the frame.
        (-[WebFrame parent]): Added.
        (-[WebFrame children]): Added.

        * WebView.subproj/WebFramePrivate.h: Added parent and children fields, changed reset to
	_controllerWillBeDeallocated, changed _parentDataSourceWillBeDeallocated to _detachFromParent,
	added _addChild method. Further simplification can probably be done here.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFramePrivate dealloc]): Release the children array.
        (-[WebFrame _controllerWillBeDeallocated]): Renamed from reset. Now just calls _detachFromParent.
        (-[WebFrame _detachFromParent]): Does all the work that reset and _parentDataSourceWillBeDeallocated
	used to do.
        (-[WebFrame _setDataSource:]): Call _detachFromParent on all the children and release them
	before setting up the new data source.
        (-[WebFrame _transitionToCommitted]): Get the parent from self instead of the data source.
        (-[WebFrame _isLoadComplete]): Ditto.
        (+[WebFrame _recursiveCheckCompleteFromFrame:]): Get the children from self instead of the data source.
        (-[WebFrame _textSizeMultiplierChanged]): Ditto.
        (-[WebFrame _reloadAllowingStaleDataWithOverrideEncoding:]): Remove the call to [WebDataSource _setParent:].
        (-[WebFrame _addChild:]): Added. Puts the child in a children list, and also sets the override
	encoding of the child based on our data source's override encoding.

2002-10-08  John Sullivan  <sullivan@apple.com>

        * WebKit.pbproj/project.pbxproj:
	Project Builder says I changed it only by setting
	"hasScannedForEncodings" to 1 -- version wars again?

2002-10-08  Richard Williamson   <rjw@apple.com>

        Removed unnecessary (and incorrect) include.
        The *.m files in DOM.subproj might be removed,
        they are empty now.
        
        * DOM.subproj/WebDOMDocument.m:

2002-10-08  Richard Williamson   <rjw@apple.com>

        Added selection API.
        
        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation setSelectionFrom:startOffset:to:endOffset:]):

2002-10-08  Richard Williamson   <rjw@apple.com>

        Add accessor for DOM document.
        
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation DOMDocument]):

2002-10-08  Richard Williamson   <rjw@apple.com>

        Made getAttributeNodeNamed match spec, changed
        to getAttributeNode.
         
        * DOM.subproj/WebDOMElement.h:

2002-10-08  John Sullivan  <sullivan@apple.com>

	- WebKit part of fix for 3069150 -- eliminate "separator"
	feature from Bookmarks

        * Bookmarks.subproj/WebBookmarkSeparator.h: Removed.
        * Bookmarks.subproj/WebBookmarkSeparator.m: Removed.
	Removed class

        * Bookmarks.subproj/WebBookmark.h:
        * Bookmarks.subproj/WebBookmark.m:
        (+[WebBookmark bookmarkOfType:]):
        (+[WebBookmark bookmarkFromDictionaryRepresentation:withGroup:]):
        * Bookmarks.subproj/WebBookmarkGroup.m:
        (-[WebBookmarkGroup insertNewBookmarkAtIndex:ofBookmark:withTitle:URLString:type:]):
        * Bookmarks.subproj/WebBookmarkList.m:
        (-[WebBookmarkList initFromDictionaryRepresentation:withGroup:]):
        * Bookmarks.subproj/WebBookmarkPrivate.h:
        * English.lproj/StringsNotToBeLocalized.txt:
	Removed all references to class.

        * WebKit.pbproj/project.pbxproj: Updated for removed files.

2002-10-08  Richard Williamson   <rjw@apple.com>

        Fixes to the DOM API.
        
        * DOM.subproj/WebDOMDocument.h:
        * DOM.subproj/WebDOMDocument.m:
        * DOM.subproj/WebDOMNode.h:
        * DOM.subproj/WebDOMNode.m:
        * DOM.subproj/WebDOMNamedNodeMap.h: Removed.
        * DOM.subproj/WebDOMNamedNodeMap.m: Removed.
        * WebKit.pbproj/project.pbxproj:

2002-10-08  Ken Kocienda  <kocienda@apple.com>

	Use WebFrameLoadType variable to set the request cache policy for the WebResourceRequest.
	This will help us to provide cached results for POST requests when the user navigates
	using the back/forward list or history for navigation, while making sure we do not
	use cached results when the user pokes the submit button for a form they have
	submitted previously.

        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _goToItem:withFrameLoadType:])

2002-10-08  Chris Blumenberg  <cblu@apple.com>

	Moved assumption that a resource without a content type or extension is HTML to WebFoundation.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-10-08  Chris Blumenberg  <cblu@apple.com>

	Minor plug-in code clean-up.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView sendActivateEvent:]):
        (-[WebBaseNetscapePluginView sendUpdateEvent]):
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream receivedData:]):

2002-10-08  Chris Blumenberg  <cblu@apple.com>

	Partial fix for 2967073 - should open all TEXT type files, at least

        * WebView.subproj/WebControllerPrivate.m:
        (+[WebController _MIMETypeForFile:]): Sniff for HTML in the fail case.

2002-10-07  Darin Adler  <darin@apple.com>

	WebKit part of implementation of multipart forms posting.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge postWithURL:referrer:data:contentType:]):
	Add a contentType parameter to match change in WebCore API.
	Put the contentType value into the request.

2002-10-07  Chris Blumenberg  <cblu@apple.com>

	Icing fix for: 3063517 - crash loading .png in separate window
	
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebNetscapePluginDatabase init]): Don't override document view and rep
	types for types that have already been registered. 

2002-10-07  Darin Adler  <darin@apple.com>

	WebKit part of the page up/down fix.

        * WebView.subproj/WebHTMLViewPrivate.m: (-[WebHTMLView scrollPoint:]):
	If we are called from the handling of a page up or page down keyboard
	event, then ignore the specific scrolling requested, and do our idea of
	page up and page down. This guarantees that we will get the smarter
	idea of how to page from WebView instead of the one that's hardcoded
	into NSTextView.

        * WebView.subproj/WebView.m: (-[WebView keyDown:]): Use scrollPageUp:,
	scrollPageDown:, scrollLineUp:, and scrollLineDown: instead of _pageUp,
	_pageDown, _lineUp, and _lineDown. This lets other classes see and use
	these selectors, which is useful when passing calls up the responder chain.
        * WebView.subproj/WebViewPrivate.h: Remove the private methods that are
	being changed to match the NSResponder keyboard methods.
        * WebView.subproj/WebViewPrivate.m:
        (-[WebView scrollPageUp:]): Rename from _pageUp, and also pass a scrollPageUp:
	selector along the responder chain if we are already scrolled to the top.
        (-[WebView scrollPageDown:]): Ditto.
        (-[WebView scrollLineUp:]): Rename from _lineUp.
        (-[WebView scrollLineDown:]): Rename from _lineDown.

2002-10-07  Richard Williamson   <rjw@apple.com>

        'Re'play the delegate messages when an item is loaded from
        the WebCore cache.

        Note that the client will NOT receive a willSendRequest: message.  The client
        presumably already did any request substitution before the object was loaded 
        into the cache.  Allowing the delegate to override the request and replace
        the object in the WebCore cache would introduce significant complexity.
        
        Fixes 3069138.
        
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:response:size:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:didReceiveResponse:]):

2002-10-05  Darin Adler  <darin@apple.com>

	- fixed 3068323 -- nil object inserted in dictionary exception on mouse move

        * WebView.subproj/WebHTMLViewPrivate.m: (-[WebHTMLView _elementAtPoint:]):
	Add some assertions in the hope of finding if my assumptions about this are
	wrong, and use the version of the dictionary setter that does nothing if it's
	passed nil when putting in the frame found by name.

2002-10-04  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Add a localization
	exception for the WebKit bundle identifier.

2002-10-04  Darin Adler  <darin@apple.com>

        * Misc.subproj/WebKitLocalizableStrings.m: Added.
	Contains the definition of the WebKitLocalizableStringsBundle.
        * WebKit.pbproj/project.pbxproj: Add -DFRAMEWORK_NAME=WebKit.

2002-10-04  Richard Williamson   <rjw@apple.com>

        Stubs for DOM level 2 core API.
        
        * DOM.subproj/WebDOMDocument.h: Added.
        * DOM.subproj/WebDOMDocument.m: Added.
        * DOM.subproj/WebDOMElement.h: Added.
        * DOM.subproj/WebDOMElement.m: Added.
        * DOM.subproj/WebDOMNamedNodeMap.h: Added.
        * DOM.subproj/WebDOMNamedNodeMap.m: Added.
        * DOM.subproj/WebDOMNode.h: Added.
        * DOM.subproj/WebDOMNode.m: Added.
        * WebKit.pbproj/project.pbxproj:
        
        * WebView.subproj/WebHTMLViewPrivate.m: tweak.

2002-10-04  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Add the last few exceptions.
	We now have a completely-clean run of extract-localizable-strings in WebKit!

2002-10-04  Darin Adler  <darin@apple.com>

	- fixed 3060140 -- REGRESSION: frames of animated gif drawn in wrong position.

	I got the "fromRect" and "toRect" parameters backwards when I made the changes
	to fix bug 3050810.

        * WebCoreSupport.subproj/WebImageRenderer.m: (-[WebImageRenderer nextFrame:]):
	Reverse targetRect and imageRect.

        * WebKit.pbproj/project.pbxproj: Mark some new files as UTF-8 because Project
	Builder asked me to.

2002-10-04  Darin Adler  <darin@apple.com>

        * Panels.subproj/WebPanelCookieAcceptHandler.h: Removed.
        * Panels.subproj/WebPanelCookieAcceptHandler.m: Removed.

2002-10-04  Richard Williamson   <rjw@apple.com>

        Danger Will Robinson.  We have to poseAsClass: as early as possible
        so that any NSViews will be created with the appropriate poser.
        This problem manifested itself with SimpleViewer failing
        immediately.  NSViews were created by loading a nib before
        WebHTMLView class initialization occured.  After posing the
        already instantiated instances of NSView had a %NSView class,
        causing many things to break.
        
        * WebView.subproj/WebHTMLViewPrivate.m:
        (+[WebHTMLView load]):

2002-10-04  Richard Williamson   <rjw@apple.com>

        Ensure that we return non-nil request  from handle:willSendRequest:
        even when WK's laod delegate is nil.
        
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:willSendRequest:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):

2002-10-04  Darin Adler  <darin@apple.com>

        * Panels.subproj/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel loadNib]): Use ERROR instead of NSLog here.
        (-[WebAuthenticationPanel setUpForRequest:]): Mark some strings for localization.

        * WebKit.pbproj/project.pbxproj: Change the encoding on a lot more files to UTF-8.

        * English.lproj/StringsNotToBeLocalized.txt: Added some new exceptions.
        * English.lproj/Localizable.strings: Re-generated.

2002-10-04  Richard Williamson   <rjw@apple.com>

        Changed WebDOMNode name to WebDebugDOMNode to make room for
        real node.
        
        * WebKit.exp:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebDOMNode.h: Removed.
        * WebView.subproj/WebDOMNode.m: Removed.

2002-10-04  Richard Williamson   <rjw@apple.com>

        * WebKit.pbproj/project.pbxproj:

2002-10-03  Richard Williamson   <rjw@apple.com>

        Changed name of controller's resourceProgressDelegate methods to resourceLoadDelegate.

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient initWithLoader:dataSource:]):
        (-[WebSubresourceClient handle:didReceiveResponse:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        (-[WebSubresourceClient handle:didFailLoadingWithError:]):
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController setResourceLoadDelegate:]):
        (-[WebController resourceLoadDelegate]):
        (-[WebController setDownloadDelegate:]):
        (-[WebController downloadDelegate]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):

2002-10-03  Richard Williamson   <rjw@apple.com>

        Always call resourceRequest:willSendRequest: on resourceProgressDelegate.
         
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):

2002-10-03  Richard Williamson   <rjw@apple.com>

        Add calls to downloadProgressDelegate.
        
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        (-[WebMainResourceClient handle:didFailLoadingWithError:]):

2002-10-03  Richard Williamson   <rjw@apple.com>

        
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:size:]):
        Hack to prevent handle creation with nil delegate,
        still perform frame complete check.
        
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]):
        Removed unused code.
        
        (-[WebMainResourceClient handle:willSendRequest:]):
        Copy the request, ugh.

2002-10-03  Darin Adler  <darin@apple.com>

	Add API for executing JavaScript.

        * WebView.subproj/WebController.h: Add method.
        * WebView.subproj/WebController.m:
        (-[WebController executeJavaScriptFromString:]): Call through to
	WebCore to do the heavy lifting.

2002-10-03  Darin Adler  <darin@apple.com>

        * English.lproj/Localizable.strings: Generated by the script.
        * English.lproj/StringsNotToBeLocalized.txt: Added many more strings to ignore.
        * English.lproj/WebError.strings: Removed.

        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        * WebView.subproj/WebView.m:
	Use UI_STRING instead of NSLocalizedString.

        * WebKit.pbproj/project.pbxproj: Changed encodings of some files to UTF-8.
	Removed WebError.strings.

2002-10-03  Richard Williamson   <rjw@apple.com>

        Renamed WebResourceProgressDelegate.h to WebResourceLoadDelegate.h

        * Misc.subproj/WebKit.h:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.m:
        * WebView.subproj/WebControllerPrivate.m:
        * WebView.subproj/WebMainResourceClient.m:
        * WebView.subproj/WebResourceLoadDelegate.h:
        * WebView.subproj/WebResourceProgressDelegate.h: Removed.

2002-10-03  Richard Williamson   <rjw@apple.com>

        Changed to reflect new WebResourceLoadDelegate API.

        * Misc.subproj/WebIconLoader.m:
        * Misc.subproj/WebKit.h:
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        (-[WebNetscapePluginStream cancel]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:size:]):
        (-[WebBridge reportBadURL:]):
        * WebCoreSupport.subproj/WebSubresourceClient.h:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient initWithLoader:dataSource:]):
        (-[WebSubresourceClient dealloc]):
        (-[WebSubresourceClient receivedProgressWithComplete:]):
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
        (-[WebSubresourceClient receivedError:]):
        (-[WebSubresourceClient handle:willSendRequest:]):
        (-[WebSubresourceClient handle:didReceiveResponse:]):
        (-[WebSubresourceClient handle:didReceiveData:]):
        (-[WebSubresourceClient handleDidFinishLoading:]):
        (-[WebSubresourceClient handle:didFailLoadingWithError:]):
        (-[WebSubresourceClient cancel]):
        * WebKit.exp:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        (-[WebController setResourceProgressDelegate:]):
        (-[WebController resourceProgressDelegate]):
        (-[WebController setDownloadProgressDelegate:]):
        (-[WebController downloadProgressDelegate]):
        * WebView.subproj/WebControllerPrivate.h:
        * WebView.subproj/WebControllerPrivate.m:
        (-[WebController _receivedProgressForResourceHandle:fromDataSource:complete:]):
        (-[WebController _mainReceivedProgressForResourceHandle:bytesSoFar:fromDataSource:complete:]):
        (-[WebController _receivedError:forResourceHandle:fromDataSource:]):
        (-[WebController _mainReceivedError:forResourceHandle:fromDataSource:]):
        * WebView.subproj/WebLoadProgress.h: Removed.
        * WebView.subproj/WebLoadProgress.m: Removed.
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]):
        (-[WebMainResourceClient dealloc]):
        (-[WebMainResourceClient receivedProgressWithHandle:complete:]):
        (-[WebMainResourceClient receivedError:forHandle:]):
        (-[WebMainResourceClient handleDidFinishLoading:]):
        (-[WebMainResourceClient handle:willSendRequest:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        (-[WebMainResourceClient handle:didFailLoadingWithError:]):
        * WebView.subproj/WebResourceProgressDelegate.h:

=== Alexander-26 ===

2002-10-02  Maciej Stachowiak  <mjs@apple.com>

	- Added "remember my password" checkbox (underlying feature not
	yet implemented).

	- Fixed a bug that caused a crash when cancelling the auth sheet.
	
        * Panels.subproj/English.lproj/WebAuthenticationPanel.nib: Added
	"remember this password" checkbox.
        * Panels.subproj/WebAuthenticationPanel.h:
        * Panels.subproj/WebAuthenticationPanel.m:
	(-[WebAuthenticationPanel cancel:]): Make sure the panel gets
	retained a bit longer, so the cleanup that happens after this
	message is sent can use the panel object.
        (-[WebAuthenticationPanel logIn:]): Make sure the panel gets
	retained a bit longer, so the cleanup that happens after this
	message is sent can use the panel object.
        (-[WebAuthenticationPanel runAsModalDialogWithRequest:]): Pass
	proper remembered value with credential.
        (-[WebAuthenticationPanel sheetDidEnd:returnCode:contextInfo:]):
	Pass proper remembered value with credential.
        * WebKit.pbproj/project.pbxproj: Project Builder had its way with
	this file.

2002-10-02  Darin Adler  <darin@apple.com>

	Machinery so we can handle mouseover feedback at the browser level.

        * WebView.subproj/WebWindowOperationsDelegate.h: Added mouseDidMoveOverElement:modifierFlags:.

        * WebKit.exp: Export WebElementLinkTargetFrameKey.
        * WebView.subproj/WebController.h: Add WebElementLinkTargetFrameKey.
        * WebView.subproj/WebController.m: Ditto.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView removeMouseMovedObserver]): Send a callback when we
	stop tracking the mouse altogether.
        (-[WebHTMLView viewDidMoveToWindow]): Only set up the mouse moved
	observer if we are the top-level HTML view.
        (-[WebHTMLView windowDidBecomeMain:]): Ditto.
        (-[WebHTMLView mouseMovedNotification:]): Handle mouse over if we are
	over any subview of the HTML view. Also send the callback.

        * WebView.subproj/WebHTMLViewPrivate.h: Added lastMouseOverElementWasNotNil,
	_mouseOverElement:modifierFlags: and _insideAnotherHTMLView.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]): Copy over each element separately so
	we don't rely on keys matching. Find the target frame given the target string,
	and include it in the dictionary.
        (-[WebHTMLView _mouseOverElement:modifierFlags]): Added. Calls the window
	operations delegate method, but doesn't call it over and over again if the
	information is still "nil".
        (-[WebHTMLView _insideAnotherHTMLView]): Added.
        (-[NSMutableDictionary _web_setObjectIfNotNil:forKey:]): Added. Helper for
	the _elementAtPoint method which could be moved to WebNSDictionaryExtras some day.

2002-10-02  Ken Kocienda  <kocienda@apple.com>

	Implemented HTTP-specific subclass for WebResourceResponse.

        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream receivedData:]): Add import for WebHTTPResourceResponse.

2002-10-02  Darin Adler  <darin@apple.com>

	Add return value to willSendRequest callback.

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader handle:willSendRequest:]):
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream handle:willSendRequest:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:willSendRequest:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:willSendRequest:]):
	Update to return the request.

2002-10-02  Darin Adler  <darin@apple.com>

	Use the text encoding name from the response and got rid of
	[WebDataSource encoding]. Also remove the "first chunk" logic since we
	now get a separate callback for the response.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge receivedData:withDataSource:]): Get the encoding name
	from the response, or fall back on the default.

        * WebView.subproj/WebDataSource.h: Removed encoding.
        * WebView.subproj/WebDataSource.m: Ditto.

        * WebView.subproj/WebDataSourcePrivate.h: Removed _setEncoding.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]): No need to release encoding any more.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]): No isFirstChunk to initialize.
        (-[WebMainResourceClient handle:didReceiveResponse:]): Moved the response handling
	in here, including the policy logic.
        (-[WebMainResourceClient handle:didReceiveData:]): This has only what's left.

2002-10-02  Chris Blumenberg  <cblu@apple.com>

	Replaced contentType on WebDataSource to response.

        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        (-[WebNetscapePluginDocumentView setDataSource:]):
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream receivedData:]):
        (-[WebNetscapePluginStream setResponse:]):
        (-[WebNetscapePluginStream setDataSource:]):
        (-[WebNetscapePluginStream receivedData:withDataSource:]):
        (-[WebNetscapePluginStream handle:didReceiveResponse:]):
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource response]):
        (-[WebDataSource fileType]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _representationClass]):
        (-[WebDataSource _setResponse:]):
        (-[WebDataSource _setContentPolicy:]):
        * WebView.subproj/WebMainResourceClient.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient dealloc]):
        (-[WebMainResourceClient handleDidFinishLoading:]):
        (-[WebMainResourceClient handle:didReceiveResponse:]):
        (-[WebMainResourceClient handle:didReceiveData:]):
        * WebView.subproj/WebTextView.m:
        (-[WebTextView dataSourceUpdated:]):
        * WebView.subproj/WebViewPrivate.m:
        (-[WebView _makeDocumentViewForDataSource:]):

2002-10-02  Darin Adler  <darin@apple.com>

	More work on "open window behind".

        * WebView.subproj/WebControllerPolicyDelegate.h: Add new OpenNewWindowBehind
	constants to the enums.

        * WebView.subproj/WebWindowOperationsDelegate.h: Add a behind: parameter to
	the openNewWindowWithURL method.

        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _continueAfterClickPolicyForEvent:]): In the new
	WebClickPolicyOpenNewWindowBehind case, pass YES for behind.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge openNewWindowWithURL:referrer:frameName:]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate openNewWindowWithURL:referrer:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame frameNamed:]):
	Pass NO for behind.

2002-10-02  Darin Adler  <darin@apple.com>

	Cut down on unnecessary use of WebFoundation private stuff.

        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream startLoad]): Remove unnecessary use of
	[WebResourceHandle _request].
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handleDidFinishLoading:]): Remove assert about
	status code, since status codes are going away.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient didCancelWithHandle:]): Use currentURL for logging.
        (-[WebMainResourceClient handleDidFinishLoading:]): Ditto.
        (-[WebMainResourceClient handle:didReceiveData:]): Ditto.

2002-10-02  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebControllerPolicyDelegate.h: Change modifierMask to
	modifierFlags to match NSEvent.
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate clickPolicyForElement:button:modifierFlags:]): Ditto.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _continueAfterClickPolicyForEvent:]): Ditto.

2002-10-02  Darin Adler  <darin@apple.com>

	Get rid of uses of canonicalURL.

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
	Start with normal URL. The change to the canonical URL will come in as a redirect.
        (-[WebSubresourceClient handle:didReceiveData:]): Remove assert.
        (-[WebSubresourceClient handleDidFinishLoading:]): Ditto.
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource initWithRequest:]):Start with normal URL. The change to the
	canonical URL will come in as a redirect.

2002-10-02  Ken Kocienda  <kocienda@apple.com>

	Added import of WebHTTPResourceRequest.h to get access to methods
	which have moved to the HTTP-sepcific request category.

        * WebView.subproj/WebDataSourcePrivate.m

2002-10-01  John Sullivan  <sullivan@apple.com>

        * WebKit.exp: added .objc_class_name_WebTextRendererFactory
	so I could use it from WebBrowser.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge startLoadingResource:withURL:referrer:]):
	Just changed whitespace so the .exp change would be built.

2002-10-01  Chris Blumenberg  <cblu@apple.com>

	Fixed build breakage.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView setWindow]):

2002-10-01  Ken Kocienda  <kocienda@apple.com>

        Implemented WebResourceRequest "category" design for extending a
        request with protocol-specific data.

        * WebCoreSupport.subproj/WebBridge.m: Now imports WebHTTPResourceRequest.h.
        * WebCoreSupport.subproj/WebSubresourceClient.m: Ditto.
        * WebView.subproj/WebMainResourceClient.m: Ditto.

2002-10-01  Chris Blumenberg  <cblu@apple.com>

	- Added debug drawing
	- removed unnecessary ifdef'ing.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView sendActivateEvent:]):
        (-[WebBaseNetscapePluginView becomeFirstResponder]):
        (-[WebBaseNetscapePluginView resignFirstResponder]):
        (-[WebBaseNetscapePluginView mouseDown:]):
        (-[WebBaseNetscapePluginView mouseUp:]):
        (-[WebBaseNetscapePluginView mouseEntered:]):
        (-[WebBaseNetscapePluginView mouseExited:]):
        (-[WebBaseNetscapePluginView menuForEvent:]):
        (-[WebBaseNetscapePluginView setWindow]):
        (-[WebBaseNetscapePluginView start]):
        (-[WebBaseNetscapePluginView drawRect:]):

2002-10-01  Ken Kocienda  <kocienda@apple.com>

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handleDidFinishLoading:]): Fixed Development build breakage. Call to [response statusCode] 
	now calls the handle's private method to get the status code.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handleDidFinishLoading:]): Ditto.
        (-[WebMainResourceClient handle:didReceiveData:]): Calls new textEncodingName method, replacing call to characterSet.

2002-10-01  Ken Kocienda  <kocienda@apple.com>

        * WebView.subproj/WebLoadProgress.m:
        (-[WebLoadProgress initWithResourceHandle:]): Status code moved from WebResourceResponse
	to WebResourceHandle private API.

2002-10-01  Ken Kocienda  <kocienda@apple.com>

        Changed WebResourceHandle so that the init method no longer starts the
        loading of the request to begin. Added new loadWithDelegate: method which
        is called separatetly from the init method, to start loads.

	All of the changes here update code that depends on WebResourceHandle. The
	changes move the code to the modified API.

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader startLoading])
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream startLoad])
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:size:])
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:])
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading])

2002-10-01  Chris Blumenberg  <cblu@apple.com>

	Fixed copyright comments.

        * Plugins.subproj/WebBaseNetscapePluginView.h:
        * Plugins.subproj/WebBaseNetscapePluginViewPrivate.h:
        * Plugins.subproj/WebNetscapePluginDocumentView.h:
        * Plugins.subproj/WebNetscapePluginDocumentView.m:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.h:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        * Plugins.subproj/WebNullPluginView.h:
        * Plugins.subproj/WebNullPluginView.m:
        * Plugins.subproj/WebPlugin.h:
        * Plugins.subproj/WebPlugin.m:
        * Plugins.subproj/WebPluginDatabase.h:
        * Plugins.subproj/WebPluginDatabase.m:
        * Plugins.subproj/WebPluginNullEventSender.h:
        * Plugins.subproj/WebPluginNullEventSender.m:
        * Plugins.subproj/WebPluginStream.h:
        * Plugins.subproj/WebPluginStream.m:
        * Plugins.subproj/npapi.h:
        * Plugins.subproj/npapi.m:

2002-10-01  Ken Kocienda  <kocienda@apple.com>

	Many changes to coincide with API work in WebFoundation. Most of the modifications
	here have to do with changes for the new callback scheme.

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader handleDidFinishLoading:])
        (-[WebIconLoader handle:willSendRequest:]): New method. A no-op here.
        (-[WebIconLoader handle:didReceiveResponse:]): Ditto.
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView stop]): Fix for Deployment build breakage. 
        * Plugins.subproj/WebPluginStream.h: Add response ivar.
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream startLoad]): Tweak method name for new API.
        (-[WebNetscapePluginStream receivedData:withHandle:]):
        (-[WebNetscapePluginStream handle:willSendRequest:]): New method. Replaces old redirect callback.
        (-[WebNetscapePluginStream handle:didReceiveResponse:]): New method. Set the response ivar.
        * WebCoreSupport.subproj/WebSubresourceClient.h: Add response ivar.
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient dealloc]): Release response ivar.
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]): Set the request user agent here.
        (-[WebSubresourceClient handle:willSendRequest:]): New method. Handle like a redirect.
        (-[WebSubresourceClient handle:didReceiveResponse:]): New method. Set the response ivar.
        (-[WebSubresourceClient handle:didReceiveData:]): Tweaks for new WebFoundation API and method names.
        (-[WebSubresourceClient handleDidFinishLoading:]): Ditto.
        (-[WebSubresourceClient handle:didFailLoadingWithError:]): Ditto.
        * WebView.subproj/WebControllerPrivate.m: 
        (-[WebController _receivedError:forResourceHandle:partialProgress:fromDataSource:]): Ditto.
        * WebView.subproj/WebDataSourcePrivate.h: Add _setRequest method.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading]): Call didStartLoadingWithURL with request URL instead of handle URL.
        (-[WebDataSource _setRequest:]): Add implementation.
        * WebView.subproj/WebLoadProgress.m:
        (-[WebLoadProgress initWithResourceHandle:]): Tweaks for new WebFoundation API and method names.
        * WebView.subproj/WebMainResourceClient.h: Add response ivar.
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient initWithDataSource:]): Set user agent on request here.
        (-[WebMainResourceClient dealloc]): Release response ivar.
        (-[WebMainResourceClient didCancelWithHandle:]): Tweaks for new WebFoundation API and method names.
        (-[WebMainResourceClient handleDidFinishLoading:]): Tweaks for new WebFoundation API and method names.
        (-[WebMainResourceClient handle:willSendRequest:]): New method. Handle like a redirect.
        (-[WebMainResourceClient handle:didReceiveResponse:]): New method. Set the response ivar.
        (-[WebMainResourceClient handle:didReceiveData:]): Tweaks for new WebFoundation API and method names.
        (-[WebMainResourceClient handle:didFailLoadingWithError:]): Ditto.


2002-09-30  Chris Blumenberg  <cblu@apple.com>

	A ton o' plugin view clean-up and arch changes. Turned WebPluginView into WebBaseNetscapePluginView. New classes WebNetscapePluginEmbeddedView and WebNetscapePluginDocumentView are subclasses of WebBaseNetscapePluginView. WebNetscapePluginDocumentView ha
ndles non-HTML plug-in content and WebNetscapePluginEmbeddedView is the WebHTMLView subview.

	Found that we leak the world on complex pages with plug-ins such as macromedia.com and marvel.com when closing the window. Still need to figure this out.

        * Plugins.subproj/WebBaseNetscapePluginView.h: Added.
        * Plugins.subproj/WebBaseNetscapePluginView.m: Added.
        (+[WebBaseNetscapePluginView getCarbonEvent:]):
        (-[WebBaseNetscapePluginView getCarbonEvent:]):
        (-[WebBaseNetscapePluginView modifiersForEvent:]):
        (-[WebBaseNetscapePluginView getCarbonEvent:withEvent:]):
        (-[WebBaseNetscapePluginView keyMessageForEvent:]):
        (-[WebBaseNetscapePluginView sendEvent:]):
        (-[WebBaseNetscapePluginView sendActivateEvent:]):
        (-[WebBaseNetscapePluginView sendUpdateEvent]):
        (-[WebBaseNetscapePluginView acceptsFirstResponder]):
        (-[WebBaseNetscapePluginView becomeFirstResponder]):
        (-[WebBaseNetscapePluginView resignFirstResponder]):
        (-[WebBaseNetscapePluginView mouseDown:]):
        (-[WebBaseNetscapePluginView mouseUp:]):
        (-[WebBaseNetscapePluginView mouseEntered:]):
        (-[WebBaseNetscapePluginView mouseExited:]):
        (-[WebBaseNetscapePluginView keyUp:]):
        (-[WebBaseNetscapePluginView keyDown:]):
        (-[WebBaseNetscapePluginView isInResponderChain]):
        (-[WebBaseNetscapePluginView performKeyEquivalent:]):
        (-[WebBaseNetscapePluginView menuForEvent:]):
        (-[WebBaseNetscapePluginView setUpWindowAndPort]):
        (-[WebBaseNetscapePluginView setWindow]):
        (-[WebBaseNetscapePluginView removeTrackingRect]):
        (-[WebBaseNetscapePluginView resetTrackingRect]):
        (-[WebBaseNetscapePluginView start]):
        (-[WebBaseNetscapePluginView stop]):
        (-[WebBaseNetscapePluginView dataSource]):
        (-[WebBaseNetscapePluginView webFrame]):
        (-[WebBaseNetscapePluginView controller]):
        (-[WebBaseNetscapePluginView plugin]):
        (-[WebBaseNetscapePluginView setMIMEType:]):
        (-[WebBaseNetscapePluginView setBaseURL:]):
        (-[WebBaseNetscapePluginView setArguments:]):
        (-[WebBaseNetscapePluginView setMode:]):
        (-[WebBaseNetscapePluginView initWithFrame:]):
        (-[WebBaseNetscapePluginView dealloc]):
        (-[WebBaseNetscapePluginView drawRect:]):
        (-[WebBaseNetscapePluginView isFlipped]):
        (-[WebBaseNetscapePluginView viewWillMoveToWindow:]):
        (-[WebBaseNetscapePluginView viewDidMoveToWindow]):
        (-[WebBaseNetscapePluginView viewHasMoved:]):
        (-[WebBaseNetscapePluginView windowWillClose:]):
        (-[WebBaseNetscapePluginView windowBecameKey:]):
        (-[WebBaseNetscapePluginView windowResignedKey:]):
        (-[WebBaseNetscapePluginView defaultsHaveChanged:]):
        (-[WebBaseNetscapePluginView frameStateChanged:]):
        (-[WebBaseNetscapePluginView pluginInstance]):
        (-[WebBaseNetscapePluginView pluginURLFromCString:]):
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        (-[WebBaseNetscapePluginView getURLNotify:target:notifyData:]):
        (-[WebBaseNetscapePluginView getURL:target:]):
        (-[WebBaseNetscapePluginView postURLNotify:target:len:buf:file:notifyData:]):
        (-[WebBaseNetscapePluginView postURL:target:len:buf:file:]):
        (-[WebBaseNetscapePluginView newStream:target:stream:]):
        (-[WebBaseNetscapePluginView write:len:buffer:]):
        (-[WebBaseNetscapePluginView destroyStream:reason:]):
        (-[WebBaseNetscapePluginView status:]):
        (-[WebBaseNetscapePluginView invalidateRect:]):
        (-[WebBaseNetscapePluginView invalidateRegion:]):
        (-[WebBaseNetscapePluginView forceRedraw]):
        * Plugins.subproj/WebBaseNetscapePluginViewPrivate.h: Added.
        * Plugins.subproj/WebNetscapePluginDocumentView.h: Added.
        * Plugins.subproj/WebNetscapePluginDocumentView.m: Added.
        (-[WebNetscapePluginDocumentView initWithFrame:]):
        (-[WebNetscapePluginDocumentView dealloc]):
        (-[WebNetscapePluginDocumentView drawRect:]):
        (-[WebNetscapePluginDocumentView dataSource]):
        (-[WebNetscapePluginDocumentView setDataSource:]):
        (-[WebNetscapePluginDocumentView dataSourceUpdated:]):
        (-[WebNetscapePluginDocumentView setNeedsLayout:]):
        (-[WebNetscapePluginDocumentView layout]):
        * Plugins.subproj/WebNetscapePluginEmbeddedView.h: Added.
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m: Added.
        (-[WebNetscapePluginEmbeddedView initWithFrame:plugin:URL:baseURL:mime:arguments:]):
        (-[WebNetscapePluginEmbeddedView dealloc]):
        (-[WebNetscapePluginEmbeddedView viewDidMoveToWindow]):
        (-[WebNetscapePluginEmbeddedView start]):
        (-[WebNetscapePluginEmbeddedView dataSource]):
        * Plugins.subproj/WebNetscapePluginViewPrivate.h: Removed.
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebNetscapePluginDatabase init]):
        * Plugins.subproj/WebPluginNullEventSender.h:
        * Plugins.subproj/WebPluginNullEventSender.m:
        (-[WebNetscapePluginNullEventSender initWithPluginView:]):
        (-[WebNetscapePluginNullEventSender sendNullEvents]):
        * Plugins.subproj/WebPluginStream.h:
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream getFunctionPointersFromPluginView:]):
        (-[WebNetscapePluginStream initWithURL:pluginPointer:notifyData:]):
        (-[WebNetscapePluginStream dealloc]):
        (-[WebNetscapePluginStream startLoad]):
        (-[WebNetscapePluginStream receivedData:withDataSource:]):
        (-[WebNetscapePluginStream handleWillUseUserAgent:forURL:]):
        (-[WebNetscapePluginStream handle:didReceiveData:]):
        (-[WebNetscapePluginStream handleDidFinishLoading:]):
        (-[WebNetscapePluginStream cancel]):
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:]):
        (-[WebNetscapePluginStream handleDidRedirect:toURL:]):
        * Plugins.subproj/WebPluginView.h: Removed.
        * Plugins.subproj/WebPluginView.m: Removed.
        * Plugins.subproj/npapi.m:
        (NPN_GetURLNotify):
        (NPN_GetURL):
        (NPN_PostURLNotify):
        (NPN_PostURL):
        (NPN_NewStream):
        (NPN_Write):
        (NPN_DestroyStream):
        (NPN_Status):
        (NPN_InvalidateRect):
        (NPN_InvalidateRegion):
        (NPN_ForceRedraw):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory viewForPluginWithURL:serviceType:arguments:baseURL:]):
        (-[WebViewFactory viewForJavaAppletWithFrame:baseURL:parameters:]):
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[NSView _web_stopIfPluginView]):

2002-09-30  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebDataSource.m: (-[WebDataSource initWithRequest:]):
	Remove the ill-advised "don't even create a WebDataSource if WebResourceHandle
	can't handle this request" code.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _startLoading]):
	Rearrange checks so we won't get confused if we can't create a handle.

2002-09-30  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Added.

2002-09-30  Darin Adler  <darin@apple.com>

	- fixed crashing part of 3063517 -- crash loading .png in separate window

        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView start]): Don't try to start if the NPP_New is 0.
	This indicates the the plugin hasn't been loaded.

2002-09-30  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _setLoading:]):
	Remove extra quotes in use of ASSERT_ARG.

2002-09-29  Darin Adler  <darin@apple.com>

        * Misc.subproj/WebIconDatabase.m: (-[WebIconDatabase _iconForFileURL:withSize:]):
	Don't be case sensitive about filename extensions.

        * Misc.subproj/WebDownloadHandler.m:
        * Misc.subproj/WebIconLoader.m:
        * Plugins.subproj/WebPluginStream.m:
        * WebView.subproj/WebDataSource.m:
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        * WebView.subproj/WebFrame.m:
        * WebView.subproj/WebFramePrivate.m:
        * WebView.subproj/WebView.m:
	Don't use WebFoundation.h -- faster building to just import what we really use.

2002-09-29  Chris Blumenberg  <cblu@apple.com>

	Fixed: 2978258 - quake3arena.com sends me to the flash=false site
	The page has a flash plugin that once loaded, requests the flash=true page. If the plugin doesn't load, the meta refresh tag to the flash=false page fires after 3 seconds. This is how this site's flash detection works.

	The reason this doesn't work for us is because the flash movie is at the bottom of the page. Plugins don't start until the initial drawRect. Since the movie is at the bottom of the page and out of site, the plugin never gets the drawRect and thus, never 
starts. We now start plug-ins when they are added to the window.

	Fixed: 3062224 - context menu includes "Download Item to Disk" for mailto links

	- Fixed click then click and drag causes crash.

        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView drawRect:]): don't start plug-in here
        (-[WebNetscapePluginView viewDidMoveToWindow]): start it here
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate contextMenuItemsForElement:defaultMenuItems:]): don't provide "Download Link To Disk" and "Open Link In New Window" items for URLs we cant handle.
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]): clean-up
        (-[WebHTMLView mouseDragged:]): Don't allow drag if the frame has a provisional data source because this view may be released and the drag callbacks might reference this released view.

2002-09-28  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebDataSource.m: (-[WebDataSource initWithRequest:]):
	Catch a request that we can't use here instead of failing later.

        * WebView.subproj/WebDataSourcePrivate.m: (-[WebDataSource _startLoading]):
	Added an assert so the failure was less confusing; good idea to leave it in.

2002-09-28  Chris Blumenberg  <cblu@apple.com>

	Support for latest Flash plug-in. It requests a javascript URL for every plug-in instance.
	Until javascript URLs work, we return an error to the plug-in. 

	Fixed: 3035582 - flash animations don't work after upgrading flash
	Fixed: 3021936 - links in flash at foggypetronasracing.com doesn't work

        * Plugins.subproj/WebPluginStream.h:
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream initWithURL:pluginPointer:notifyData:]):
	Make the request here and return nil if we can't create a handle with it.
        (-[WebNetscapePluginStream dealloc]): release the request
        (-[WebNetscapePluginStream startLoad]): use the request when creating the handle

2002-09-28  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebBridge.m: (-[WebBridge setNeedsLayout]): Added.

2002-09-27  Chris Blumenberg  <cblu@apple.com>

	Fixed KJS crasher caused by nil plug-in returned from WebPlugin.
	Got the RealPlayer plug-in loaded, nothing playing yet.

        * Plugins.subproj/WebPlugin.m:
        (-[WebNetscapePlugin getPluginInfo]): check for nil plug-in names/descriptions
        (-[WebNetscapePlugin stringByResolvingSymlinksAndAliasesInPath:]): new, resolves old-style aliases
        (-[WebNetscapePlugin initWithPath:]): call stringByResolvingSymlinksAndAliasesInPath

2002-09-27  Richard Williamson   <rjw@apple.com>

        Fix 3058315:  crash in WebHTMLRepresentation receivedData:withDataSource
        http://www.u2.com/lite/ does some whacky things with its framset's onLoad
        handler.  The fix ensures that data isn't sent to the bridge once
        the bridge has been dealloced.
        
        * WebKit.pbproj/project.pbxproj: Nothing changed.  PB dorkiness.
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation receivedData:withDataSource:]):

2002-09-27  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3056559 - QT plugin doesn't load
	Fixed: 3042850 - Enable Java by default

	Cleaned up WebPlugin and WebPluginDatabase.

        * Plugins.subproj/WebPlugin.h:
        * Plugins.subproj/WebPlugin.m:
        (-[WebNetscapePlugin openResourceFile]):
        (-[WebNetscapePlugin closeResourceFile:]):
        (-[WebNetscapePlugin stringForStringListID:andIndex:]):
        (-[WebNetscapePlugin getPluginInfo]):
        (-[WebNetscapePlugin initWithPath:]):
        (-[WebNetscapePlugin load]):
        (-[WebNetscapePlugin unload]):
        (-[WebNetscapePlugin MIMEToExtensionsDictionary]):
        (-[WebNetscapePlugin extensionToMIMEDictionary]):
        (-[WebNetscapePlugin MIMEToDescriptionDictionary]):
        (-[WebNetscapePlugin description]):
        * Plugins.subproj/WebPluginDatabase.h:
        * Plugins.subproj/WebPluginDatabase.m:
        (-[WebNetscapePluginDatabase pluginForMIMEType:]):
        (-[WebNetscapePluginDatabase pluginForExtension:]):
        (-[WebNetscapePluginDatabase pluginForFilename:]):
        (-[WebNetscapePluginDatabase MIMETypes]):
        (-[WebNetscapePluginDatabase init]):
        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView setDataSource:]):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory viewForPluginWithURL:serviceType:arguments:baseURL:]):
        (-[WebViewFactory viewForJavaAppletWithFrame:baseURL:parameters:]):
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences load]): Enable Java by default

2002-09-27  Richard Williamson   <rjw@apple.com>

        Fixed 3060158:  REGRESSION: iframes added to session history
        Also moved setting title in history to WebKit.
        
        * History.subproj/WebHistory.h:
        * History.subproj/WebHistory.m:
        (+[WebHistory sharedHistory]):
        (+[WebHistory webHistoryWithFile:]):
        (-[WebHistory addEntryForURL:]):
        (-[WebHistory addEntries:]):
        * History.subproj/WebHistoryPrivate.h:
        * History.subproj/WebHistoryPrivate.m:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge requestedURL]):
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _setTitle:]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]):

2002-09-26  Richard Williamson   <rjw@apple.com>

        More twiddling.  Changed the color of the drag labels to
        match the favorites bar.
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]):

2002-09-27  Chris Blumenberg  <cblu@apple.com>

	Added support for dragging links the the dock.
	Created new pasteboard types WebURLPboardType WebURLNamePboardType that the dock requires.

        * Misc.subproj/WebNSPasteboardExtras.h:
        * Misc.subproj/WebNSPasteboardExtras.m:
        (+[NSPasteboard initialize]): set WebURLPboardType and WebURLNamePboardType
        (-[NSPasteboard _web_writeURL:andTitle:withOwner:]): use WebURLPboardType and WebURLNamePboardType
        * WebKit.exp: export WebURLPboardType and WebURLNamePboardType

2002-09-27  Maciej Stachowiak  <mjs@apple.com>

        * Panels.subproj/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel setUpForRequest:]):
        (-[WebAuthenticationPanel runAsModalDialogWithRequest:]):
        (-[WebAuthenticationPanel sheetDidEnd:returnCode:contextInfo:]):
        * Panels.subproj/WebPanelAuthenticationHandler.h:
        * Panels.subproj/WebPanelAuthenticationHandler.m:
        (-[WebPanelAuthenticationHandler isReadyToStartAuthentication:]):
        (-[WebPanelAuthenticationHandler startAuthentication:]):
        (-[WebPanelAuthenticationHandler _authenticationDoneWithRequest:result:]):

2002-09-26  Darin Adler  <darin@apple.com>

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge receivedData:withDataSource:]): Use NSString for encoding.
        * WebView.subproj/WebController.h: Update names to use separate boolean
	for user agent and strings for text encodings instead of CFStringEncoding.
        * WebView.subproj/WebController.m:
        (-[WebController setCustomUserAgent:]): Name change.
        (-[WebController resetUserAgent]): Added.
        (-[WebController hasCustomUserAgent]): Added.
        (-[WebController customUserAgent]): Name change.
        (-[WebController setCustomTextEncodingName:]): Take NSString.
        (-[WebController resetTextEncoding]): Update for NSString.
        (-[WebController _mainFrameOverrideEncoding]): Ditto.
        (-[WebController hasCustomTextEncoding]): Ditto.
        (-[WebController customTextEncodingName]): Return NSString.

        * WebView.subproj/WebDataSourcePrivate.h: Use NSString instead of
	CFStringEncoding.
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSourcePrivate init]): No need to init.
        (-[WebDataSource _setContentType:]): Copy, don't retain.
        (-[WebDataSource _setEncoding:]): Copy, don't retain.
        (-[WebDataSource _setOverrideEncoding:]): Use NSString.
        (-[WebDataSource _overrideEncoding]): Use NSString.

        * WebView.subproj/WebFramePrivate.h: Use NSString.
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _reloadAllowingStaleDataWithOverrideEncoding:]): Use NSString.

        * WebView.subproj/WebPreferences.h: Use NSString instead of
	CFStringEncoding.
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences load]): Use NSString.
        (-[WebPreferences defaultTextEncodingName]): Use NSString.
        (-[WebPreferences setDefaultTextEncodingName:]): Use NSString.

2002-09-26  Chris Blumenberg  <cblu@apple.com>

	Made WebTextView super-private.

        * WebKit.pbproj/project.pbxproj:

2002-09-26  Richard Williamson   <rjw@apple.com>

        Use a rectangle with rounded corners for dragged label.
        Put a subtle shadow behind text in label.
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]):

2002-09-26  Chris Blumenberg  <cblu@apple.com>

	- When dragging an image, use the image itself for the drag image
	- Support promised file and image data drag types for dragged images.

        * Misc.subproj/WebNSImageExtras.h: Added.
        * Misc.subproj/WebNSImageExtras.m: Added.
        (-[NSImage _web_scaleToMaxSize:]): new, scales an image is greater than max
        (-[NSImage _web_dissolveToFraction:]): new, dissolves image in place
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.h: Added WebElementImageLocationKey to the element dictionary
        * WebView.subproj/WebController.m: ditto
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]): subclassed for only for image drags
        (-[WebHTMLView mouseDragged:]): use the promised file api again.
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]): use the retained element dictionary instead of the dragged URL which I deleted.
        * WebView.subproj/WebHTMLViewPrivate.h:

=== Alexander-25 ===

2002-09-25  Richard Williamson   <rjw@apple.com>

        API tweaks.
        * Misc.subproj/WebKit.h:
        Added headers.
        
        * Misc.subproj/WebKitErrors.h:
        Removed #defines.
        
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading]):
        (-[WebDataSource _loadIcon]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate contextMenuItemsForElement:defaultMenuItems:]):
        Removed isMainDocument.
        
        Moved errors string #defines here.
        * WebView.subproj/WebView.m:

2002-09-25  John Sullivan  <sullivan@apple.com>

	- fixed 3060773 -- Wrong title proposed when image link 
	dropped on favorites bar

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]): Claim the pasteboard (via
	declareTypes:) before putting data on it.

2002-09-25  Richard Williamson   <rjw@apple.com>

        API and documentation tweaks.
        
        WebDocumentDragSettings:  canDrag -> acceptsDrag
        WebDataSource:  removed originalURL
        WebStandardPanels:  use -> uses
        
        * History.subproj/WebBackForwardList.h:
        * Misc.subproj/WebDownloadHandler.m:
        (-[WebDownloadHandler initWithDataSource:]):
        * Panels.subproj/WebStandardPanels.h:
        * Panels.subproj/WebStandardPanels.m:
        (-[WebStandardPanels setUsesStandardAuthenticationPanel:]):
        (-[WebStandardPanels usesStandardAuthenticationPanel]):
        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView frameStateChanged:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient cancel]):
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _commitIfReady]):
        * WebView.subproj/WebDocument.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame setProvisionalDataSource:]):
        (-[WebFrame startLoading]):
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _transitionToCommitted]):
        (-[WebFrame _setState:]):
        (-[WebFrame _goToItem:withFrameLoadType:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView setAcceptsDrags:]):
        (-[WebHTMLView acceptsDrags]):
        (-[WebHTMLView setAcceptsDrops:]):
        (-[WebHTMLView acceptsDrops]):
        * WebView.subproj/WebImageView.m:
        (-[WebImageView setAcceptsDrags:]):
        (-[WebImageView acceptsDrags]):
        (-[WebImageView setAcceptsDrops:]):
        (-[WebImageView acceptsDrops]):
        * WebView.subproj/WebLoadProgress.h:
        * WebView.subproj/WebLocationChangeDelegate.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient didCancelWithHandle:]):
        * WebView.subproj/WebView.h:

2002-09-25  Ken Kocienda  <kocienda@apple.com>

        Changes to move the WebResourceHandle API closer to the
        specified design. This includes:

        - Removed loadInBackground method from the public interface.
        - Start asynchronous loading in WebResourceHandle init method. This required some
	  code reorganization in callers.
        - Remove loadInForeground: from WebResourceHandle interface.
        - Move WebResourceHandle callback deferral methods to SPI header file.
        - Change name of WebResourceHandle cancelLoadInBackground method to cancel.

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader startLoading])
        (-[WebIconLoader stopLoading])
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream startLoad])
        (-[WebNetscapePluginStream cancel])
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:])
        (-[WebSubresourceClient cancel])
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading])
        (-[WebDataSource _addSubresourceClient:])
        (-[WebDataSource _stopLoading])
        (-[WebDataSource _defersCallbacksChanged])
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveData:])

2002-09-25  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3050665 - REGRESSION: mp3 audio loads and plays, but no progress or play control is visible

        * Plugins.subproj/WebPluginView.h:
        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView setNeedsLayout:]):
        (-[WebNetscapePluginView layout]):
        (-[WebNetscapePluginView drawRect:]):

2002-09-25  Darin Adler  <darin@apple.com>

	Make the "set aside subviews" logic stronger so it can handle a display
	while inside drawRect. But note, this recursive display is most likely
	the cause of the redrawing problems we have while resizing, like bug 2969367.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView drawRect:]): Restore views and then set them aside again, but don't
	leave the "views set aside" boolean set.
        * WebView.subproj/WebHTMLViewPrivate.h: Add private _setAsideSubviews and _restoreSubviews methods.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _setAsideSubviews]): Added.
        (-[WebHTMLView _restoreSubviews]): Added.
        (-[WebHTMLView _recursiveDisplayRectIfNeededIgnoringOpacity:isVisibleRect:rectIsVisibleRectForView:topView:]):
	Use the new _setAsideSubviews and _restoreSubviews methods.
        (-[WebHTMLView _recursiveDisplayAllDirtyWithLockFocus:visRect:]): Ditto.

2002-09-25  Ken Kocienda  <kocienda@apple.com>

        Removed this method from WebResourceHandle:

        +(BOOL)canInitWithURL:(NSURL *)theURL;

        replaced with:

        +(BOOL)canInitWithRequest:(WebResourceRequest *)request;

	Callers have been updated to reflect the change.

        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (+[WebDefaultPolicyDelegate defaultURLPolicyForURL:])
        * WebView.subproj/WebFramePrivate.m:
        (-[WebFrame _shouldShowURL:])

2002-09-25  Ken Kocienda  <kocienda@apple.com>

        More moves to the new WebResourceHandleDelegate API.   

        This change moves all WebResourceHandleDelegate implementors to:

        -(void)handle:(WebResourceHandle *)handle didReceiveData:(NSData *)data;

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader handle:didReceiveData:])
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream handle:didReceiveData:])
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:didReceiveData:])
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didReceiveData:])

2002-09-25  Ken Kocienda  <kocienda@apple.com>

        Moving to the new WebResourceHandleDelegate API.

        This change moves all WebResourceHandleDelegate implementors to:

        - (void)handle:(WebResourceHandle *)handle didFailLoadingWithError:(WebError *)result;

        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader handle:didFailLoadingWithError:])
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream handle:didFailLoadingWithError:])
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient handle:didFailLoadingWithError:])
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handle:didFailLoadingWithError:])

2002-09-25  Ken Kocienda  <kocienda@apple.com>

        Begin change from WebResourceClient to WebResourceHandleDelegate.
        In this step, I have just changed the name of the protocol; the
        protocol interface is the same. 

	I made other cosmetic changes to variable names and such.

        * Misc.subproj/WebIconLoader.h:
        * Misc.subproj/WebIconLoader.m:
        (-[WebIconLoader startLoading])
        * Plugins.subproj/WebPluginStream.m:
        (-[WebNetscapePluginStream startLoad])
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCache:size:])
        * WebCoreSupport.subproj/WebSubresourceClient.h:
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:])
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading])
        * WebView.subproj/WebMainResourceClient.h:

2002-09-25  Maciej Stachowiak  <mjs@apple.com>

	- fixed 2854536 - New cookie policy: "accept cookies only from the
	same domain as the main page"
	
        * WebCoreSupport.subproj/WebCookieAdapter.h:
        * WebCoreSupport.subproj/WebCookieAdapter.m:
        (-[WebCookieAdapter setCookies:forURL:policyBaseURL:]):
        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (+[WebSubresourceClient startLoadingResource:withURL:referrer:forDataSource:]):
        (-[WebSubresourceClient handleDidRedirect:toURL:]):
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource _startLoading]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient handleDidRedirect:toURL:]):

2002-09-24  Richard Williamson   <rjw@apple.com>

        More documentation tweaks.
        
        * History.subproj/WebHistory.h:
        * History.subproj/WebHistoryItem.h:
        * WebView.subproj/WebContextMenuDelegate.h:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebLocationChangeDelegate.h:
        * WebView.subproj/WebResourceProgressDelegate.h:

2002-09-24  Darin Adler  <darin@apple.com>

	- fixed 3059513 -- REGRESSION: Scrolling to fragment doesn't work

	Turns out it was better to just put the extra smarts into the clip view
	that we are already creating. Making WebHTMLView be a second clip view
	was silly and broke things.

        * WebView.subproj/WebView.m: (-[WebView initWithFrame:]): Create a WebClipView
	and use it as the content view rather than the NSClipView created by default.

        * WebKit.pbproj/project.pbxproj: Added WebClipView.
        * WebView.subproj/WebClipView.h: Added.
        * WebView.subproj/WebClipView.m: Added.

        * WebView.subproj/WebHTMLView.h: Don't be a subclass of NSClipView any more.
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView drawRect:]): Call setAdditionalClip and resetAdditionalClip on
	the clip view.

        * WebView.subproj/WebHTMLViewPrivate.h: Remove inDrawRect and drawRect.
        * WebView.subproj/WebHTMLViewPrivate.m: Remove visibleRect override. This is
	now in WebClipView.

2002-09-24  Chris Blumenberg  <cblu@apple.com>

	More documentation changes.

        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultContextMenuDelegate.h:
        * WebView.subproj/WebDocument.h:

2002-09-24  Richard Williamson   <rjw@apple.com>

        Added FIXME note about unresolved issue with CFStringEncoding/NSStringEncoding.
        
        * WebView.subproj/WebController.h:

2002-09-24  Richard Williamson   <rjw@apple.com>

        Documentation for WebDataSource and WebFrame.
        
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource frameExists:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        (-[WebDataSource addFrame:]):
        * WebView.subproj/WebFrame.h:

2002-09-24  Darin Adler  <darin@apple.com>

	- fixed 3059266 -- REGRESSION: clicking in web view when location field is
	focused does not focus web view

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView needsPanelToBecomeKey]):
	Must override this to return YES, because NSClipView makes it return NO
	even though we accept the first responder.

2002-09-24  John Sullivan  <sullivan@apple.com>

	- fixed 3056158 -- REGRESSION: Page up/down should scroll one 
	whole contentView minus at least one readable line of text

	This was broken a while back when the keyboard scrolling code
	migrated into WebKit.

        * WebView.subproj/WebViewPrivate.m:
        (-[WebView _verticalKeyboardScrollAmount]),
        (-[WebView _horizontalKeyboardScrollAmount]):
	New private methods, return one arrow key's worth of scrolling.
        (-[WebView _scrollLineVertically:]),
        (-[WebView _scrollLineHorizontally:]):
	Now use the broken-out methods.
        (-[WebView _pageVertically:]),
        (-[WebView _pageHorizontally:]):
	overlap by one arrow key's worth of scrolling instead of the
	teensy-weensy one click's worth.

2002-09-24  Chris Blumenberg  <cblu@apple.com>

	Documentation for WebHTMLView

        * WebView.subproj/WebHTMLView.h:

2002-09-24  Richard Williamson   <rjw@apple.com>

        Documentation changes.  Removal of imports from
        some headers required modification of .m.
        
        * Plugins.subproj/WebNullPluginView.m:
        * WebCoreSupport.subproj/WebBridge.m:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        * WebView.subproj/WebDataSource.h:
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDataSourcePrivate.m:
        * WebView.subproj/WebDefaultPolicyDelegate.h:
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (+[WebDefaultPolicyDelegate defaultURLPolicyForURL:]):
        (-[WebDefaultPolicyDelegate URLPolicyForURL:inFrame:]):
        * WebView.subproj/WebFramePrivate.m:
        * WebView.subproj/WebHTMLViewPrivate.m:

2002-09-24  Chris Blumenberg  <cblu@apple.com>

	Renamed element info keys to WebElement* instead of WebContextMenuElement*
	Added WebKit API documentation

        * Plugins.subproj/WebPlugin.m:	
        (-[WebNetscapePlugin load]): clean-up
        * WebKit.exp:
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebContextMenuDelegate.h:
        * WebView.subproj/WebController.h:
        * WebView.subproj/WebController.m:
        * WebView.subproj/WebControllerPolicyDelegate.h:
        * WebView.subproj/WebDefaultContextMenuDelegate.h:
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate contextMenuItemsForElement:defaultMenuItems:]):
        (-[WebDefaultContextMenuDelegate openNewWindowWithURL:referrer:]):
        (-[WebDefaultContextMenuDelegate downloadURL:]):
        (-[WebDefaultContextMenuDelegate openLinkInNewWindow:]):
        (-[WebDefaultContextMenuDelegate downloadLinkToDisk:]):
        (-[WebDefaultContextMenuDelegate copyLinkToClipboard:]):
        (-[WebDefaultContextMenuDelegate openImageInNewWindow:]):
        (-[WebDefaultContextMenuDelegate downloadImageToDisk:]):
        (-[WebDefaultContextMenuDelegate copyImageToClipboard:]):
        (-[WebDefaultContextMenuDelegate openFrameInNewWindow:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]):
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView _elementAtPoint:]):

2002-09-24  Darin Adler  <darin@apple.com>

	Cleaned up some loose ends from adding setNeedsLayout to the WebDocumentView
	protocol. Was causing exceptions.

        * Plugins.subproj/WebPluginView.m: (-[WebNetscapePluginView setNeedsLayout:]):
        * WebView.subproj/WebTextView.m: (-[WebTextView setNeedsLayout:]):
	Added missing stubs.

        * WebCoreSupport.subproj/WebBridge.m: (-[WebBridge setNeedsReapplyStyles]):
	Removed unneeded cast.
        * WebView.subproj/WebFramePrivate.m: (-[WebFrame _isLoadComplete]): Remove an
	unneeded cast and call to isDocumentHTML.
        * WebView.subproj/WebHTMLView.h: No need to re-declare setNeedsLayout.
        * WebView.subproj/WebView.m: (-[WebView setFrame:]): Get rid of unneeded check
	of isDocumentHTML.

2002-09-24  Darin Adler  <darin@apple.com>

	- fixed 3057383 -- focus rectangles are being drawn multiple times
	- fixed 3051025 -- focus ring on password field gets darker and darker

	To make focus rings clip too, we have to do more than just set the clip.
	We also have to set the visible rectangle to make clipping happen, and we
	need to be a subclass of NSClipView so that the focus ring drawing code will
	consult us rather than one of our superviews.

        * WebView.subproj/WebHTMLView.h: Be a subclass of NSClipView.
        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView drawRect:]): Set a inDrawRect
	flag, and a drawRect rectangle. This tells us to clip to this rectangle.
	what we need to clip to.
        * WebView.subproj/WebHTMLViewPrivate.h: Added inDrawRect and drawRect.
        * WebView.subproj/WebHTMLViewPrivate.m:
        (-[WebHTMLView visibleRect]): Clip the visible rect based on the drawRect while
	inDrawRect is set.

2002-09-23  Chris Blumenberg  <cblu@apple.com>

	Factored URL pasteboard initialization to 1 place.
	Fixed: 3048924 - regression: drag & drop broken for initial empty page
	Fixed: 3045997 - Dragging a link from one Alex window to another one doesn't work

        * Misc.subproj/WebNSPasteboardExtras.h:
        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeURL:andTitle:withOwner:]): new
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultContextMenuDelegate copyLinkToClipboard:]): call -[NSPasteboard _web_writeURL:andTitle:withOwner:]
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView mouseDragged:]): call -[NSPasteboard _web_writeURL:andTitle:withOwner:]
        * WebView.subproj/WebView.m:
        (-[WebView draggingEntered:]): handle nil cases

2002-09-23  Maciej Stachowiak  <mjs@apple.com>

	Added documentation for these two delegate protocols.
	
        * WebView.subproj/WebLocationChangeDelegate.h:
        * WebView.subproj/WebResourceProgressDelegate.h:

2002-09-23  Richard Williamson   <rjw@apple.com>

        Made WebIconLoader and WebIconDatabase SPI.
        
        * WebKit.pbproj/project.pbxproj:

2002-09-23  Richard Williamson   <rjw@apple.com>

        WebContextMenuHandler becomes WebContextMenuDelegate
        WebControllerPolicyHandler becomes WebControllerPolicyDelegate
        WebLocationChangeHandler becomes WebLocationChangeDelegate
        WebResourceProgressHandler becomes WebResourceProgressDelegate
        WebWindowContext becomes WebWindowOperationsDelegate

        * Misc.subproj/WebDownloadHandler.m:
        * Plugins.subproj/WebNullPluginView.m:
        (-[WebNullPluginView drawRect:]):
        * Plugins.subproj/WebPluginView.m:
        (-[WebNetscapePluginView loadRequest:inTarget:withNotifyData:]):
        (-[WebNetscapePluginView status:]):
        * WebCoreSupport.subproj/WebBridge.m:
